Wed Dec 16 21:16:55 2015  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/fiddle/handle.c: check tainted string arguments.
	  Patch provided by tenderlove and nobu.

	* test/fiddle/test_handle.rb (class TestHandle): add test for above.

Wed Dec 16 21:16:55 2015  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/dl/handle.c (rb_dlhandle_initialize): prohibits DL::dlopen
	  with a tainted name of library.
	  Patch by sheepman <sheepman AT sheepman.sakura.ne.jp>.

	* ext/dl/handle.c (rb_dlhandle_sym): ditto

Tue Aug 18 22:00:12 2015  SHIBATA Hiroshi  <hsbt@ruby-lang.org>

	* lib/rubygems.rb: bump version to 2.0.14.1. this version fixed
	  CVE-2015-3900.

	* lib/rubygems/remote_fetcher.rb: ditto.

	* test/rubygems/test_gem_remote_fetcher.rb: added testcase for CVE-2015-3900

Tue Jun  2 00:10:14 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/resolv.rb (Requester#request): typo, regression introduced at
	  r49422 (patchlevel 618).  reported and patched by Stefan Kolb
	  [ruby-core:69429] [Backport #11204]

Mon Apr 13 22:11:42 2015  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/openssl/lib/openssl/ssl.rb: stricter hostname verification
	  following RFC 6125. with the patch provided by Tony Arcieri and
	  Hiroshi Nakamura [ruby-core:61545] [Bug #9644]
	* test/openssl/test_ssl.rb: add tests for above.

Tue Mar 24 16:38:14 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* spec/default.mspec: use default configuration file name.
	  https://github.com/ruby/rubyspec/commit/cc69f337b06362e5607ffa3e3ad40ef7494960cf

Tue Mar 24 16:38:14 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* spec/default.mspec: remove specific version number.
	  https://github.com/ruby/rubyspec/commit/7a909e925c1baa9c700bd44af9241aef6e596714

Tue Mar 24 16:38:14 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* common.mk: use ruby organization for rubyspec.

Wed Feb 25 17:30:10 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* class.c (clone_method): fixed missing assignment introduced by
	  previous commit.

	* vm_insnhelper.c (rb_vm_rewrite_cref_stack): ditto.

Wed Feb 25 15:07:01 2015  Kazuki Tsujimoto  <kazuki@callcc.net>

	* vm_insnhelper.c (rb_vm_rewrite_cref_stack): copy nd_refinements
	  of original crefs. It fixes segmentation fault when calling
	  refined method in duplicate module. [ruby-dev:48878] [Bug #10885]

	* vm_core.h, class.c: change accordingly.

	* test/ruby/test_refinement.rb: add a test for above.

Wed Feb 25 14:53:27 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* class.c (method_entry_i, class_instance_method_list,
	  rb_obj_singleton_methods): should not include methods of
	  superclasses if recur is false. [ruby-dev:48854] [Bug #10826]

Wed Feb 25 14:53:27 2015  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_method.c (remove_method): When remove refined
	  method, raise a NameError if the method is not
	  defined in refined class.
	
	  But if the method is defined in refined class,
	  it should keep refined method and remove original
	  method.
	  
	  Patch by Seiei Higa. [ruby-core:67722] [Bug #10765]

Wed Feb 25 14:41:01 2015  Seiei Higa  <hanachin@gmail.com>

	* vm_method.c (check_definition): Module#public_method_defined?,
	  Module#private_method_defined?, Module#protected_method_defined?
	  should not use refinements. [ruby-core:67656] [Bug #10753]

Wed Feb 25 14:29:19 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/sdbm/_sdbm.c: include ruby/ruby.h for PRIdPTRDIFF when a
	  macro `DEBUG` is defined.  based on the patch by Owen Rodley in
	  [ruby-core:67987]. [Bug #10825]

Wed Feb 25 14:22:57 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (try_cppflags, try_cflags, try_ldflags): get rid of
	  interference by modifying global variables in have_devel? method.
	  [ruby-core:67962] [Bug #10821]

Wed Feb 25 14:19:35 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* thread.c: Improve documentation for Thread#value
	  [Bug #10694][ruby-core:67324][ci skip]

Wed Feb 25 14:18:26 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* string.c: [DOC] Add missing documentation around String#chomp.
	  Patchby @stderr [ci skip][fix GH-780]

Sat Feb 21 09:48:48 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic.build):
	  use hostname= to detect and wrap IPv6 hosts.
	  Build is accepting URI components and users may not expect
	  that a host component needs to be wrapped with square brackets
	  since it's not providing a URI.
	  Note: initialize with arg_check => true does not wrap IPv6 hosts.
	  by Joe Rafaniello <jrafanie@redhat.com>
	  https://github.com/ruby/ruby/pull/765 fix GH-765

	* test/uri/test_generic.rb: Add more tests

Wed Feb 18 16:02:30 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/resolv.rb (Resolv::DNS::Resource#==, #hash): elements
	  returned by Kernel#instance_variables are Symbols now.
	  [ruby-core:68128] [Bug #10857]

Tue Feb 17 17:37:14 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/socket/getaddrinfo.c (get_addr): reject too long hostname to
	  get rid of GHOST vulnerability on very old platforms.

	* ext/socket/raddrinfo.c (make_hostent_internal): ditto, paranoic
	  check for the canonical name.

Fri Jan 30 16:49:15 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c: [DOC] Revise documentation by Marcus Stollsteimer at
	  [ruby-core:66368].  [Bug #10526]

	  * #inspect: be more specific about generated string, remove
	    obsolete example.
	  * #nil?: use code examples instead of different call-seq's.
	  * #tap: clarify what is yielded.
	  * Integer(): be more specific about to_int and to_i, remove
	    reference to Ruby 1.8.
	  * Array(): fix error.
	  * Class: fix variable name style and indentation in example.
	  * improve consistency, fix typos and formatting.

Fri Jan 30 16:49:15 2015  Benoit Daloze  <eregontp@gmail.com>

	* object.c (Module#const_defined?): [DOC] Revise the documentation.
	  Patch by Xavier Noria.
	  [Fixes GH-754] https://github.com/ruby/ruby/pull/754

Fri Jan 30 16:49:15 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* object.c: fix document of Kernel.Stirng by @suzukaze
	  [fix GH-743][ci skip]

Fri Jan 30 16:26:57 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* pack.c (str_associate, str_associated): keep associated objects
	  in an instance variables, instead of in the internal structure.

Fri Jan 30 16:11:47 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rdoc/text.rb (expand_tabs): get rid of infinite loop with
	  CR.  should check if substitution occurred too.
	  [ruby-dev:48813] [Bug #10732]

Fri Jan 30 16:00:35 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (install_dirs): revert DESTDIR prefix by r39841, since
	  it is fixed by r41648.  [ruby-core:55760] [Bug #8115]

Fri Jan 30 15:47:49 2015  Eric Wong  <e@80x24.org>

	* numeric.c (bit_coerce): use original value for error message
	  [ruby-core:67405] [Bug #10711]
	* test/ruby/test_numeric.rb (test_coerce): check error message

Tue Jan 27 17:05:43 2015  Seiei Higa  <hanachin@gmail.com>

	* vm_method.c (rb_alias): raise a NameError when creating alias to
	  a refined method if the original method of the refined method is
	  not defined.  [ruby-core:67523] [Bug #10731]

Tue Jan 27 16:41:33 2015  Seiei Higa  <hanachin@gmail.com>

	* vm_method.c (rb_export_method): bail out if the original method
	  is undefined when the method is refined.
	  [ruby-core:67387] [Bug #10706]

Tue Jan 27 16:27:44 2015  Eric Wong  <e@80x24.org>

	* lib/resolv.rb: consider ENETUNREACH as ResolvTimeout
	  [ruby-core:67411] [Bug #10712]

Thu Jan 22 18:15:41 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* ext/zlib/zlib.c: fix document of method signatures.
	  [Bug #10668][ruby-core:67186][ci skip]

Thu Jan 22 18:10:35 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/ruby/test_io.rb: added timeout for AIX environment.
	  [ruby-core:62983][Bug #9917]

Thu Jan 22 17:30:33 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* lib/net/http.rb (Net::HTTP#send_request): there is no response body
	  with HEAD request. Patch by @rodrigosaito [fix GH-520]

Thu Jan 22 17:30:33 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/net/http/test_http.rb (_test_send_request__HEAD): Added
	  failing test for send_request with HEAD method.

Wed Jan 14 16:53:14 2015  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* ext/tk/lib/tkextlib/tcllib/plotchart.rb: fix to invoke correct function
	  of tcllib. Patch by @zalt50 [fix GH-787]

Wed Jan 14 16:48:15 2015  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (Resolv::DNS::Name#==): Compare an array of Label:Str
	  objects.  Label#Str#== is case-insensitive.

Wed Jan 14 16:48:15 2015  Ben Miller  <bmiller@rackspace.com>

	* lib/resolv.rb (Resolv::DNS::Name#==): DNS is case-insensitive, so the
	  comparison should be case-insensitive as well.
	  [ruby-core:66498] [Bug #10550]

Wed Jan 14 16:48:15 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/resolv.rb (Resolv::DNS::Name): names with different dots
	  should be different.

Wed Jan 14 16:30:51 2015  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http/response.rb (Net::HTTPResponse): require one or more
	  spaces [Bug #10591].
	  by leriksen <leif.eriksen.au@gmail.com>
	  https://github.com/ruby/ruby/pull/782 fix GH-782
	  NOTE: graph.facebook.com returns without SP Reason-Phrase.

Wed Jan 14 16:23:49 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl_cipher.c (ossl_cipher_update_long): update huge
	  data gradually not to exceed INT_MAX.  workaround of OpenSSL API
	  limitation.  [ruby-core:67043] [Bug #10633]

Wed Jan 14 16:14:50 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rb_cv_binary_elf): get rid of -e option of cat
	  which is not available on BusyBox, use tr instead.
	  [ruby-core:64824] [Bug #10210]

Wed Jan 14 16:07:11 2015  NAKAMURA Usaku  <usa@ruby-lang.org>

	* signal.c (ruby_signal): since SIGKILL is not supported by MSVCRT,
	  should be treated before calling signal(3).
	  [Bug #10615]

Wed Jan 14 15:57:26 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (exec_recursive): use the same last method name as
	  recursive_push in the error message when recursive_pop failed.
	  [ruby-core:66742] [Bug #10579]

Wed Jan 14 15:57:26 2015  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_frame_last_func): return the most recent frame method
	  name.

	* thread.c (recursive_list_access): use the last method name,
	  instead of the current method name which can be unset in some
	  cases, not to use a symbol by the invalid ID.
	  [ruby-core:66742] [Bug #10579]

Wed Jan 14 15:54:18 2015  Aaron Patterson <aaron@tenderlovemaking.com>

	* lib/resolv.rb: fall back if canonicalization fails.
	  Thanks Vit Ondruch for the patch!  [ruby-core:65836]

	* test/resolv/test_dns.rb: test for patch

Fri Nov 28 16:43:20 2014  Eric Hodel  <drbrain@segment7.net>

	* lib/net/http.rb:  Do not attempt SSL session resumption when the
	  session is expired.  [Bug #10533]

Fri Nov 28 16:36:34 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (symbol_list): fix the node type of literal symbol list
	  with no interpolation.  [ruby-core:66343]

Fri Nov 28 16:28:07 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/etc/etc.c (etc_getlogin): set login name encoding properly.
	  [ruby-core:66163] [Bug #10493]

Fri Nov 28 16:18:44 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (method_proc): the receiver of binding from method should
	  be same as the receiver of the method.
	  [ruby-core:65917] [Bug #10432]

Fri Nov 28 16:12:22 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http.rb (Net::HTTP.proxy_uri): use initializer instead
	  of parser to handle IPv6 address. [Bug #9129]

Fri Nov 28 16:05:09 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (copy_stream_body): should write in binary mode.  based on a
	  patch by godfat (Lin Jen-Shin) at [ruby-core:56556].
	  [ruby-core:56518] [Bug #8767]

Fri Nov 28 16:05:09 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (copy_stream_body): move common open flags.

Fri Nov 28 16:01:44 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/rubygems/ssl_certs/AddTrustExternalCARoot{-2048,}.pem: add newer
	  root CA for rubygems.org.  a part of r48389 of trunk.
	  see also https://github.com/rubygems/rubygems/commit/98f5f44c7141881c756003e4256b1a96b200b98e .
	  [Backport #10516] [ruby-core:66303]

Wed Nov 19 10:19:36 2014  Eric Wong  <e@80x24.org>

	* vm_eval.c (rb_yield_splat): add missing GC guard
	  [Bug #10509]

Thu Nov 13 22:31:50 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rexml/document.rb: add REXML::Document#document.
	  reported by Tomas Hoger <thoger@redhat.com> and patched by nahi.

Thu Nov  6 17:31:51 2014  Naohisa Goto  <ngotogenome@gmail.com>

	* compile.c (compile_data_alloc): add padding when strict alignment
	  is required for memory access. Currently, the padding is enabled
	  only when the CPU is 32-bit SPARC and the compiler is GCC.
	  [Bug #9681] [ruby-core:61715]

	* compile.c (STRICT_ALIGNMENT): defined if strict alignment is required

	* compile.c (ALIGNMENT_SIZE, ALIGNMENT_SIZE_MASK, PADDING_SIZE_MAX):
	  new macros for alignemnt word size, bit mask, max size of padding.

	* compile.c (calc_padding): new function to calculate padding size

Wed Nov  5 18:26:49 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* vm_insnhelper.c (unknown_keyword_error): delete expected keywords
	  directly from raw table, so that the given block is not called.
	  derived from r48102 of trunk.
	  [ruby-core:65837] [Bug #10413]

Mon Oct 27 20:21:05 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/rexml/entity.rb: keep the entity size within the limitation.
	  reported by Willis Vandevanter <will@silentrobots.com> and
	  patched by nahi.

Mon Oct 27 13:26:46 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c (rb_method_entry_make): warn redefinition only for
	  already defined methods, but not for undefined methods.
	  [ruby-dev:48691] [Bug #10421]

Thu Oct 23 18:56:55 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/openssl/lib/openssl/ssl.rb (DEFAULT_PARAMS): override
	  options even if OpenSSL::SSL::OP_NO_SSLv3 is not defined.
	  this is pointed out by Stephen Touset. [ruby-core:65711] [Bug #9424]

Thu Oct 23 18:56:55 2014  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* test/openssl/test_ssl.rb: Reuse TLS default options from
	  OpenSSL::SSL::SSLContext::DEFAULT_PARAMS.

Thu Oct 23 18:56:55 2014  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* lib/openssl/ssl.rb: Explicitly whitelist the default
	  SSL/TLS ciphers. Forbid SSLv2 and SSLv3, disable
	  compression by default.
	  Reported by Jeff Hodges.
	  [ruby-core:59829] [Bug #9424]

Mon Oct 20 14:41:45 2014  Kazuki Tsujimoto  <kazuki@callcc.net>

	* vm_core.h, vm.c, proc.c: fix GC mark miss on bindings.
	  [ruby-dev:48616] [Bug #10368]

	* test/ruby/test_eval.rb: add a test code.

Fri Oct 17 13:22:17 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_here_document): do not append already appended
	  and disposed code fragment.  [ruby-dev:48647] [Bug #10392]

Fri Oct 17 13:19:44 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_write): ASCII-8BIT StringIO
	  should be writable any encoding strings, without conversion.
	  [ruby-core:65240] [Bug #10285]

Fri Oct 17 13:10:08 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (eval_string_with_cref): fix super from eval with
	  scope.  set klass in the current control frame to the class of
	  the receiver in the context to be evaluated, this class/module
	  must match the actual receiver to call super.
	  [ruby-core:65122] [Bug #10263]

Thu Oct 16 16:33:51 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* regcomp.c, regexec.c: Optimization should be disabled not only for
	  /(?<=x).*/ but also for /(?!x).*/.
	  (merge r47598 partially. [Bug #9728])

Thu Oct 16 16:23:03 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* lib/fileutils.rb: handle ENOENT error with symlink targeted to
	  non-exists file. [ruby-dev:45933] [Bug #6716]

Wed Oct 15 16:23:22 2014  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_time_tz.rb: Fix test error with tzdata-2014g.
	  [ruby-core:65058] [Bug #10245] Reported by Vit Ondruch.

Wed Oct 15 16:23:22 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/minitest/test_minitest_unit.rb: removed obsoleted condition
	  for Ruby 1.8.
	* test/ruby/test_time_tz.rb: ditto.

Wed Oct 15 16:19:39 2014  Eric Wong  <e@80x24.org>

	* array.c (ary_recycle_hash): add RB_GC_GUARD
	  (rb_ary_diff): remove volatile
	  [Bug #10369]

Wed Oct 15 16:13:28 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (dir_s_aref): fix rdoc.  `Dir.glob` allows an array but
	  `Dir[]` not.  the former accepts an optional parameter `flags`,
	  while the latter accepts arbitrary number of arguments but no
	  `flags`.  [ruby-core:65265] [Bug #10294]

Wed Oct 15 16:12:11 2014  Rei Odaira  <Rei.Odaira@gmail.com>

	* configure.in: Fix typo. [Bug #9914]

Wed Oct 15 16:05:47 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* error.c: update exception tree. [DOC]
	  reported by @hemge via twitter.

Wed Oct 15 15:57:48 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (VCSUP): nothing to do if this worktree is not
	  under any VCS (it means that the worktree may be from the release
	  package).

Wed Oct 15 15:35:39 2014  Kazuki Tsujimoto  <kazuki@callcc.net>

	* ext/pathname/pathname.c (path_inspect): use PRIsVALUE to preserve
	  the result encoding.

Wed Sep 17 15:09:16 2014  Natalie Weizenbaum  <nweiz@google.com>

	* ext/pathname/lib/pathname.rb (SAME_PATHS):
	  Pathname#relative_path_from uses String#casecmp to compare strings
	  on case-insensitive filesystem platforms (e.g., Windows). This can
	  return nil for strings with different encodings, and the code
	  previously assumed that it always returned a Fixnum.  [Fix GH-713]

Wed Sep 17 15:07:35 2014  Sho Hashimoto  <sho.hsmt@gmail.com>

	* ext/fiddle/lib/fiddle/import.rb (Fiddle::Importer#sizeof): fix typo,
	  SIZEOF_LONG_LON.  [Fix GH-714]

Wed Sep 17 14:58:50 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MakeMakefile#pkg_config): append --cflags to also
	  $CXXFLAGS, as they are often used by C++ compiler.
	  [ruby-core:54532] [Bug #8315]

Wed Sep 17 14:58:50 2014  Shota Fukumori  <her@sorah.jp>

	* lib/mkmf.rb (configuration): Make CXXFLAGS customizable.
	  Patch by Kohei Suzuki (eagletmt). [Fixes GH-492]

Wed Sep 17 14:52:38 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/csv.rb (CSV#<<): honor explicitly given encoding.  based on
	  the patch by DAISUKE TANIWAKI <daisuketaniwaki AT gmail.com> at
	  [ruby-core:62113].  [Bug #9766]

Fri Sep 12 11:34:39 2014  Koichi Sasada  <ko1@atdot.net>

	* test/ruby/test_object.rb: extend timeout.

Fri Sep 12 11:34:39 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_obj_copy_ivar): allocate no memory for empty
	  instance variables.  [ruby-core:64700] [Bug #10191]

Fri Sep 12 11:34:39 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_obj_copy_ivar): extract function to copy instance
	  variables only for T_OBJECT from init_copy.

Fri Sep 12 11:30:50 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* regcomp.c: Merge Onigmo 988517a4f16f14acbd7cc9d5b51a096d5153992c.
	  [Bug #9344].

Fri Sep 12 11:22:55 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (Doxyfile): revert r43888, not to require preinstalled
	  ruby.  [ruby-core:64488] [Bug #10161]

Fri Sep 12 11:15:04 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_reopen): create a new, temporary FD via rb_sysopen and
	  call rb_cloexec_dup2 on it to atomically replace the file fptr->fd
	  points to.  This leaves no possible window where fptr->fd is invalid
	  to userspace (even for any threads running w/o GVL).  based on the
	  patch by Eric Wong <normalperson@yhbt.net> at [ruby-core:57943].
	  [Bug #9036]

Wed Sep 10 12:34:34 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_close): ignore only "closed stream" IOError and
	  NoMethodError, do not swallow other exceptions at the end of
	  block.  [ruby-core:64463] [Bug #10153]

Wed Sep 10 12:27:08 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/trans/euckr-tbl.rb (EUCKR_TO_UCS_TBL): add missing euro and
	  registered signs.  [ruby-core:64452] [Bug #10149]

Wed Sep 10 12:25:24 2014  Eric Wong  <e@80x24.org>

	* time.c (time_timespec): fix tv_nsec overflow
	  [Bug #10144]

Wed Sep 10 12:21:51 2014  Eric Wong  <e@80x24.org>

	* ext/zlib/zlib.c (gzfile_reset): preserve ZSTREAM_FLAG_GZFILE
	  [Bug #10101]

	* test/zlib/test_zlib.rb (test_rewind): test each_byte

Wed Sep 10 12:06:27 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_initialize): [DOC] fix rdoc of append mode.  it does
	  not move the pointer at open.  [ruby-core:63747] [Bug #10039]

Wed Sep 10 11:50:26 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (GETASTER): should not use the numbered argument to be
	  formatted, raise ArgumentError instead.
	  [ruby-dev:48330] [Bug #9982]

Wed Sep 10 11:43:55 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/openssl/test_pkey_rsa.rb (OpenSSL#test_sign_verify_memory_leak):
	  added timeout into testcase for low performance environment.
	  [Bug #9984][ruby-core:63367]

Wed Sep 10 11:39:54 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (env_aset, env_has_key, env_assoc, env_has_value),
	  (env_rassoc, env_key): prohibit tainted strings if $SAFE is
	  non-zero.  [Bug #9976]

Sat Sep  6 09:10:45 2014  Zachary Scott  <e@zzak.io>

	* lib/rdoc/generator/template/darkfish/js/jquery.js: Backport
	  rdoc/rdoc@74f60fcb04fee1778fe2694d1a0ea6513f8e67b7

Fri Sep  5 14:08:00 2014  Masaki Suketa <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (ole_create_dcom): use the converted
	  result if the argument can be converted to a string, to get rid
	  of invalid access. Thanks to nobu. [ruby-dev:48467] [Bug #10127]

Fri Sep  5 14:00:33 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (open): use UTF-8 version function to support
	  non-ascii path properly.  [ruby-core:63185] [Bug #9946]

Fri Sep  5 13:53:41 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yylex): fix invalid char in eval, should raise
	  an syntax error too, as well as directly coded.
	  [ruby-core:64243] [Bug #10117]

Fri Sep  5 13:51:10 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yyerror): preserve source code encoding in
	  syntax error messages.  [ruby-core:64228] [Bug #10114]

Fri Sep  5 13:44:53 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_count): fix wrong single-byte optimization.
	  7bit ascii can be a trailing byte in Shift_JIS.
	  [ruby-dev:48442] [Bug #10078]

Fri Sep  5 13:36:12 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	merge r46831 partially.  these changes are from:
	https://github.com/k-takata/Onigmo/commit/7abd7b29481f98eb92be786e3d33611fc7d000a0
	[Bug #8716]

	* include/ruby/oniguruma.h (ONIG_MAX_CAPTURE_GROUP_NUM,
	  ONIGERR_TOO_MANY_CAPTURE_GROUPS): add cheking the number of capture
	  groups.

	* regerror.c (onig_error_code_to_format): ditto.

	* regparse.c (scan_env_add_mem_entry): ditto.

	* regexec.c (onig_region_copy, match_at): fix: segmation fault occurs
	  when many groups are used.

Fri Sep  5 13:06:53 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_resize): update capa only when buffer get
	  reallocated.
	  http://d.hatena.ne.jp/nagachika/20140613/ruby_trunk_changes_46413_46420#r46413

Fri Sep  5 13:06:53 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_resize): should consider the capacity instead
	  of the old length, as pointed out by nagachika.

Fri Sep  5 13:06:53 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (expand_path): shrink expanded path which no longer needs
	  rooms to append.  [ruby-core:63114] [Bug #9934]

Wed Sep  3 13:42:24 2014  Mark Lorenz  <mlorenz@covermymeds.com>

	* lib/erb.rb (result): [DOC] no longer accepts a Proc, as
	  Kernel.eval does not.  [fix GH-619]

Wed Sep  3 13:23:29 2014  Tanaka Akira  <akr@fsij.org>

	* io.c (rb_io_autoclose_p): Don't raise on frozen IO.

	* test/lib/minitest/unit.rb: IO#autoclose? may raise IOError.

Wed Sep  3 13:23:29 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_fileno, rb_io_inspect): non-modification does not
	  error on frozen IO.  [ruby-dev:48241] [Bug #9865]

Wed Sep  3 13:17:38 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (posix_fadvise): disable use of posix_fadvise
	  itself on 32-bit AIX.  [ruby-core:62968] [Bug #9914]

Wed Sep  3 13:17:38 2014    <kanemoto@ruby-lang.org>

	* io.c (rb_io_advise): AIX currently does not support a 32-bit call to
	  posix_fadvise() if _LARGE_FILES is defined. Patch by Rei Odaira.
	  [ruby-core:62968] [Bug #9914]

Wed Sep  3 12:48:14 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_write): use rb_str_append to
	  reuse coderange bits other than ASCII-8BIT, and keep
	  taintedness.  [ruby-dev:48118] [Bug #9769]

Wed Sep  3 12:41:35 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (env_shift): fix memory leak on Windows, free environment
	  strings block always.  [ruby-dev:48332] [Bug #9983]

Wed Sep  3 12:41:35 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (env_select): fix memory leak and crash on Windows, make
	  keys array first instead of iterating on environ directly.
	  [ruby-dev:48325] [Bug #9978]

Wed Sep  3 12:41:35 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (ruby_setenv): fix memory leak on Windows, free
	  environment strings block after check for the size.
	  [ruby-dev:48323] [Bug #9977]

Wed Sep  3 12:24:39 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* re.c (match_aref, rb_reg_regsub): consider encoding of captured
	  names, encoding-incompatible should not match.
	  [ruby-dev:48278] [Bug #9903]

Wed Sep  3 12:24:39 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (ruby__sfvextra): add QUOTE flag to escape unprintable
	  characters.

Wed Sep  3 12:24:39 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* sprintf.c (ruby__sfvextra): add QUOTE flag to escape unprintable
	  characters.

Sun Aug 31 16:59:45 2014  Koichi Sasada  <ko1@atdot.net>

	* vm_eval.c (rb_catch_protect): fix same problem of [Bug #9961].

	* vm_eval.c (rb_iterate): ditto.

Sun Aug 31 16:59:45 2014  Koichi Sasada  <ko1@atdot.net>

	* vm.c (rb_vm_rewind_cfp): add new function to rewind specified cfp
	  with invoking RUBY_EVENT_C_RETURN.
	  [Bug #9961]

	* vm_core.h: ditto.

	* eval.c (rb_protect): use it.

	* eval.c (rb_rescue2): ditto.

	* vm_eval.c (rb_iterate): ditto.

	* test/ruby/test_settracefunc.rb: add a test.

	* vm_core.h (rb_name_err_mesg_new): 

Sun Aug 31 16:50:06 2014  Koichi Sasada  <ko1@atdot.net>

	* compile.c (rb_iseq_compile_node): put start label of block after
	  trace (b_call).
	  [Bug #9964]

	* test/ruby/test_settracefunc.rb: add a test.

	  added assert_consistent_call_return() method check call/return
	  consistency.

Sun Aug 31 16:38:26 2014  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h: add VM_FRAME_MAGIC_RESCUE to recognize normal block or
	  rescue clause.

	* vm.c (vm_exec): use VM_FRAME_MAGIC_RESCUE on at rescue/ensure.

	* test/ruby/test_settracefunc.rb: should not invoke b_return at rescue
	  clause.
	  [Bug #9957]

	* vm_dump.c (control_frame_dump): check VM_FRAME_MAGIC_RESCUE.

	* vm_dump.c (vm_stack_dump_each): ditto.

Sun Aug 31 16:32:10 2014  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* lib/test/unit/parallel.rb: fix test-all parallel failure if a test
	  is skipped after raise.
	  DL::TestFunc#test_sinf is skipped after raise on mingw ruby.
	  But it causes Marshal.load failure due to undefined class/module
	  DL::DLError when doing test-all parallel and test-all doesn't
	  complete. We create new MiniTest::Skip object to avoid Marshal.load
	  failure.
	  [ruby-core:62133] [Bug #9767]

	* test/testunit/test_parallel.rb (TestParallel): add a test.

	* test/testunit/tests_for_parallel/ptest_forth.rb: ditto.

Sun Aug 31 16:24:54 2014  Tanaka Akira  <akr@fsij.org>

	* ext/pathname/lib/pathname.rb (cleanpath_aggressive): make all
	  separators File::SEPARATOR from File::ALT_SEPARATOR.
	  Reported by Daniel Rikowski.
	  Fixed by Nobuyoshi Nakada.  [Bug #9618]

	* ext/pathname/lib/pathname.rb (cleanpath_conservative): ditto.

Sun Aug 31 16:23:41 2014  Naohisa Goto  <ngotogenome@gmail.com>

	* lib/fileutils.rb (rmdir): rescue Errno::EEXIST in addition to
	  ENOTEMPTY (and ENOENT), because SUSv3 describes that "If the
	  directory is not an empty directory, rmdir() shall fail and set
	  errno to [EEXIST] or [ENOTEMPTY]" and Solaris uses EEXIST.
	  [Bug #9571] [ruby-dev:48017]

Sun Aug 31 16:20:14 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (bind_random_port): Rescue EPERM for FreeBSD which
	  security.mac.portacl.port_high is changed.
	  See mac_portacl(4) for details.
	  Reported by Jakub Szafranski.  [ruby-core:60917] [Bug #9544]

Sun Aug 31 16:16:24 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* re.c (match_aref): should not ignore name after NUL byte.
	  [ruby-dev:48275] [Bug #9902]

Sun Aug 31 16:10:30 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/digest/digest.c (rb_digest_instance_equal): no need to call
	  `to_s` twice.  [Bug #9913]

Sun Aug 31 16:10:30 2014  Benoit Daloze  <eregontp@gmail.com>

	* ext/digest/digest.c (rb_digest_instance_equal):
	  fix #== for non-string arguments. [ruby-core:62967] [Bug #9913]

	* test/digest/test_digest.rb: add test for above.

Sun Aug 31 15:46:23 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (yield_indexed_values): extract from permute0(),
	  rpermute0(), and rcombinate0().

Sun Aug 31 15:23:25 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_permutation): `p` is the array of size `r`, as
	  commented at permute0().  since `n >= r` here, buffer overflow
	  never happened, just reduce unnecessary allocation though.

Mon Jul  7 13:05:04 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* test/test_timeout.rb (test_timeout): inverted test condition.
	  [Bug #8523]

Mon Jul  7 12:57:26 2014  Masaya Tarui  <tarui@ruby-lang.org>

	* st.c (st_foreach_check): change start point of search at check
	  from top to current. [ruby-dev:48047] [Bug #9646]

Mon Jul  7 12:53:45 2014  Zachary Scott  <e@zzak.io>

	* lib/gserver.rb: [DOC] Fixed typo in example by @stomar [Bug #9543]

Mon Jul  7 12:52:44 2014  Zachary Scott  <e@zzak.io>

	* enumerator.c: [DOC] Fix example to show Enumerator#peek behavior
	  Patch by Erik Hollembeak [Bug #9814]

Mon Jul  7 12:51:09 2014  Zachary Scott  <e@zzak.io>

	* enum.c: [DOC] Use #find in example to clarify alias by @rachellogie
	  Patch submitted via documenting-ruby/ruby#34

Mon Jul  7 12:49:10 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* man/ruby.1: remove deadlink. [ruby-core:62145][Bug #9773]

Mon Jul  7 12:46:28 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* struct.c (not_a_member): extract name error and use same error
	  messages.  based on the patch by Marcus Stollsteimer <sto.mar AT
	  web.de> at [ruby-core:61721].  [Bug #9684]

Mon Jul  7 12:39:34 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (read_all): truncate the buffer before appending read data,
	  instead of truncating before reading.
	  [ruby-core:55951] [Bug #8625]

Mon Jul  7 12:39:34 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_setstrbuf, io_read): should not shorten the given buffer until
	  read succeeds.  [ruby-core:55951] [Bug #8625]

Mon Jul  7 12:16:54 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/ftp.rb (gets, readline): read lines without LF properly.
	  [ruby-core:63205] [Bug #9949]

	* test/net/ftp/test_buffered_socket.rb: related test.

Mon Jul  7 12:13:09 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (body_type_1part): Gmail IMAP reports a body
	  type as "MIXED" followed immediately by params
	  [ruby-core:62864] [Bug #9885]
	  Patch by @rayners (David Raynes). [Fixes GH-622] 
	  https://github.com/ruby/ruby/pull/622

Mon Jul  7 12:05:28 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (body_type_msg): should accept
	  message/delivery-status with extra data.
	  [ruby-core:53741] [Bug #8167]

	* test/net/imap/test_imap_response_parser.rb: related test.

Mon Jul  7 11:47:51 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (local_tbl_gen): remove local variables duplicated with
	  arguments.

Thu Jul  3 15:17:22 2014  Koichi Sasada  <ko1@atdot.net>

	  [ruby-core:60501] [Bug #9486]
	* vm.c (rb_vm_pop_cfunc_frame): added.  It cares c_return event.
	  The patch base by drkaes (Stefan Kaes).
	  [Bug #9321]

	* variable.c (rb_mod_const_missing): use rb_vm_pop_cfunc_frame()
	  instead of rb_frame_pop().

	* vm_eval.c (raise_method_missing): ditto.

	* vm_eval.c (rb_iterate): ditto.

	* internal.h (rb_vm_pop_cfunc_frame): add decl.

	* test/ruby/test_settracefunc.rb: add tests.
	  provided by drkaes (Stefan Kaes).

	* vm.c, eval.c, include/ruby/intern.h (rb_frame_pop):
	  move definition of rb_frame_pop() and deprecate it.
	  It doesn't care about `return' events.

Fri Jun 27 17:57:16 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_substr): need to reset code range for shared
	  string too, not only copied string.
	  [ruby-core:62842] [Bug #9882]

Fri Jun 27 17:54:09 2014  Rei Odaira  <Rei.Odaira@gmail.com>

	* signal.c (ruby_signal): should return either `old.sa_sigaction`
	  or `old.sa_handler`, depending on whether `SA_SIGINFO` is set in
	  `old.sa_flags`, because they may not be a union.
	  [ruby-core:62836] [Bug #9878]

Fri Jun 27 17:37:12 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vsnprintf.c (BSD_vfprintf): fix string width when precision is
	  given.  as the result of `memchr` is NULL or its offset from the
	  start cannot exceed the size, the comparison was always false.
	  [ruby-core:62737] [Bug #9861]

Fri Jun 27 17:27:26 2014  Eric Wong  <e@80x24.org>

	* process.c (proc_getgroups, proc_setgroups): use ALLOCV_N
	  [Bug #9856]

Fri Jun 27 17:19:22 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_setstrbuf): always check if the buffer is modifiable.
	  [ruby-core:62643] [Bug #9847]

Fri Jun 27 17:15:36 2014  Tanaka Akira  <akr@fsij.org>

	* ext/openssl/lib/openssl/ssl.rb (OpenSSL::SSL::SSLServer#accept):
	  Consider Socket#accept as well as TCPServer#accept.
	  Reported by Sam Stelfox.  [ruby-core:62064] [Bug #9750]

Fri Jun 27 17:12:45 2014  Eric Wong  <e@80x24.org>

	* complex.c (parse_comp): replace ALLOCA_N with ALLOCV_N/ALLOCV_END
	  [Bug #9608]
	* rational.c (read_digits): ditto

Fri Jun 27 17:05:23 2014  Tanaka Akira  <akr@fsij.org>

	* lib/net/ftp.rb (transfercmd): Close TCP server socket even if an
	  exception occur.

Fri Jun 27 17:02:36 2014  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* thread_win32.c (rb_w32_stack_overflow_handler): use Structured
	  Exception Handling by AddVectoredExceptionHandler() for machine
	  stack overflow on mingw.
	  This would be equivalent to the handling using __try and __except
	  on mswin introduced by r43748.

Fri Jun 27 17:02:36 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* eval_intern.h (SAVE_ROOT_JMPBUF): workaround for the failure of
	  test/ruby/test_exception.rb on Windows.
	  wrap by __try and __exception statements on mswin to raise SIGSEGV
	  when EXCEPTION_STACK_OVERFLOW is occurred, because MSVCRT doesn't
	  handle the exception.
	  however, (1) mingw-gcc doesn't support __try and __exception
	  statements, and (2) we cannot retry SystemStackError after this
	  change yet (maybe crashed) because SEH and longjmp() are too
	  uncongenial.

	* signal.c (check_stack_overflow, CHECK_STACK_OVERFLOW): now defined on
	  Windows, too.

	* thread_win32.c (ruby_stack_overflowed_p): ditto.

Fri Jun 27 16:56:38 2014  Eric Wong  <e@80x24.org>

	* signal.c (signal_exec): ignore immediate cmd for SIG_IGN
	* signal.c (trap_handler): set cmd to true for SIG_IGN
	* signal.c (trap): handle nil and true values for oldcmd
	  [Bug #9835]

Mon Jun 23 18:51:43 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_mod_init_copy): always clear instance variable,
	  constant and method tables first, regardless the source tables.
	  [ruby-dev:48182] [Bug #9813]

Mon Jun 23 18:50:13 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (thread_start_func_2): stop if forked in a sub-thread,
	  the thread has become the main thread.
	  [ruby-core:62070] [Bug #9751]

Mon Jun 23 18:35:34 2014  Josh Goebel  <dreamer3@gmail.com>

	* net/protocol.rb (using_each_crlf_line): fix SMTP dot-stuffing
	  for messages not ending with a new-line.
	  [ruby-core:61441] [Bug #9627] [fix GH-616]

Mon Jun 23 18:16:07 2014  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* configure.in: enable SSE2 on mingw. target='i386-pc-mingw32'.
	  [ruby-core:62095] [Bug #8358]

Mon Jun 23 18:16:07 2014  Tanaka Akira  <akr@fsij.org>

	* configure.in: Fix compilation error.
	  https://bugs.ruby-lang.org/issues/8358#note-16

Mon Jun 23 18:16:07 2014  Vit Ondruch  <vondruch@redhat.com>

	* configure.in: add qouting brackets and append wildcard for the
	  rest after target_cpu, to properly detect platform for SSE2
	  instructions.  [ruby-core:60576] [Bug #8358]

Mon Jun 23 18:16:07 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: use SSE2 instructions to drop unexpected precisions on
	  other than mingw.  [ruby-core:59472] [Bug #8358]

Mon Jun 23 18:16:07 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: use SSE2 instructions for drop unexpected
	  precisions.  [ruby-core:54738] [Bug #8358]

Mon Jun 23 17:29:53 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (obj2uid, obj2gid): now getpwnam_r() and getgrnam_r()
	  may need larger buffers than sysconf values, so retry with
	  expanding the buffer when ERANGE is returned.
	  [ruby-core:61325] [Bug #9600]

Mon Jun 23 17:20:10 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket/socket.c (sock_s_getnameinfo): Save errno for EAI_SYSTEM.
	  Reported by Saravana kumar.  [ruby-core:61820] [Bug #9697]
	  Fixed by Heesob Park.  [ruby-core:61868]

Mon Jun 23 17:20:10 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket/ipsocket.c (ip_s_getaddress): Don't access freed memory.

Mon Jun 23 17:20:10 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket: always operate length of socket addess companion with
	  socket address. 

	* ext/socket/rubysocket.h (rsock_make_ipaddr): add an argument for
	  socket address length.
	  (rsock_ipaddr): ditto.

	* ext/socket/ipsocket.c (ip_addr): pass length to rsock_ipaddr.
	  (ip_peeraddr): ditto.
	  (ip_s_getaddress): pass length to rsock_make_ipaddr.

	* ext/socket/socket.c (make_addrinfo): pass length to rsock_ipaddr.
	  (sock_s_getnameinfo): pass actual address length to rb_getnameinfo.
	  (sock_s_unpack_sockaddr_in): pass length to rsock_make_ipaddr.
	  
	* ext/socket/init.c (rsock_s_recvfrom): pass length to rsock_ipaddr.
	  (rsock_s_recvfrom_nonblock): ditto.

	* ext/socket/tcpsocket.c (tcp_sockaddr): pass length to
	  rsock_make_ipaddr.

	* ext/socket/raddrinfo.c (make_ipaddr0): add an argument for socket
	  address length.  pass the length to rb_getnameinfo.
	  (rsock_ipaddr): ditto.
	  (rsock_make_ipaddr): add an argument for socket address length. 
	  pass the length to make_ipaddr0.
	  (make_inetaddr): pass length to make_ipaddr0.
	  a local variable renamed.
	  (host_str): a local variable renamed.
	  (port_str): ditto.

Mon Jun 23 16:55:13 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (primary): flush cmdarg flags inside left-paren in a
	  command argument, to allow parenthesed do-block as an argument
	  without arguments parentheses.  [ruby-core:61950] [Bug #9726]

Mon Jun 23 16:45:48 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/cptr.c (dlptr_free), ext/dl/handle.c (dlhandle_free),
	  ext/fiddle/handle.c (fiddle_handle_free),
	  ext/fiddle/pointer.c (fiddle_ptr_free): fix memory leak.
	  based on the patch Heesob Park at [ruby-dev:48021] [Bug #9599].

Wed May 28 13:24:39 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rb_cv_func___builtin_unreachable): try with an
	  external variable not only by a warning, which might not be
	  shown due to the optimization.  [ruby-core:61647] [Bug #9665]

Wed May 28 13:20:32 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl_asn1.c (ossl_asn1_initialize): SYMID on a value
	  other than Symbol is an undefined behavior.  fix up r31699.
	  [ruby-core:62142] [Bug #9771]

Wed May 28 13:18:21 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_putc): fix for non-ascii
	  encoding, like as IO#putc.  [ruby-dev:48114] [Bug #9765]

Tue May 27 13:57:41 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/fileutils.rb (FileUtils#copy_entry): update rdoc about
	  preserve option and permissions, following r31123.
	  [ruby-core:62065] [Bug #9748]

Tue May 27 13:42:36 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (umethod_bind): use the ancestor iclass instead of new
	  iclass to get rid of infinite recursion, if the defined module
	  is already included.  [ruby-core:62014] [Bug #9721]

Tue May 27 13:42:36 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (rb_method_call_with_block, umethod_bind): call with
	  IClass including the module for a module instance method.
	  [ruby-core:61936] [Bug #9721]

	* vm_insnhelper.c (vm_search_super_method): allow bound
	  UnboundMethod case.

Tue May 27 11:51:00 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (ary_reject): may be turned into a shared array during
	  the given block.  [ruby-dev:48101] [Bug #9727]

Tue May 27 11:48:22 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (str_buf_cat): should round up the capacity by 4KiB,
	  but not number of rooms.  [ruby-core:61886] [Bug #9709]

Tue May 27 11:46:03 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/xmlrpc/client.rb (do_rpc): don't check body length.
	  If HTTP content-encoding is used, the length may be different.
	  [Bug #8182] [ruby-core:53811]

Tue May 27 11:23:02 2014  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (d_lite_cmp): should compare with #<.

Mon May  5 00:42:35 2014  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* ext/psych/yaml/config.h: ditto.

	* ext/psych/yaml/scanner.c: ditto.

	* ext/psych/yaml/yaml_private.h: ditto.

Thu May  8 02:01:51 2014  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_initialize): Insert GC guard.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_global_new): ditto.

Thu May  8 01:51:19 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl_pkey.c (ossl_pkey_verify): as EVP_VerifyFinal()
	  finalizes only a copy of the digest context, the context must be
	  cleaned up after initialization by EVP_MD_CTX_cleanup() or a
	  memory leak will occur.  [ruby-core:62038] [Bug #9743]

Wed Apr 30 16:39:43 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/readline/extconf.rb (rl_hook_func_t): check pointer type.
	  [ruby-dev:48089] [Bug #9702]

Wed Apr 30 16:37:16 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_accept, open_ifs_socket, socketpair_internal):
	  reset inherit flag of socket to avoid unintentional inheritance of
	  socket.  note that the return value of SetHandleInformation() is not
	  verified intentionally because old Windows may return an error.
	  [Bug #9688] [ruby-core:61754]

Wed Apr 30 16:33:57 2014  Eric Wong  <e@80x24.org>

	* time.c (time_mload): freeze and preserve marshal-loaded time zone
	* test/ruby/test_time.rb: add test for GC on loaded object
	  [Bug #9652]

Wed Apr 30 16:15:09 2014  Kohei Suzuki  <eagletmt@gmail.com>

	* vm_method.c (rb_method_entry_get_without_cache): me->klass is 0
	  for a method aliased in a module.  [ruby-core:61636] [Bug #9663]

Wed Apr 30 16:15:09 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c (rb_method_entry_get_without_cache): get rid of
	  infinite recursion at aliases in a subclass and a superclass.
	  return actually defined class for other than singleton class.
	  [ruby-core:60431] [Bug #9475]

Wed Apr 30 16:09:18 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_callee_setup_arg): turn a macro into an
	  inline function.

Wed Apr 30 15:04:25 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/readline/extconf.rb: fix typo, `$defs` not `$DEFS`.
	  [ruby-core:61756] [Bug #9578]

Mon Mar 31 00:57:39 2014  James Edward Gray II  <james@graysoftinc.com>

	* lib/csv.rb: Fixed a broken regular expression that was causing
	  CSV to miss escaping some special meaning characters when used
	  in parsing.
	  Reported by David Unric
	  [ruby-core:54986] [Bug #8405]

Mon Mar 31 00:48:12 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/ruby/envutil.rb (assert_no_memory_leak): increase default value
	  of `limit` keyword argument.
	  assert_no_memory_leak occasionally fails with limit=1.5.

Mon Mar 31 00:15:45 2014  Shota Fukumori  <her@sorah.jp>

	* vm_eval.c (eval_string_with_cref): Unify to use NIL_P.

Mon Mar 31 00:15:45 2014  Shota Fukumori  <her@sorah.jp>

	* vm_eval.c (eval_string_with_cref): Use file path even if scope is
	  given. Related to [ruby-core:56099] [Bug #8662] and r42103.

Mon Mar 31 00:02:04 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (yycompile): store file name as String to keep the encoding.

	* parse.y (rb_parser_compile_string_path, rb_parser_compile_file_path):
	  new functions to pass file name as a String.

	* parse.y (gettable_gen): return a copy of the original file name, not
	  a copy in filesystem encoding.

	* vm_eval.c (eval_string_with_cref): use Qundef instead of "(eval)".

Sun Mar 30 23:49:21 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl.c (ossl_make_error): check NULL for unknown
	  error reasons with old OpenSSL, and insert a colon iff formatted
	  message is not empty.

Thu Mar 20 21:13:18 2014  Eric Wong  <e@80x24.org>

	* variable.c (rb_const_set): delete existing entry on redefinition
	  [Bug #9645]
	* test/ruby/test_const.rb (test_redefinition): test for leak

Thu Mar 20 20:44:17 2014  Kazuki Tsujimoto  <kazuki@callcc.net>

	* test/fiddle/test_c_struct_entry.rb,
	  test/fiddle/test_c_union_entity.rb,
	  test/fiddle/test_cparser.rb, test/fiddle/test_func.rb,
	  test/fiddle/test_handle.rb, test/fiddle/test_import.rb,
	  test/fiddle/test_pointer.rb: don't run test if the system
	  don't support fiddle.

Sun Mar 16 00:57:20 2014  Kazuki Tsujimoto  <kazuki@callcc.net>

	* ext/.document: remove refinement from documentable directories.

Mon Mar  3 01:43:30 2014  Charlie Somerville  <charliesome@ruby-lang.org>

	* eval_error.c (warn_printf): use rb_vsprintf instead so ruby specific
	  extensions like PRIsVALUE can be used in format strings
	* eval_error.c (error_print): use warn_print_str (alias for
	  rb_write_error_str) to print a string value instead of using
	  RSTRING_PTR and RSTRING_LEN manually
	* eval.c (setup_exception): use PRIsVALUE instead of %s and RSTRING_PTR

Mon Mar  3 01:32:14 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/readline/extconf.rb (rl_hook_func_t): define as Function for
	  very old readline versions.  [ruby-core:61209] [Bug #9578]

Mon Mar  3 01:32:14 2014  Tanaka Akira  <akr@fsij.org>

	* ext/readline/readline.c (Init_readline): Use rl_hook_func_t instead
	  of Function to support readline-6.3.  (rl_hook_func_t is available
	  since readline-4.2.)
	  Reported by Dmitry Medvinsky.  [ruby-core:61141] [Bug #9578]

Mon Mar  3 01:25:28 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (setup_exception): preserve errinfo across calling #to_s
	  method on the exception.  [ruby-core:61091] [Bug #9568]

Mon Mar  3 01:00:00 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* numeric.c (ruby_num_interval_step_size): check signs and get rid
	  of implementation dependent behavior of negative division.
	  [ruby-core:61106] [Bug #9570]

Mon Mar  3 00:43:33 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	(merged partially from r42781)
	* test/ruby/test_numeric.rb (assert_step): introduce assert_step.

Mon Mar  3 00:24:38 2014  Zachary Scott  <e@zzak.io>

	* README.EXT.ja: [DOC] Fix typo "macro macro" @utenmiki [Fixes GH-551]
	  https://github.com/ruby/ruby/pull/551

Sat Feb 22 22:11:58 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/io/console/console.c (console_dev): need read access for conout$
	  because some functions need it.  [Bug#9554]

Sat Feb 22 14:01:42 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* iseq.c (iseq_load): keep type_map to get rid of memory leak.
	  based on a patch by Eric Wong at [ruby-core:59699].  [Bug #9399]

Sat Feb 22 13:56:38 2014  Charlie Somerville  <charliesome@ruby-lang.org>

	* compile.c (iseq_build_from_ary_body): Use :blockptr instead of :block
	  as hash key when loading serialized instruction sequences from arrays.
	  [Bug #9455] [ruby-core:60146]

Sat Feb 22 13:04:54 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/init.c (wait_connectable): break if the socket is
	  writable to avoid infinite loops on FreeBSD and other platforms
	  which conforms to SUSv3.  This problem cannot be reproduced with
	  loopback interfaces, so it's hard to write test code.
	  rsock_connect() and wait_connectable() are overly complicated, so
	  they should be refactored, but I commit this fix as a workaround
	  for the release of Ruby 1.9.3 scheduled on Feb 24.
	  [ruby-core:60940] [Bug #9547]

Sat Feb 22 12:55:24 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	(merged partially from r42927)
	* lib/rubygems/core_ext/kernel_require.rb: Backport a fix for concurrent
	  requires. [ruby-core:58918] [Backport #9224]
	  see also https://github.com/rubygems/rubygems/pull/833

Sat Feb 22 11:50:52 2014  Eric Wong  <e@80x24.org>

	* ext/socket/ancdata.c (bsock_sendmsg_internal): only retry on error
	  (bsock_recvmsg_internal): ditto
	* test/socket/test_unix.rb: test above for infinite loop

Sat Feb 22 11:44:50 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_mod_init_copy): do nothing if copying self.
	  [ruby-dev:47989] [Bug #9535]

	* hash.c (rb_hash_initialize_copy): ditto.

Thu Feb 20 02:14:18 2014  Zachary Scott  <e@zzak.io>

	* ext/openssl/lib/openssl/buffering.rb: Fix warning in copyright

Thu Feb 20 02:14:18 2014  Zachary Scott  <e@zzak.io>

	* ext/openssl/lib/openssl/buffering.rb: [DOC] Fix HEREDOC comment for
	  OpenSSL::Buffering which breaks overview because of RDoc bug

Thu Feb 20 02:04:09 2014  Eric Hodel  <drbrain@segment7.net>

	* ext/.document:  Add syslog/lib to documentable items. [Bug #9228]

Thu Feb 20 01:54:08 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_search_super_method): when super called in a
	  bound UnboundMethod generated from a module, no superclass is
	  found since the current defined class is the module, then call
	  method_missing in that case.  [ruby-core:59619] [Bug #9377]

Thu Feb 20 01:33:06 2014  Eric Hodel  <drbrain@segment7.net>

	* lib/optparse.rb:  The Integer acceptable now allows binary and
	  hexadecimal numbers per the documentation.  [ruby-trunk - Bug #8865]

	  DecimalInteger, OctalInteger, DecimalNumeric now validate their input
	  before converting to a number.  [ruby-trunk - Bug #8865]

	* test/optparse/test_acceptable.rb:  Tests for the above, tests for all
	  numeric acceptables for existing behavior.

Thu Feb 20 01:23:36 2014  Aaron Pfeifer  <aaron.pfeifer@gmail.com>

	* thread.c (terminate_atfork_i): fix locking mutexes not unlocked in
	  forks when not tracked in thread.  [ruby-core:55102] [Bug #8433]

Tue Feb 18 23:48:03 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/envutil.rb (assert_separately): require envutil in the
	  child process too.

Tue Feb 18 22:38:01 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/envutil.rb (Test::Unit::Assertions#assert_separately):
	  specify the encoding of source.

Mon Feb 17 02:00:36 2014  Tanaka Akira  <akr@fsij.org>

	* lib/open-uri.rb: Make proxy disabling working again.
	  Fixed by Christophe Philemotte.   [ruby-core:59650] [Bug #9385]

Mon Feb 17 01:57:45 2014  Benoit Daloze  <eregontp@gmail.com>

	* range.c (Range#size): [DOC] improve description and add examples.
	  Patch by @skade. [Fixes GH-501]

Mon Feb 17 01:51:49 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/webrick/htmlutils.rb (WEBrick::HTMLUtils#escape): replace HTML
	  meta chars even in non-ascii string.  [Bug #8425] [ruby-core:55052]

	* lib/webrick/httputils.rb (WEBrick::HTTPUtils#{_escape,_unescape}):
	  fix %-escape encodings.  [Bug #8425] [ruby-core:55052]

Mon Feb 17 01:51:49 2014  Ayumu AIZAWA  <ayumu.aizawa@gmail.com>

	* test/webrick/test_htmlutils.rb: add test for WEBrick::HTMLUtils.

Mon Feb 17 01:41:59 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_hash_rehash): use hash_alloc() instead of rb_hash_new().
	  [Bug #9187]

Mon Feb 17 01:41:59 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* hash.c (rb_hash_rehash): make temporary st_table under the control
	  of GC. [Bug #9187]

	* test/ruby/test_hash.rb: add a test for above.

Mon Feb 17 01:41:59 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* hash.c (rb_hash_rehash): fix to free new st_table when exception
	  is raised in do_hash(). [Bug #9187]

Mon Feb 17 01:18:04 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_mod_s_constants): return its own constants for other
	  than Module itself.  [ruby-core:59763] [Bug #9413]

Mon Feb 17 01:16:00 2014  Eric Wong <e@80x24.org>

	* ext/json/generator/depend: add build dependencies for json extension
	  [Bug #9374] [ruby-core:59609]
	* ext/json/parser/depend: ditto

Mon Feb 17 01:12:57 2014  Yusuke Endoh  <mame@tsg.ne.jp>

	* ext/fiddle/closure.c: use sizeof(*pcl) for correct sizeof value.
	  [ruby-core:57599] [Bug #8978].

Mon Feb 17 01:12:57 2014  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/fiddle/closure.c: use sizeof(*pcl) for correct sizeof value.
	  [ruby-core:57599] [Bug #8978].  Thanks mame!

Mon Feb 17 01:09:52 2014  Eric Wong <e@80x24.org>

	* benchmark/driver: avoid large alloc in driver process
	  [ruby-core:59869] [Bug #9430]

Mon Feb 17 00:59:40 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (rb_thread_create_timer_thread): fix for platforms
	  where PTHREAD_STACK_MIN is a dynamic value and not a compile-time
	  constant.  [ruby-dev:47911] [Bug #9436]

Mon Feb 17 00:59:40 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (rb_thread_create_timer_thread): expand timer
	  thread stack size to get rid of segfault on FreeBSD/powerpc64.
	  based on the patch by Steve Wills at [ruby-core:59923].
	  [ruby-core:56590] [Bug #8783]

Mon Feb 17 00:45:44 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_modify_expand): enable capacity and disable
	  association with packed objects when setting capa, so that
	  pack("p") string fails to unpack properly after modified.

Sun Feb 16 01:36:57 2014  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/yaml/emitter.c: merge libyaml 0.1.5
	* ext/psych/yaml/loader.c: ditto
	* ext/psych/yaml/parser.c: ditto
	* ext/psych/yaml/reader.c: ditto
	* ext/psych/yaml/scanner.c: ditto
	* ext/psych/yaml/writer.c: ditto
	* ext/psych/yaml/yaml_private.h: ditto

Sun Feb 16 01:02:32 2014  Zachary Scott  <e@zzak.io>

	* lib/racc/rdoc/grammar.en.rdoc: [DOC] Correct grammar and typos
	  Patch by Giorgos Tsiftsis [Bug #9429] [ci skip]

Sun Feb 16 01:00:45 2014  Zachary Scott  <e@zzak.io>

	* lib/open-uri.rb: [DOC] use lower case version of core classes, same
	  as commit r44878, based on patch by Jonathan Jackson [Bug #9483]

Sun Feb 16 01:00:45 2014  Zachary Scott  <e@zzak.io>

	* ext/ripper/lib/ripper/lexer.rb: [DOC] use lower case version of core
	  classes when referring to return value, since we aren't directly
	  talking about the class. Patch by Jonathan Jackson [Bug #9483]

Sun Feb 16 00:57:13 2014  Ayumu AIZAWA  <ayumu.aizawa@gmail.com>

	* variable.c: [DOC] adding extra example in docs.
	  patched by Steve Klabnik. [Bug #9210]

Sun Feb 16 00:54:50 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (Resolv::DNS::Resource::TXT#data): Return concatenated
	  string.
	  Patch by Ryan Brunner.  [ruby-core:58220] [Bug #9093]

Sun Feb 16 00:50:59 2014  Zachary Scott  <e@zzak.io>

	* ext/openssl/ossl_pkey_dh.c: Fixed typo by Sandor Szuecs [Bug #9243]

Sun Feb 16 00:47:36 2014  Zachary Scott  <e@zzak.io>

	* lib/xmlrpc/client.rb: [DOC] Remove note about SSL package on RAA
	  Since RAA has been deprecated, and the SSL package has been replaced
	  with net/https this statement is entirely false and should be
	  deleted. [Bug #9152]

Sun Feb 16 00:44:51 2014  Zachary Scott  <e@zzak.io>

	* lib/net/smtp.rb: [DOC] Remove dead link to RAA by Giorgos Tsiftsis
	  Fixes the following bugs: [Bug #9152] [Bug #9268] [Bug #9394]
	* lib/open-uri.rb: ditto

Sun Feb 16 00:27:04 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* hash.c (rb_hash_assoc): revert r42224. table->type->compare is
	  called only if hashes are matched.

	* test/ruby/test_hash.rb: add a test to check using #== to compare.

Sun Feb 16 00:27:04 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_initialize_copy): copy st_table type even if empty.
	  [ruby-core:56256] [Bug #8703]

Sun Feb 16 00:27:04 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_initialize_copy): clear old table before copy new
	  table.

Sun Feb 16 00:27:04 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (rb_hash_assoc): aggregate object can be initialized only
	  with link time constants.

Sun Feb 16 00:27:04 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* hash.c (rb_hash_assoc): performance improvement by replacing
	  compare function in RHASH(hash)->ntbl->type temporarily.

Sun Feb 16 00:01:16 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb: Ignore name servers which cause EAFNOSUPPORT on
	  socket creation.
	  Reported by Bjoern Rennhak.  [ruby-core:60442] [Bug #9477]

Sat Feb 15 23:58:31 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (Resolv::DNS::Message::MessageDecoder): Raise
	  DecodeError if no data before the limit.
	  Reported by Will Bryant.  [ruby-core:60557] [Bug #9498]

Sat Feb 15 23:46:31 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (IDSET_ATTRSET_FOR_INTERN): fix off-by-one bug.

	* parse.y (rb_enc_symname_type): junk ID succeeded by '=' is also
	  attrset ID.  [ruby-core:60668] [Bug #8756]

Sat Feb 15 23:42:04 2014  Richo Healy  <richo@psych0tik.net>

	* test/ruby/test_struct.rb: Add regression test for question marks and
	  bangs in struct members. [Closes GH-468]

Sat Feb 15 23:26:31 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* struct.c (new_struct): fix warning message, class name and encoding.

Sat Feb 15 16:08:26 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* struct.c (make_struct): avoid inadvertent symbol creation.
	  (rb_struct_aref): ditto.
	  (rb_struct_aset): ditto.

Sat Feb 15 15:32:46 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_insnhelper.c (vm_call_method): should check ci->me->flag of
	  a refining method in case the method is private.
	  [ruby-core:60111] [Bug #9452]

	* vm_method.c (make_method_entry_refined): set me->flag of a refined
	  method entry to NOEX_PUBLIC in case the original method is private
	  and it is refined as a public method.  The original flag is stored
	  in me->def->body.orig_me, so it's OK to make a refined method
	  entry public.  [ruby-core:60111] [Bug #9452]

	* test/ruby/test_refinement.rb: related tests.

Tue Feb 11 23:21:02 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/ruby/test_struct.rb (test_struct_question_mark): add a testcase
	  for Struct attribute with question mark. the patch was originally
	  written by Eric Wong [ruby-core:59095] [Backport #9248]

Tue Feb 11 23:21:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_id_attrset, intern_str): allow junk attrset ID for
	  Struct.

	* parse.y (rb_id_attrset): fix inconsistency with literals, allow
	  ID_ATTRSET and return it itself, but ID_JUNK cannot make ID_ATTRSET.
	  and raise a NameError instead of rb_bug() for invalid argument.

Tue Feb 11 23:21:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_enc_symname_type): allow ID_ATTRSET for ID_INSTANCE,
	  ID_GLOBAL, ID_CLASS, ID_JUNK too.  [Bug #8756]

Tue Feb 11 23:21:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_id_attrset): allow other than ID_ATTRSET.

	* parse.y (intern_str): ditto.  try stem ID for ID_INSTANCE,
	  ID_GLOBAL, ID_CLASS, ID_JUNK too.  [Bug #8756]

Tue Feb 11 23:21:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_id_attrset): check if the argument is valid type as an
	  attribute.

Tue Feb 11 00:26:19 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (GetLastError): already defined in windows.h on nowadays
	  cygwin, and caused the confliction with the system provided
	  definition on cygwin64.  by @kou1okada [Fixes GH-433].

Mon Feb 10 01:15:10 2014  Kouhei Sutou  <kou@cozmixng.org>

	* ext/socket/raddrinfo.c (nogvl_getaddrinfo): Fix indent.

Mon Feb 10 01:15:10 2014  Kouhei Sutou  <kou@cozmixng.org>

	* ext/socket/raddrinfo.c (nogvl_getaddrinfo): Add missing return
	  value assignment.

Mon Feb 10 01:15:10 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/socket/raddrinfo.c (nogvl_getaddrinfo): work around for Ubuntu
	  13.04's getaddrinfo issue with mdns4. [ruby-list:49420]

Mon Feb 10 00:42:12 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* ext/thread/thread.c (rb_szqueue_clear): notify SZQUEUE_WAITERS
	  on SizedQueue#clear. [ruby-core:59462] [Bug #9342]

	* test/thread/test_queue.rb: add test. the patch is from
	  Justin Collins.

Mon Feb 10 00:27:33 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (local_push_gen, local_pop_gen): save cmdarg_stack to
	  isolate command argument state from outer scope.
	  [ruby-core:59342] [Bug #9308]

Mon Feb 10 00:02:18 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (glob_helper): don't skip current directories if FNM_DOTMATCH
	  is given.  [ruby-core:53108] [Bug #8006]

Wed Feb  5 23:39:36 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (intern_str): sigil only names are junk, at least one
	  identifier character is needed.  [ruby-dev:47723] [Bug #8928]

	* parse.y (rb_enc_symname_type): fix out of bound access.

Wed Feb  5 22:54:52 2014  Kazuki Tsujimoto  <kazuki@callcc.net>

	* time.c (get_timeval, get_new_timeval): use rb_obj_class()
	  instead of CLASS_OF() because CLASS_OF() may return
	  a singleton class.

Sun Feb 2 05:48:42 2014  Eric Wong <e@80x24.org>

	* io.c (rb_io_syswrite): add RB_GC_GUARD
	  [Bug #9472][ruby-core:60407]

Fri Jan 31 00:51:50 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* configure.in: use $@ instead of $(.TARGET) because .TARGET is not
	  supported by GNU make.

Fri Jan 31 00:49:41 2014  Yamashita Yuu  <yamashita@geishatokyo.com>

	* ext/openssl/ossl_ssl.c (Init_ossl_ssl): Declare a constant
	  `OP_MSIE_SSLV2_RSA_PADDING` only if the macro is defined.  The
	  `SSL_OP_MSIE_SSLV2_RSA_PADDING` has been removed from latest
	  snapshot of OpenSSL 1.0.1.  [Fixes GH-488]

Thu Jan 23 21:08:16 2014  Shota Fukumori  <her@sorah.jp>

	* vm_insnhelper.c (check_match): Fix SEGV with VM_CHECKMATCH_TYPE_CASE
	  and class of `pattern` has `method_missing`
	  [Bug #8882] [ruby-core:58606]

Mon Jan 20 01:02:18 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (CLASS_NAME): macro to wrap
	  depending on PRIsVALUE for 1.9.  [Backport #9406]

	* ext/bigdecimal/bigdecimal.c (DECIMAL_SIZE_OF_BITS): fallback
	  definition for 2.1 or older.  [ruby-core:59750] [Backport #9406]

Sun Jan 12 22:46:49 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	patch inspired from r44260 on trunk. [ruby-core:58652] [Bug #9168]

	* gc.c (run_finalizer): clear th->errinfo before invoke finalizer and
	  restore afterward.

	* test/ruby/test_gc.rb (test_exception_in_finalizer): add test for
	  above.

	* vm_trace.c (rb_threadptr_exec_event_hooks_orig): clear th->errinfo
	  before invoke hook.

Sun Jan 12 16:07:52 2014  vo.x (Vit Ondruch)  <vondruch@redhat.com>

	* tool/rbinstall.rb (Gem::Specification#collect): make stable
	  Gem::Specification.files in default .gemspecs the different order of
	  "files" in .gemspec files makes them different therefore possibly
	  conflicting in multilib scenario.  patch by vo.x (Vit Ondruch) at
	  [ruby-core:57544] [Bug #8623].

Sun Jan 12 16:01:54 2014  Tanaka Akira  <akr@fsij.org>

	* test/openssl/test_cipher.rb (test_aes_gcm_wrong_tag): Don't use
	  String#succ because it can make modified (wrong) auth_tag longer
	  than 16 bytes.  The longer auth_tag makes that
	  EVP_CIPHER_CTX_ctrl (and internally aes_gcm_ctrl) fail.
	  [ruby-core:55143] [Bug #8439] reported by Vit Ondruch.

Sun Jan 12 15:33:11 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* util.c (ruby_qsort): fix potential stack overflow on a large
	  machine.  based on the patch by Conrad Irwin <conrad.irwin AT
	  gmail.com> at [ruby-core:51816].  [Bug #7772]

Sun Jan 12 15:17:00 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/tk/tkutil/tkutil.c: use rb_sprintf(), rb_id2str(), and
	  rb_intern_str() instead of rb_intern() and RSTRING_PTR() with
	  RB_GC_GUARD(), to prevent temporary objects from GC.
	  [ruby-core:39000] [Bug #5199]

Tue Jan  7 01:16:34 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (mnew_from_me): keep iclass as-is, to make inheritance
	  chain consistent.  [ruby-core:59358] [Bug #9315]

	* proc.c (method_owner): return the original defined_class from
	  prepended iclass, instead.

Tue Jan  7 01:16:34 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_search_super_method): direct superclass of a
	  module is found when super called in a Method object generated a
	  method defined in a module, call method_missing in that case.
	  [ruby-core:59358] [Bug #9315]

Fri Jan  3 22:25:23 2014  Aman Gupta <ruby@tmm1.net>

	* test/net/imap/cacert.pem: generate new CA cert, since the last one
	  expired. [Bug #9341] [ruby-core:59459]
	* test/net/imap/server.crt: new server cert signed with updated CA.
	* test/net/imap/Makefile: add `make regen_certs` to automate this
	  process.

Wed Dec 25 00:46:44 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/net/smtp.rb (Net::SMTP#critical):  Always return a
	  Net::SMTP::Response.  Patch by Pawel Veselov.
	  [ruby-trunk - Bug #9125]
	* test/net/smtp/test_smtp.rb:  Test for the above.

Wed Dec 25 00:18:19 2013  Tanaka Akira  <akr@fsij.org>

	* ext/socket/lib/socket.rb: Don't test $! in "ensure" clause because
	  it may be set before the body.
	  Reported by ko1 and mrkn.  [ruby-core:59088] [Bug #9247]

	* lib/cgi/core.rb: Ditto.

	* lib/drb/ssl.rb: Ditto.

Tue Dec 24 00:18:14 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (configuration): strip destdir part from prefix to get
	  rid of duplication.  a patch by arton at [ruby-core:58859].
	  [ruby-core:58856] [Bug #9213]

Mon Dec 23 22:37:01 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (mnew_from_me): method by respond_to_missing? should be
	  owned by the original class.

Sun Dec 22 22:56:06 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (mnew_from_me): achieve the original defined_class from
	  prepended iclass, to fix inherited owner.

	* proc.c (method_owner): return the defined class, but not the
	  class which the method object is created from.

Sun Dec 22 22:56:06 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (method_owner): return the class where alias is defined, not
	  the class original method is defined.

	* vm_method.c (rb_method_entry_make, rb_alias): store the originally
	  defined class in me.  [Bug #7993] [Bug #7842] [Bug #9236]

	* vm_method.c (rb_method_entry_get_without_cache): cache included
	  module but not iclass.

Sun Dec 22 00:07:09 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* insns.def: Fix optimization bug of Float#/ [Bug #9238]

Sat Dec 21 23:13:55 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval_jump.c (rb_exec_end_proc): unlink and free procs data before
	  calling for each procs.  [Bug #9110]

Sat Dec 21 23:13:55 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* eval_jump.c (rb_exec_end_proc): fix double free or corruption error
	  when reentering by callcc. [ruby-core:58329] [Bug #9110]

	* test/ruby/test_beginendblock.rb: test for above.

Sat Dec 21 22:55:03 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/resolv.rb (Resolv::Hosts#lazy_initialize): should not
	  consider encodings in hosts file.  [ruby-core:59239] [Bug #9273]

	* lib/resolv.rb (Resolv::Config.parse_resolv_conf): ditto.

Sat Dec 21 22:51:51 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (fake.rb): fixed wrong RUBY_PLATFORM, to correctly
	  install win32.h.
	  [ruby-core:58801][Bug #9199] reported by arton.

Sat Dec 21 16:16:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (finalize_deferred): flush all deferred finalizers while other
	  finalizers can get ready to run newly by lazy sweep.
	  [ruby-core:58833] [Bug #9205]

Sat Dec 21 16:07:00 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby_atomic.h (ATOMIC_PTR_EXCHANGE): atomic exchange function for
	  a generic pointer.

Sat Dec 21 15:50:13 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* ruby_atomic.h: remove duplicate definisions between ATOMIC_XXX
	  and ATOMIC_SIZE_XXX.

Sat Dec 21 15:50:13 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* ruby_atomic.h: define ATOMIC_SIZE_CAS() with
	  __atomic_compare_exchange_n() and refactoring.

Sat Dec 21 15:50:13 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* ruby_atomic.h: use __atomic builtin functions supported by GCC.
	  __sync family are legacy functions now and it is recommended
	  that new code use the __atomic functions.
	  http://gcc.gnu.org/onlinedocs/gcc/_005f_005fatomic-Builtins.html

	* configure.in: check existence of __atomic functions.

Sat Dec 21 15:37:11 2013  Naohisa Goto  <ngotogenome@gmail.com>

	* ruby_atomic.h (ATOMIC_SIZE_CAS): fix compile error on Solaris
	  since r43460.

Sat Dec 21 15:37:11 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby_atomic.h (ATOMIC_SIZE_CAS): new macro, compare and swap size_t.

Sat Dec 21 15:37:11 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby_atomic.h (rb_w32_atomic_cas): call InterlockedCompareExchange
	  directly.

	* ruby_atomic.h (ATOMIC_CAS): fix missing function call.

Sat Dec 21 15:37:11 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby_atomic.h (ATOMIC_CAS): suppress C4022 and C4047 warnings in
	  VC6.  only InterlockedCompareExchange is declared using PVOID.

Sat Dec 21 14:54:37 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/bigdecimal/lib/bigdecimal/util.rb: [DOC] remove example of
	  Rational#to_d without argument. [Bug #8958]

Sat Dec 21 14:54:37 2013  Zachary Scott  <e@zzak.io>

	* ext/bigdecimal/lib/bigdecimal/util.rb: [DOC] +precision+ is required

Sat Dec 21 14:54:37 2013  Zachary Scott  <e@zzak.io>

	* ext/bigdecimal/lib/bigdecimal/util.rb: [DOC] Document the required
	  +precision+ argument for Rational#to_d [Bug #8958]

Sat Dec 21 03:46:14 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_strptime.c (date__strptime_internal): unset
	  case-insensitive flag for [:alpha:], which already implies both
	  cases, to get rid of backtrack explosion.  [ruby-core:58984]
	  [Bug #9221]

Sat Dec 21 03:46:14 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_parse.c (parse_time): unset case-insensitive flag
	  for [:alpha:], which already implies both cases, to get rid of
	  backtrack explosion.  [ruby-core:58876] [Bug #9221]

Fri Dec 13 00:23:01 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* enumerator.c (enumerator_with_index): try to convert given offset to
	  integer. fix bug introduced in r39594.

Mon Dec  2 23:31:00 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enumerator.c (enumerator_with_index): should not store local variable
	  address to memoise the arguments.  it is invalidated after the return.
	  [ruby-core:58692] [Bug #9178]

Mon Dec  2 23:16:50 2013  Eric Hodel  <drbrain@segment7.net>

	* enumerator.c (enumerator_with_index):  Restore handling of a nil memo
	  from r39594.

Mon Dec  2 22:53:05 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_readlink): fix buffer overflow on a long symlink. since
	  rb_str_modify_expand() expands from its length but not its capacity,
	  need to set the length properly for each expansion.
	  [ruby-core:58592] [Bug #9157]

Fri Nov 29 00:31:46 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (Doxyfile): tool/file2lastrev.rb needs running with
	  BASERUBY since r43617.  [ruby-dev:47823] [Bug #9169]

Fri Nov 22 13:18:28 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* util.c (ruby_strtod): BigMath requires more precision.

Fri Nov 22 12:46:08 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* util.c (ruby_strtod): ignore too long fraction part, which does not
	  affect the result.

Wed Nov 20 15:20:00 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/ruby/test_thread.rb (test_mutex_unlock_on_trap): extend waiting
	  time to invocation of signal handler from 0.01 sec to 0.2 sec.
	  RubyCI report error on mswin. reported by @unak

Wed Nov 13 11:57:01 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems: Update to RubyGems 2.0.14. [ruby-core:58300]
	  [Backport #9104]
	  the patch is provided by drbrain (Eric Hodel).

Tue Nov 12 23:41:43 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (rb_feature_p): deal with default loadable suffixes.

	* load.c (load_lock): initialize statically linked extensions.

	* load.c (search_required, rb_require_safe): deal with statically
	  linked extensions.

	* load.c (ruby_init_ext): defer initialization of statically linked
	  extensions until required actually.  [Bug #8883]

Tue Nov 12 23:41:43 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (ruby_init_ext): share feature names between frame name and
	  provided features.

Tue Nov 12 23:33:08 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/rbinstall.rb (Gem::Specification.load): obtain spec date from
	  VCS for the case using git, RUBY_RELEASE_DATE is the last resort.
	  probably fixes [Bug #9085].

Tue Nov 12 23:24:35 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (RUNRUBY): append -- only after runruby.rb, not
	  cross-compiling baseruby, so that $(RUN_OPT) can be command line
	  options.  [ruby-dev:47703] [Bug #8893]

Tue Nov 12 23:24:35 2013  Masaki Matsushita  <glass.saga@gmail.com>

	(partially merged from r42862)
	* common.mk: use RUNRUBY instead of MINIRUBY because MINIRUBY can't
	  require extension libraries. The patch is from nobu
	  (Nobuyoshi Nakada).

Mon Nov 11 23:54:51 2013  Tanaka Akira  <akr@fsij.org>

	* ext/socket/init.c (cloexec_accept): Fix a compile error on
	  Debian GNU/kFreeBSD.  Consider HAVE_ACCEPT4 is defined
	  but SOCK_CLOEXEC is not defined.

Mon Nov 11 22:14:37 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/win32.h (rb_infinity_float): suppress overflow in
	  constant arithmetic warnings.  [ruby-core:57981] [Bug #9044]

Mon Nov 11 22:14:37 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/Makefile.sub (config.h): VC 2013 supports C99 mathematics
	  functions.  [ruby-core:57981] [Bug #9044]

Thu Oct 31 22:28:04 2013  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* test/openssl/test_pkey_ec.rb: Skip tests for "Oakley" curves as
	  they are not suitable for ECDSA.
	  [ruby-core:54881] [Bug #8384]

Thu Oct 31 22:28:04 2013  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* ext/openssl/ossl_pkey_ec.c: Ensure compatibility to builds of
	  OpenSSL with OPENSSL_NO_EC2M defined, but OPENSSL_NO_EC not
	  defined.
	* test/openssl/test_pkey_ec.rb: Iterate over built-in curves
	  (and assert their non-emptiness!) instead of hard-coding them, as
	  this may cause problems with respect to the different availability
	  of individual curves in individual OpenSSL builds.
	  [ruby-core:54881] [Bug #8384]

	  Thanks to Vit Ondruch for providing the patch!

Sun Oct 27 01:04:28 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems: Update to RubyGems 2.0.13. [ruby-core:58031]
	  [Backport #9052]
	  the patch is provided by drbrain (Eric Hodel).

Sat Oct 26 16:04:36 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* gc.c (gc_prof_set_heap_info): fix compile error when
	  GC_PROFILE_MORE_DETAIL != 0.
	  the patch is provided by ko1 (Koichi Sasada).

Thu Oct 24 23:27:12 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems: Update to RubyGems 2.0.12. [ruby-core:57818]
	  [Backport #9014]
	  the patch is provided by drbrain (Eric Hodel).

Thu Oct 24 22:49:28 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* parse.y: Remove +(binary) and -(binary) special cases
	  [Feature #9048]

Thu Oct 24 22:36:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (load_encoding): should preserve outer errinfo, so that
	  expected exception may not be lost.  [ruby-core:57949] [Bug #9038]

Fri Oct 18 02:10:00 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_insnhelper.c (vm_call_method): set ci->me to 0 when the
	  original method of a refined method is undef to avoid SEGV.

	* vm_method.c (rb_method_entry_without_refinements): return 0 when
	  the original method of a refined method is undef to avoid SEGV.

	* test/ruby/test_refinement.rb: related test.

Fri Oct 18 02:05:45 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/file.c (rb_file_expand_path_internal): fix memory leaks at
	  a non-absolute home exception.

Thu Oct 10 01:14:37 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compar.c (cmp_eq): fail if recursion.  [ruby-core:57736] [Bug #9003]

	* thread.c (rb_exec_recursive_paired_outer): new function which is
	  combinnation of paired and outer variants.

Thu Oct 10 01:07:37 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/tempfile.rb (Tempfile#unlink): finalizer is no longer needed
	  after unlinking.  patched by by normalperson (Eric Wong) at
	  [ruby-core:56521] [Bug #8768]

Thu Oct 10 00:58:39 2013  Benoit Daloze  <eregontp@gmail.com>

	* test/ruby/test_array.rb (test_count): add a test case for #count
	  with an argument. See Bug #8654.

Thu Oct 10 00:58:39 2013  Benoit Daloze  <eregontp@gmail.com>

	* array.c (rb_ary_count): check length to avoid SEGV
	  while iterating. Remove other pointer loop when arg is given.

	* test/ruby/test_array.rb (test_count): add test for bug.
	  [ruby-core:56072] [Bug #8654]

Thu Oct 10 00:58:39 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_count): iterate items appropriately.
	  [Bug #8654]

Thu Oct 10 00:44:28 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (rb_fork_internal): remove cloexec setting on pipes
	  created by rb_cloexec_pipe.  patch by normalperson (Eric Wong) at
	  [ruby-core:56523].  [Bug #8769]

Thu Oct 10 00:24:01 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c: disable FIBER_USE_NATIVE on GNU/Hurd because it doesn't
	  support a combination getcontext() and threads. Patch by
	  Gabriele Giacone (1o5g4r8o@gmail.com). [Bug #8990][ruby-core:57685]

Mon Oct  7 21:03:54 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in, win32/Makefile.sub (FIBER_USE_NATIVE): move conditions
	  from cont.c

Thu Oct 10 00:17:56 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/dl/test_base.rb: {libc, libm} detection now handle GNU/Hurd
	  correctly. Patch by Gabriele Giacone (1o5g4r8o@gmail.com).
	  [Bug #8937][ruby-core:57311]
	* test/fiddle/helper.rb: ditto.

Thu Oct 10 00:00:30 2013  Tanaka Akira  <akr@fsij.org>

	* lib/time.rb (Time.strptime): Time.strptime('0', '%s') returns local
	  time Time object as Ruby 2.0 and before.

Thu Oct 10 00:00:30 2013  Tanaka Akira  <akr@fsij.org>

	* lib/time.rb (Time.strptime): Use :offset.
	  Patch by Felipe Contreras.  [ruby-core:57694]

Wed Oct  9 23:32:37 2013  Koichi Sasada  <ko1@atdot.net>

	* gc.c (rb_gc_disable): do rest_sweep() before disable GC.
	  This fix may solve a failure of
	  TestTracepointObj#test_tracks_objspace_events
	  [test/-ext-/tracepoint/test_tracepoint.rb:43].

Sat Oct  5 02:14:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_close_read): duplex IO should wait its child process
	  even after close_read.

Sat Oct  5 02:14:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_close_read): keep fptr in write_io to be discarded, to
	  fix freed pointer access when it is in use by other threads, and get
	  rid of potential memory/fd leak.

Sat Oct  5 01:59:50 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_method.c (rb_undef): raise a NameError if the original method
	  of a refined method is not defined.

	* vm_insnhelper.c (rb_method_entry_eq): added NULL check to avoid SEGV.

	* test/ruby/test_refinement.rb: related test.

Sat Oct  5 00:16:33 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* process.c (rb_daemon): daemon(3) is implemented with fork(2).
	  Therefore it needs rb_thread_atfork(). (and revert r41903)

Sat Oct  5 00:16:33 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (fork_daemon): kill the other threads all and abandon the
	  kept mutexes.

Sat Oct  5 00:16:33 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (fork_daemon): kill the other threads all and abandon the
	  kept mutexes.

Tue Oct  1 00:28:40 2013  SHIBATA Hiroshi  <shibata.hiroshi@gmail.com>

	* tool/make-snapshot: Fix order of priority for option parameter.

Sat Sep 28 21:40:40 2013  Kenichi Kamiya  <kachick1@gmail.com>

	* random.c (rb_random_ulong_limited): coerce before check negative.
	  [Fixes GH-379]

Fri Sep 27 01:24:20 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems: Update to Rubygems 2.0.10. [ruby-core:57360]
	  [Backport #8950]
	  the patch is provided by drbrain (Eric Hodel).
	  this update contains a security fix for CVE-2013-4363.

Fri Sep 27 01:11:21 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (lambda): adjust position to the beginning of the block.

Fri Sep 27 01:02:59 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/generic.rb (URI::Generic.find_proxy): return nil if
	  http_proxy environment variable is empty string.
	  [ruby-core:57140] [Bug #8898]

Fri Sep 27 00:58:57 2013  Zachary Scott  <e@zzak.io>

	* lib/gserver.rb: [DOC] correct gserver.rb license [Bug #8913]

Sun Sep 15 23:15:32 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems: Update to Rubygems 2.0.9. [ruby-core:57183]
	  [Backport #8908]
	  the patch is provided by drbrain (Eric Hodel).

Sun Sep 15 22:59:04 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/rbinstall.rb (Gem::Specification#initialize): default date to
	  RUBY_RELEASE_DATE.  [ruby-core:57072] [Bug #8878]

	* tool/rbinstall.rb (Gem::Specification#to_ruby): add date.

Sun Sep 15 22:55:44 2013  Zachary Scott  <e@zzak.io>

	* hash.c (rb_hash_aset): [DOC] Document key dup patch by @kachick
	  [Fixes GH-382] https://github.com/ruby/ruby/pull/382

Sun Sep 15 22:03:01 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vsnprintf.c (MAXEXP, MAXFRACT): calculate depending on constants in
	  float.h.

	* vsnprintf.c (BSD_vfprintf): limit length for cvt() to get rid of
	  buffer overflow.  [ruby-core:57023] [Bug #8864]

	* vsnprintf.c (exponent): make expbuf size more precise.

Sat Sep 14 00:01:20 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems: Update to RubyGems 2.0.8. [ruby-core:57155]
	  [Backport #8900]
	  the patch is provided by drbrain (Eric Hodel).
	  this update contains a security fix for CVE-2013-4287.

Fri Sep 13 23:20:29 2013  Kenichi Kamiya  <kachick1@gmail.com>

	* object.c (Init_Object): undef Module#prepend_features on Class, as
	  well as Module#append_features.  [Fixes GH-376]

	* test_class.rb: Added test for above. And ensure type checking
	  on similar methods as module_function.

Fri Sep 13 23:16:12 2013  Zachary Scott  <e@zzak.io>

	* enumerator.c: [DOC] Remove reference to Enumerator::Lazy#cycle
	  Patch by @kachick [Fixes GH-372]
	  https://github.com/ruby/ruby/pull/372

Fri Sep 13 22:40:28 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_search_super_method): use ci->argc instead of
	  ci->orig_argc. ci->argc can be changed by splat arguments.
	  [ruby-list:49575]
	  This fix should be applied to Ruby 2.0.0 series.

	* test/ruby/test_super.rb: add a test for above.

Fri Sep 13 01:44:54 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_mutex_unlock): Mutex#unlock no longer raise
	  an exception even if uses on trap. [Bug #8891]

Fri Sep 13 01:09:59 2013  Shota Fukumori  <sorah@tubusu.net>

	* vm_backtrace.c (vm_backtrace_to_ary): Ignore the second argument if
	  it is nil. [Bug #8884] [ruby-core:57094]

	* test/ruby/test_backtrace.rb (test_caller_with_nil_length):
	  Test for above.

Fri Sep 13 00:57:54 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (method_entry_i): should exclude refined methods from
	  instance method list.  [ruby-core:57080] [Bug #8881]

Fri Sep 13 00:33:09 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* vm_eval.c (vm_call0): fix prototype, the id parameter should be of
	  type ID, not VALUE

	* vm_insnhelper.c (check_match): the rb_funcall family of functions
	  does not care about refinements. We need to use
	  rb_method_entry_with_refinements instead to call === with
	  refinements. Thanks to Jon Conley for reporting this bug.
	  [ruby-core:57051] [Bug #8872]

	* test/ruby/test_refinement.rb: add test

Fri Sep 13 00:18:55 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enumerator.c (lazy_zip_func): fix non-single argument.  fix
	  out-of-bound access and pack multiple yielded values.
	  [ruby-core:56383] [Bug #8735]

Thu Sep 12 01:44:01 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (str_gsub): use BEG(0) for whole matched position not
	  return value from rb_reg_search(), for \K matching.
	  [ruby-dev:47694] [Bug #8856]

Thu Sep 12 01:34:07 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* object.c (rb_class_inherited_p): allow iclasses to be tested for
	  inheritance. [Bug #8686] [ruby-core:56174]

	* test/ruby/test_method.rb: add test

Thu Sep 12 01:18:44 2013  Michal Rokos  <michal@rokos.cz>

	* configure.in (sys/pstat.h): fix missing header check for
	  missing/setproctitle.c on HP-UX.  [ruby-core:56644] [Bug #8792]

Thu Sep 12 01:02:56 2013  Benoit Daloze  <eregontp@gmail.com>

	* test/ruby/test_time.rb: use the in_timezone() helper
	  and define it at the top with other helpers.

Thu Sep 12 01:02:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* time.c (time_mload): ignore auxiliary data, offset and zone, if
	  invalid.  [ruby-core:56648] [Bug #8795]

Thu Sep 12 00:22:22 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* variable.c (classname): the name of class that has
	  non class id should not be nil. This bug was introduced
	  in r36577.

	* test/thread/test_cv.rb: test for change.

Thu Aug 29 21:51:33 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/zlib/zlib.c (zstream_run):  Fix handling of deflate streams that
	  need a dictionary but are being decompressed by Zlib::Inflate.inflate
	  (which has no option to set a dictionary).  Now Zlib::NeedDict is
	  raised instead of crashing.  [ruby-trunk - Bug #8829]
	* test/zlib/test_zlib.rb (TestZlibInflate):  Test for the above.

Thu Aug 29 21:28:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_call_method): a method entry refers the based
	  class/module, so should search superclass from the origin i-class
	  where the entry belongs to, to get rid of infinite loop when zsuper
	  in a prepended class/module.  [ruby-core:54105] [Bug #8238]

Fri Aug 23 01:16:00 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_parse.c (rfc2822_cb): check if wday is given, since it
	  can be omitted.

Fri Aug 23 00:55:02 2013  Tanaka Akira  <akr@fsij.org>

	* gc.c (getrusage_time): Fallback clock_gettime to getrusage when
	  clock_gettime fails.
	  Reported by Eric Saxby.  [ruby-core:56762] [Bug #8805]
	  
Sat Aug 17 00:42:12 2013  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* parse.y: fix build error with bison-3.0.

Sat Aug 17 00:39:20 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/webrick/test_cgi.rb (TestWEBrickCGI#{start_cgi_server,test_cgi}):
	  mswin is not only mswin32 but also mswin64. [Bug #8746]

Sat Aug 17 00:36:24 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* test/openssl/test_ssl.rb: Fix test for CVE-2013-4073.
	  Patch by Antonio Terceiro. [Bug #8750] [ruby-core:56437]

Sat Aug 17 00:32:17 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems: update to RubyGems 2.0.7. the patch by drbrain.
	  [ruby-core:56633] [Backport #8787]

Sat Aug 10 23:59:47 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/coverage/test_coverage.rb (TestCoverage#test_big_code): use `1'
	  instead of `p' to get rid of a side effect.
	  Kernel#p without any argument seems to do nothing, but flushes stdout.
	  and, if stdout is redirected to file, fsync() will be called on
	  Windows.  so, when running test-all on Windows with redirection, such
	  as CI environment, this test took a lot of time.

Sun Aug  4 22:42:16 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (wrename): use MoveFileExW instead of MoveFileW,
	  because the latter fails on cross device file move of some
	  environments.
	  fix [ruby-core:53492] [Bug #8109]
	  reported by mitchellh (Mitchell Hashimoto)

Sat Aug  3 23:02:09 2013  Tanaka Akira  <akr@fsij.org>

	* ext/extmk.rb (extmake): Invoke Logging::log_close in a ensure
	  clause.

Sat Aug  3 23:02:09 2013  Tanaka Akira  <akr@fsij.org>

	* ext/extmk.rb (extmake): Use Logging.open to switch stdout and
	  stderr.  Delay Logging::log_close until the failure message is
	  written.  Write the failure message only if log file is opened.

	* lib/mkmf.rb (Logging.log_opened?): New method.

	  [ruby-dev:47215] [Bug #8209]

Sat Aug  3 22:46:19 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (xsystem): expand environment variable in all macros not
	  expanded with RbConfig.  [Bug #8702]

	* test/mkmf/test_framework.rb (create_framework): replace all $@ not
	  only once.

Sat Aug  3 22:40:57 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (have_framework): allow header file to check.
	  [ruby-core:55745] [Bug #8593]

Sat Aug  3 22:24:44 2013  Shota Fukumori  <her@sorah.jp>

	* lib/uri/common.rb (URI.decode_www_form_component):
	  Don't raise error when str includes multibyte characters.

Sun Jul 28 22:00:10 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* rational.c (f_round_common): Rational is expected to be returned by
	  Rational#*, but mathn.rb breaks that assumption.  [ruby-core:56177]
	  [Bug #8687]

Sun Jul 28 21:50:34 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* io.c (io_getpartial): use rb_str_locktmp_ensure().
	  [ruby-core:56121] [Bug #8669]

	* io.c (rb_io_sysread): ditto.

	* test/ruby/test_io.rb: add tests for above.

Sun Jul 28 21:50:34 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* string.c: add internal API rb_str_locktmp_ensure().

	* io.c (io_fread): use rb_str_locktmp_ensure().
	  [ruby-core:56121] [Bug #8669]

	* test/ruby/test_io.rb: add a test for above.

Sun Jul 28 21:44:57 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/openssl/ossl_asn1.c (asn1time_to_time):  Implement YYMMDDhhmmZ
	  format for ASN.1 UTCTime.  [ruby-trunk - Bug #8664]
	* test/openssl/test_asn1.rb:  Test for the above.

Fri Jul 26 00:38:58 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems: Update to RubyGems 2.0.6. [ruby-core:56160]
	  [Backport #8682]

Wed Jul 24 22:35:32 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/generic.rb (find_proxy): raise BadURIError if the URI is
	  a relative URI. [Bug #8645]

Wed Jul 24 01:13:02 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* include/ruby/intern.h (rb_f_lambde): restore the declaration of
	  rb_f_lambda() for backword compatibility. and mark it as deprecated.

Tue Jul 23 01:36:43 2013  Zachary Scott  <e@zzak.io>

	* lib/rubygems/psych_additions.rb: Ignore Psych docs here

Tue Jul 23 01:34:00 2013  Koichi Sasada  <ko1@atdot.net>

	* test/test_tracer.rb: catch up recent rubygems changes.

Tue Jul 23 01:28:54 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rubygems: Update to RubyGems 2.0.5.
	  The patch provided by drbrain (Eric Hodel). [ruby-core:55896]
	  [Backport #8617]

	* test/rubygems:  Tests for the above.

Tue Jul 23 00:00:27 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (eval_string_with_cref): use the given file name unless
	  eval even if scope is given.  additional fix for [Bug #8436].
	  based on the patch by srawlins at [ruby-core:56099] [Bug #8662].

Sat Jul 20 23:49:33 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/drb/drbtest.rb (Drb{Core,Ary}#teardown): retry Process.kill
	  if it fails with Errno::EPERM on Windows (workaround).
	  [ruby-dev:47245] [Bug #8251]

Sat Jul 20 23:31:11 2013  Aman Gupta  <tmm1@ruby-lang.org>

	* iseq.c (iseq_location_setup): re-use existing string when iseq has
	  the same path and absolute_path. [Bug #8149]

Sun Jul 14 00:18:08 2013  Zachary Scott  <e@zzak.io>

	* sprintf.c: Fix typo patch by @hynkle [Fixes GH-357]
	  https://github.com/ruby/ruby/pull/357

Sun Jul 14 00:17:07 2013  Zachary Scott  <zachary@zacharyscott.net>

	* man/ri.1: Incorrect use of .Dd macro [Bug #8620] by Tristan Hill

Sun Jul 14 00:15:26 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/logger.rb: Use :call-seq: for method signature rdoc

Sun Jul 14 00:13:01 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/net/http/test_http.rb (TestNetHTTP_v1_2#test_get,
	  TestNetHTTP_v1_2_chunked#test_get): shouldn't check
	  HttpResponse#decode_content if Zlib is not available.
	  ko1 complained via IRC.

Sat Jul 13 23:50:00 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: fixed coding error [ruby-core:55337].
	  reported by Riley Lynch.

Sat Jul 13 23:50:00 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: fixed a bug [ruby-core:55295].  reported
	  by Riley Lynch.

Sat Jul 13 23:41:25 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_parse.c (date_zone_to_diff): [ruby-core:55831].

Sat Jul 13 23:34:13 2013  Akinori MUSHA  <knu@iDaemons.org>

	* object.c: Fix rdoc for Kernel#<=>. [Fix GH-352]

Sat Jul 13 23:29:51 2013  Akinori MUSHA  <knu@iDaemons.org>

	* lib/fileutils.rb (FileUtils#mode_to_s): Define mode_to_s() also
	  as singleton method, or FileUtils.chmod fails in verbose mode.

Sat Jul 13 23:27:12 2013  Akinori MUSHA  <knu@iDaemons.org>

	* lib/fileutils.rb (FileUtils#chown, FileUtils#chown_R): If user
	  and group are both nil, print ":".

Sat Jul 13 23:16:49 2013  Tanaka Akira  <akr@fsij.org>

	* bignum.c (bigrsh_bang): Fix bignum digits overrun.

Sat Jul 13 23:16:49 2013  Tanaka Akira  <akr@fsij.org>

	* bignum.c (biglsh_bang): Fix bignum digits under-run.

Sat Jul 13 22:45:10 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (RUBY_DTRACE_POSTPROCESS): dtrace version SUN D 1.11
	  introduces a check in the dtrace compiler to ensure that probes
	  actually exist. If there are no probes, then the -G step will
	  fail. As this test is only being used to determine whether -G is
	  necessary (for instance, on OSX it is not), adding a real probe to
	  the conftest allows it to succeed on newer versions of dtrace.
	  Patch by Eric Saxby <sax AT livinginthepast.org> at
	  [ruby-core:55826].  [Fix GH-351], [Bug #8606].

Sat Jul 13 22:41:20 2013  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* test/openssl/test_x509crl.rb: Remove unused variable.
	  [ruby-core:53501] [Bug #8114]

	  Thanks, Vipul Amler, for pointing this out!

Sun Jul  7 02:00:41 2013  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* lib/openssl/ssl.rb: Fix SSL client connection crash for SAN marked
	  critical.
	  The patch for CVE-2013-4073 caused SSL crash when a SSL server returns
	  the certificate that has critical SAN value.  X509 extension could
	  include 2 or 3 elements in it:

	  [id, criticality, octet_string] if critical,
	  [id, octet_string] if not.

	  Making sure to pick the last element of X509 extension and use it as
	  SAN value.
	  [ruby-core:55685] [Bug #8575]

	  Thank you @nahi for providing the patch!

Sun Jul  7 01:58:25 2013  Akinori MUSHA  <knu@iDaemons.org>

	* lib/fileutils.rb (FileUtils#symbolic_modes_to_i): Fix the wrong
	  character class [+-=], which happened to match all desired
	  characters but also match undesired characters.

Sun Jul  7 01:54:44 2013  Akinori MUSHA  <knu@iDaemons.org>

	* lib/fileutils.rb (FileUtils#chown, FileUtils#chown_R): Fix the
	  wrong output message when user is nil, which should be "chown
	  :group file" instead of "chown group file".

Fri Jul  5 00:55:05 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* regcomp.c (): Merge Onigmo 5.13.5 23b523076d6f1161.

	  * [bug]  (thanks Akinori MUSHA and Ippei Obayashi)
	           Fix a renumbering bug in condition regexp with a named
	           capture. [Bug #8583]
	  * [spec] (thanks Akinori MUSHA)
	    Allow ENCLOSE_OPTION in look-behind.

Wed Jul  3 23:31:26 2013  Shota Fukumori  <sorah@cookpad.com>

	* lib/mkmf.rb (try_config): Fix to not replace $LDFLAGS with $libs
	  (1.9.3 behavior) [ruby-core:55752] [Bug #8595]

Tue Jul  2 03:06:38 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigMath_s_exp): Fix for the cases when
	  the argument x is not a BigDecimal.
	  This change is based on the patch made by Heesob Park and Garth Snyder.
	  [Bug #6862] [ruby-core:47145]
	  [Fix GH-332] https://github.com/ruby/ruby/pull/332

Fri Jun 28 02:20:13 2013  Aman Gupta  <ruby@tmm1.net>

	* compile.c (iseq_add_mark_object): Use new rb_iseq_add_mark_object().

	* insns.def (setinlinecache): Ditto.

	* iseq.c (rb_iseq_add_mark_object): New function to allocate
	  iseq->mark_ary on demand. [Bug #8142]

	* iseq.h (rb_iseq_add_mark_object): Ditto.

	* iseq.c (prepare_iseq_build): Avoid allocating mark_ary until needed.

	* iseq.c (rb_iseq_build_for_ruby2cext): Ditto.

Thu Jun 27 20:10:56 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/openssl/lib/openssl/ssl.rb (verify_certificate_identity): fix
	  hostname verification. Patched by nahi.

	* test/openssl/test_ssl.rb (test_verify_certificate_identity): test for
	  above.


Thu Jun 27 13:16:40 2013  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* test/rubygems/test_gem_installer.rb (test_install_extension_flat):
	  use ruby in build directory in case ruby is not installed.
	  [ruby-core:53265] [Bug #8058]

Wed Jun 26 23:05:34 2013  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* test/ruby/test_io.rb (TestIO#test_write_32bit_boundary): skip if
	  writing a file is slow.
	  [ruby-core:55541] [Bug #8519]

Wed Jun 26 22:42:36 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb: should use expanded values for header directories
	  unless extmk.  patch by vo.x (Vit Ondruch) at [ruby-core:55653]
	  [Bug #8115], rhbz#921650.

Wed Jun 26 02:25:52 2013  Akinori MUSHA  <knu@iDaemons.org>

	* lib/rubygems/ext/builder.rb (Gem::Ext::Builder.make): Pass
	  DESTDIR via command line to override what's in MAKEFLAGS.  This
	  fixes an installation problem under a package building
	  environment where DESTDIR is specified in the (parent) command
	  line. [Fixes GH-327]

Tue Jun 25 00:12:19 2013  Zachary Scott  <zachary@zacharyscott.net>

	* array.c: Return value in Array overview example found by @PragTob
	  [Fix GH-336] https://github.com/ruby/ruby/pull/336

Tue Jun 25 00:11:46 2013  Zachary Scott  <zachary@zacharyscott.net>

	* array.c (rb_ary_zip): typo by @PragTob [Fix GH-337]
	  https://github.com/ruby/ruby/pull/337

Tue Jun 25 00:10:54 2013  Zachary Scott  <zachary@zacharyscott.net>

	* win32/README.win32: grammar typo by @blankenshipz [Fix GH-334]
	  https://github.com/ruby/ruby/pull/334

Sun Jun 23 00:03:18 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* ext/etc/etc.c (etc_getpwnam): use PRIsVALUE in format string instead
	  of %s and RSTRING_PTR

	* ext/etc/etc.c (etc_getgrnam): ditto

Sat Jun 22 00:54:41 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems 2.0.3

	* test/rubygems:  Tests for the above.

	* NEWS:  Added RubyGems 2.0.3 note.

Wed Jun 19 04:20:31 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* vm_insnhelper.c (vm_call_method): ensure methods of type
	  VM_METHOD_TYPE_ATTR_SET are called with 1 argument

	* test/ruby/test_module.rb (class TestModule): add test

	[ruby-core:55543] [Bug #8540]

Wed Jun 19 03:54:04 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* defs/id.def (predefined): add "idProc".

	* proc.c (mnew, mproc, mlambda): use predefined IDs.

	* vm.c (Init_VM): ditto.

Wed Jun 19 03:54:04 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/intern.h (rb_block_lambda): add declaration instead of
	  deprecated rb_f_lambda.

Wed Jun 19 03:24:07 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* include/ruby/ruby.h, vm_eval.c (rb_funcall_with_block):
	  new function to invoke a method with a block passed
	  as an argument.

	* string.c (sym_call): use the above function to avoid
	  a block sharing. [ruby-dev:47438] [Bug #8531]

	* vm_insnhelper.c (vm_yield_with_cfunc): don't set block
	  in the frame.

	* test/ruby/test_symbol.rb (TestSymbol#test_block_given_to_proc):
	  run related tests.

Wed Jun 19 03:06:57 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* test/ruby/test_proc.rb (TestProc#test_block_given_method_to_proc):
	  run test for r41359.

Wed Jun 19 03:06:57 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* include/ruby/intern.h, proc.c (rb_method_call_with_block):
	  new function to invoke a Method object with a block passed
	  as an argument.

	* proc.c (bmcall): use the above function to avoid a block sharing.
	  [ruby-core:54626] [Bug #8341]

	* test/ruby/test_proc.rb (TestProc#test_block_persist_between_calls):
	  run related tests.

Tue Jun 18 02:49:20 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/ruby/envutil.rb (assert_separately): stop_auto_run of
	  Test::Unit::Runner to prevent auto runner use ARGV.

	* test/ruby/envutil.rb (assert_separately): add $: to separate process.

	* test/ruby/envutil.rb (assert_separately): fail if stderr is not
	  empty and ignore_stderr is false.

Tue Jun 18 02:21:54 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/ruby/envutil.rb (EnvUtil.with_default_external): add for
	  changing Encoding.default_external without warnings.

	* test/ruby/envutil.rb (EnvUtil.with_default_internal): ditto.

	* test/ruby/test_io_m17n.rb: use above with_default_external.

Tue Jun 18 00:43:27 2013  Zachary Scott  <zachary@zacharyscott.net>

	* vm_backtrace.c: Update rdoc for Backtrace#label with @_ko1

Tue Jun 18 00:34:57 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

merge revision(s) 41347: [Backport #5048] [Backport #5465] [Backport #8319]

        * ext/tk/extconf.rb: support s390x (Thanks to bkabrda) [Bug #5465]

	* ext/tk/extconf.rb: apply [Bug #5048]

	* ext/tk/lib/tk/canvas.rb,ext/tk/sample/demos-{en,jp}/{tree.rb,widget}:
	  fix bug (Thanks to zzak) [ruby-trunk - Bug #8319]

Sun Jun 16 01:56:54 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (FL_SET_EMBED): shared object is frozen even when get
	  unshared.

	* array.c (rb_ary_modify): ARY_SET_CAPA needs unshared array.

Sun Jun 16 01:32:26 2013  TAKANO Mitsuhiro <tak@no32.tk>

	* insns.def: fix condition.

Sun Jun 16 01:22:35 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/socket/extconf.rb:  Enable RFC 3542 IPV6 socket options for OS X
	  10.7+.  [ruby-trunk - Bug #8517]

Sun Jun 16 01:11:10 2013  Koichi Sasada  <ko1@atdot.net>

	* compile.c (rb_iseq_compile_node): fix location of a `trace'
	  instruction (b_return event).
	  [ruby-core:55305] [ruby-trunk - Bug #8489]
	  (need a backport to 2.0.0?)

	* test/ruby/test_settracefunc.rb: add a test.

Sun Jun 16 00:30:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (eval_string_with_cref): propagate absolute path from the
	  binding if it is given explicitly.  patch by Gat (Dawid Janczak) at
	  [ruby-core:55123]. [Bug #8436]

Wed Jun 12 23:41:21 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* vm_insnhelper.c (vm_yield_setup_block_args): partially revert r41019.
	  The code is not useless.

Wed Jun 12 23:41:21 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_yield_setup_block_args): split single parameter
	  if any keyword arguments exist, and then extract keyword arguments.
	  [ruby-core:55203] [Bug #8463]

Wed Jun 12 23:05:41 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_getc): fix 7bit coderange condition, check if ascii read
	  data instead of read length. [ruby-core:55444] [Bug #8516]

Sun Jun  9 02:27:07 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (install_dirs, with_destdir): prefix with DESTDIR
	  directories to install only unless bundled extension libraries.
	  [ruby-core:53502] [Bug #8115]

Sun Jun  9 02:17:16 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* class.c (include_modules_at): invalidate method cache if included
	  module contains constants

	* test/ruby/test_module.rb: add test

Sun Jun  9 01:59:39 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

merge revision 40783 (partially): [Backport #8413]

	* win32/Makefile.sub: fix a typo in config.h.

Sun Jun  9 01:38:55 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* intern.h: remove dangling rb_class_init_copy declaration
	  [ruby-core:55120] [Bug #8434]

Sun Jun  9 01:30:57 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (capability_response): should ignore trailing
	  spaces.  Thanks, Peter Kovacs.  [ruby-core:55024] [Bug #8415]

	* test/net/imap/test_imap_response_parser.rb: related test.

Wed Jun  5 00:38:46 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/zlib/zlib.c (gzfile_read, gzfile_read_all, gzfile_getc),
	  (gzreader_gets): check EOF.  [ruby-core:55220] [Bug #8467]

Wed Jun  5 00:32:18 2013  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_require.rb: Remove temporally files in the tests.

	* test/ruby/test_rubyoptions.rb: Ditto.

	* test/logger/test_logger.rb: Ditto.

	* test/psych/test_psych.rb: Ditto.

	* test/readline/test_readline.rb: Ditto.

	* test/syslog/test_syslog_logger.rb: Ditto.

	* test/webrick/test_httpauth.rb: Ditto.

	* test/zlib/test_zlib.rb: Ditto.

Wed Jun  5 00:08:55 2013  Yusuke Endoh  <mame@tsg.ne.jp>

	* dir.c (bracket): fix copy-paste error.  When the first and last
	  characters of fnmatch range have different length, fnmatch may
	  have wrongly matched a path that does not really match.
	  Coverity Scan found this bug.

Wed Jun  5 00:04:12 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_quote_unprintable): check if argument is a string.

Tue Jun  4 23:42:18 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (loaded_feature_path): fix invalid read by index underflow.
	  the beginning of name is also a boundary as well as just after '/'.

Tue Jun  4 23:32:12 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* variable.c (set_const_visibility): use rb_frame_this_func() instead
	  of rb_frame_callee() for getting the name of the called method

	* test/ruby/test_module.rb: add test for private_constant with no args

Tue Jun  4 23:27:24 2013  Yusuke Endoh  <mame@tsg.ne.jp>

	* vm_insnhelper.c (vm_callee_setup_keyword_arg,
	  vm_callee_setup_arg_complex): consider a hash argument for keyword
	  only when the number of arguments is more than the expected
	  mandatory parameters.  [ruby-core:53199] [ruby-trunk - Bug #8040]

	* test/ruby/test_keyword.rb: update a test for above.

Tue Jun  4 00:46:05 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (setup_overlapped, finish_overlapped): extract from
	  rb_w32_read() and rb_w32_write().

Tue Jun  4 00:02:45 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_core.h (rb_vm_tag): move jmpbuf between tag and prev so ensure to
	  be accessible.

Tue Jun  4 00:02:45 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval_intern.h (TH_PUSH_TAG): ensure jmpbuf to be accessible before
	  pushing tag to get rid of unaccessible tag by stack overflow.

Mon Jun  3 23:22:58 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each): forward anonymous and first keyword
	  rest argument one.  [ruby-core:55033] [Bug #8416].

Sun Jun  2 22:39:24 2013  Zachary Scott  <zachary@zacharyscott.net>

	* range.c: Fix rdoc on Range#bsearch [Bug #8242] [ruby-core:54143]

Mon May 20 04:00:48 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/yaml.rb: YAML documentation from #8344 [Bug #8355]

Wed May 15 23:22:09 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* include/ruby/intern.h: should include sys/time.h for struct timeval
	  if it exists. [ruby-list:49363]

Tue May 14 20:21:41 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/config_file.rb:  Lazily load .gem/credentials to only
	  check permissions when necessary.  RubyGems bug #465
	* test/rubygems/test_gem_config_file.rb:  Test for the above.

	* test/rubygems/test_gem_commands_push_command.rb:  Remove duplicated
	  test.

Tue May 14 20:11:00 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/dl/lib/dl/func.rb (DL::Function#call): check tainted when
	  $SAFE > 0.
	* ext/fiddle/function.c (function_call): check tainted when $SAFE > 0.
	* test/fiddle/test_func.rb (module Fiddle): add test for above.


Sun May 12 22:42:25 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* signal.c (rb_f_kill): fixes typo. s/HAS_KILLPG/HAVE_KILLPG/.

Sun May 12 04:23:06 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_peek_variable_name): treat invalid global, class,
	  and instance variable names as mere strings rather than errors.
	  [ruby-core:54885] [Bug #8375]

Sun May 12 04:23:06 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yylex): fail if $, @, @@ are not followed by a valid
	  name character.  [ruby-core:54846] [Bug #8375].

Sun May 12 02:50:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (RUBY_RM_RECURSIVE): this hack is needed by only
	  autoconf 2.69 or earlier on darwin.

Sun May 12 02:50:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rm, shvar_to_cpp, unexpand_shvar): local is not
	  available on old shells.

	* configure.in (shvar_to_cpp): escape quotes for old shells.
	  [Bug #7959] [Bug #8071]

Thu May  9 23:39:47 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_mod_included_modules): should not include non-modules.
	  [ruby-core:53158] [Bug #8025]

Thu May  9 23:39:47 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_mod_included_modules): should not include the original
	  module itself.  [ruby-core:53158] [Bug #8025]

Wed May  8 23:07:19 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* insns.def (defined): use vm_search_superclass() like as normal super
	  call.  based on a patch <https://gist.github.com/wanabe/5520026> by
	  wanabe.

	* vm_insnhelper.c (vm_search_superclass): return error but not raise
	  exceptions.

	* vm_insnhelper.c (vm_search_super_method): check the result of
	  vm_search_superclass and raise exceptions on error.

Wed May  8 23:07:19 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* insns.def (defined): get method entry from the method top level
	  frame, not block frame.  [ruby-core:54769] [Bug #8367]

Wed May  8 01:18:41 2013  Tanaka Akira  <akr@fsij.org>

	* internal.h (MUL_OVERFLOW_SIGNED_INTEGER_P): New macro.
	  (MUL_OVERFLOW_FIXNUM_P): Ditto.
	  (MUL_OVERFLOW_LONG_P): Ditto.

	* array.c (rb_ary_product): Don't overflow on signed integer
	  multiplication.

	* numeric.c (fix_mul): Ditto.
	  (int_pow): Ditto.

	* rational.c (f_imul): Ditto.

	* insns.def (opt_mult): Ditto.

	* thread.c (sleep_timeval): Don't overflow on signed integer addition.

	* bignum.c (rb_int2big): Don't overflow on signed integer negation.
	  (rb_big2ulong): Ditto.
	  (rb_big2long): Ditto.
	  (rb_big2ull): Ditto.
	  (rb_big2ll): Ditto.

Tue May  7 20:13:12 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/ruby/test_thread.rb (invoke_rec): extend timeout 10 -> 50 sec,
	  to investigate test failure on rubyci.
	  http://a.mrkn.jp/~mrkn/chkbuild/mountain_lion/ruby-2.0.0-m64-o0/log/20130507T052909Z.log.html.gz

Sat May  4 23:48:56 2013  Zachary Scott  <zachary@zacharyscott.net>

	* doc/security.rdoc: Add note about reporting security vulns

Sat May  4 23:44:54 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_obj_is_kind_of): skip prepending modules.
	  [ruby-core:54742] [Bug #8357]

	* object.c (rb_class_inherited_p): ditto.
	  [ruby-core:54736] [Bug #8357]

Thu May  2 23:39:45 2013  Tanaka Akira  <akr@fsij.org>

	* thread.c (double2timeval): convert the infinity to TIME_MAX to avoid
	  SEGV by Thread.new {}.join(Float::INFINITY) on
	  Debian GNU/Linux (amd64).

Thu May  2 00:30:00 2013  Tanaka Akira  <akr@fsij.org>

	* thread_pthread.c (ruby_init_stack): Add STACK_GROW_DIR_DETECTION.
	  This fixes a compilation failure while cross-compiling for Tensilica
	  Xtensa Processor.

Thu May  2 00:19:46 2013  Tanaka Akira  <akr@fsij.org>

	* dir.c (dir_set_pos): Fix a compilation error when seekdir() is not
	  exist.

Thu May  2 00:16:36 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* README.EXT: correct method name to be used.  [Bug #7982]

	* README.EXT.ja: add notes too.

Thu May  2 00:16:36 2013  Zachary Scott  <zachary@zacharyscott.net>

	* README.EXT: Copy note from r40505 for rb_sprintf() [Bug #7982]

Thu May  2 00:16:36 2013  Zachary Scott  <zachary@zacharyscott.net>

	* README.EXT: Update note from r40504, by Jeremy Evans [Bug #7982]

Thu May  2 00:16:36 2013  Zachary Scott  <zachary@zacharyscott.net>

	* README.EXT: Add note to warn use of %i in Exceptions [Bug #7982]

Wed May  1 23:35:18 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_ext_int_to_encs, parse_mode_enc): bom-prefixed name is
	  not a real encoding name, just a fallback.  so the proper conversion
	  should take place even if if the internal encoding is equal to the
	  bom-prefixed name, unless actual encoding is equal to the internal
	  encoding.  [ruby-core:54563] [Bug #8323]

	* io.c (io_set_encoding_by_bom): reset extenal encoding if no BOM
	  found.  [ruby-core:54569]

Sat Apr 27 02:12:14 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (rb_fd_fix_cloexec): use rb_update_max_fd().

Sat Apr 27 02:12:14 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (rb_update_max_fd): use ATOMIC_CAS because this function
	  is used from timer thread too.

Sat Apr 27 01:57:43 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* configure.in: use quadrigraphs. workaround for autoconf 2.64.
	  a patch provided by Hessob Park. [ruby-core:53157] [Backport #8020]

Sat Apr 27 00:39:28 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_str_inspect): refix r40413, on Ruby 1.9 usual character
	  escape uses hex/Unicode escapes, so fix to use Unicode escape on
	  Unicode strings and hex on others. [ruby-core:54458] [Bug #8290]

Sat Apr 27 00:39:28 2013  Akinori MUSHA  <knu@iDaemons.org>

	* test/ruby/test_module.rb
	  (TestModule#test_const_get_invalid_name)
	  (test_const_defined_invalid_name): Fix expected values.

Sat Apr 27 00:39:28 2013  Akinori MUSHA  <knu@iDaemons.org>

	* string.c (rb_str_inspect): NUL should not be represented as "\0"
	  when octal digits may follow.  [ruby-core:54458] [Bug #8290]

Fri Apr 26 23:48:58 2013  Tanaka Akira  <akr@fsij.org>

	* thread_pthread.c (ruby_init_stack): Add STACK_GROW_DIR_DETECTION.
	  This fixes a compilation failure while cross-compiling for ARM.

Fri Apr 26 23:32:09 2013  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/atom.rb (RSS::Atom::Entry): Fix indent of document comment.

Fri Apr 26 23:32:09 2013  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rss/maker.rb (RSS::Maker): Fix indent of document comment.

Fri Apr 26 23:32:09 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/rss/atom.rb: Documentation for RSS::Atom based on a patch by
	  Michael Denomy
	* lib/rss/maker.rb: Documentation for RSS::Maker also by @mdenomy

Thu Apr 25 00:40:41 2013  Zachary Scott  <zachary@zacharyscott.net>

	* numeric.c: Fix wiki link on Float imprecision in overview, patched
	  by Makoto Kishimoto [Bug #8304] [ruby-dev:47280]

Thu Apr 25 00:39:16 2013  Zachary Scott  <zachary@zacharyscott.net>

	* string.c: Document String#setbyte return value by @gjmurakami-10gen
	  [Fixes GH-294]

Thu Apr 25 00:38:06 2013  Zachary Scott  <zachary@zacharyscott.net>

	* ext/socket/lib/socket.rb: Doc typos by @vipulnsward [Fixes GH-292]

Tue Apr 23 23:06:43 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c (rb_mod_public_method): fix visibility on anonymous
	  module. set visibility of singleton method, not method in base
	  class.  [ruby-core:54404] [Bug #8284]

Tue Apr 23 22:33:16 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (getacl_response): parse the mailbox of an ACL
	  response correctly.  [ruby-core:54365] [Bug #8281]

Sun Apr 21 00:14:36 2013  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* test/ruby/test_require.rb (TestRequire#test_require_nonascii_path):
	  RUBY_PLATFORM should escape as Regexp,
	  because RUBY_PLATFORM may contain '.'.

Sun Apr 21 00:14:36 2013  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* test/ruby/test_require.rb (TestRequire#test_require_nonascii_path):
	  fix load path for encoding to run the test as stand-alone.

Sun Apr 21 00:14:36 2013  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* load.c (features_index_add): use rb_str_subseq() to specify C string
	  position properly to fix require non ascii path.
	  [ruby-core:53733] [Bug #8165]

	* test/ruby/test_require.rb (TestRequire#test_require_nonascii_path):
	  a test for the above.

Sun Apr 21 00:13:24 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (rb_feature_p), vm_core.h (rb_vm_struct): turn
	  loaded_features_index into st_table.  patches by tmm1 (Aman Gupta)
	  in [ruby-core:53251] and [ruby-core:53274] [Bug #8048]

Sun Apr 21 00:13:24 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* load.c (features_index_add_single, rb_feature_p): store single index
	  as Fixnum to reduce the number of arrays for the indexes.  based on
	  the patch by tmm1 (Aman Gupta) in [ruby-core:53216] [Bug #8048].

Sat Apr 20 23:32:06 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (glob_helper): should skip dot directories only for recursion,
	  but should not if matching to the given pattern.  [ruby-core:54387]
	  [Bug #8283]

Sat Apr 20 02:37:33 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/curses/curses.c (Init_curses): fix implementation function,
	  crmode should be same as cbreak.  [ruby-core:54013] [Bug #8222]

Sat Apr 20 02:09:46 2013  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* ext/openssl/ossl_ssl.c: Correct shutdown behavior w.r.t GC.

	* test/openssl/test_ssl.rb: Add tests to verify correct behavior.

	[Bug #8240] Patch provided by Shugo Maeda. Thanks!

Sat Apr 20 01:56:32 2013  Yuki Yugui Sonoda  <yugui@google.com>

	* thread_pthread.c (ruby_init_stack): Avoid using uninitialized value.
	  stackaddr and size are not set if get_stack() fails.

Sat Apr 20 01:47:31 2013  Yuki Yugui Sonoda  <yugui@google.com>

	* thread_pthread.c: Fixes wrong scopes of #if USE_SLEEPY_TIMER_THREAD
	  .. #endif sections.  This fixes a build error on NativeClient.

Sat Apr 20 01:31:38 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* Merge Onigmo 5.13.4 f22cf2e566712cace60d17f84d63119d7c5764ee.
	  [bug] fix problem with optimization of \z (Issue #16) [Bug #8210]

Sat Apr 20 01:18:20 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_callee_setup_keyword_arg): non-symbol key is not
	  a keyword argument, keep it as a positional argument.

Sat Apr 20 01:14:08 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_mutex_synchronize_m): yield no block params.  patch by
	  splattael (Peter Suschlik) in [ruby-core:53773] [Bug #8097].
	  fix GH-266.

Sat Apr 20 00:41:10 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each): append keyword hash to argument array
	  to splat if needed.  [ruby-core:54094] [Bug #8236]

Sat Apr 20 00:31:57 2013  Kouhei Sutou  <kou@cozmixng.org>

	* README.EXT.ja (Data_Wrap_Struct): Remove a description about
	  orphan argument. Oh, I renamed the argument name without
	  changing description at r36180... Sorry....
	  Patch by Makoto Kishimoto. Thanks!!! [ruby-dev:47269] [Bug #8292]
	* README.EXT.ja (Data_Make_Struct): Add a sample code that describes
	  how it works.
	  Patch by Makoto Kishimoto. Thanks!!! [ruby-dev:47269] [Bug #8292]

Tue Apr 16 01:30:47 2013  Kenta Murata  <mrkn@mrkn.jp>

	* configure.in: set ac_cv_prog_cxx if CXX is supplied.

Tue Apr 16 01:30:47 2013  Kenta Murata  <mrkn@mrkn.jp>

	* configure.in: Fix c++ compiler auto-selection not only for
	  Darwin 11.x, but also the other versions of Darwin.

Tue Apr 16 00:27:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each): fix of defined? with empty
	  expression.  [ruby-core:53999] [Bug #8220]

Mon Apr 15 00:25:00 2013  Tanaka Akira  <akr@fsij.org>

	* time.c (num_exact): use to_r method only if to_int method is
	  available.
	  [ruby-core:53764] [Bug #8173] reported by Hiro Asari.

Mon Apr 15 00:22:09 2013  Shota Fukumori  <her@sorah.jp>

	* ext/objspace/objspace.c: Fix typo in doc. Patch by Sho Hashimoto.
	  [Bug #8116] [ruby-dev:47177]

Mon Apr 15 00:15:04 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (HAVE_METACLASS_P): should check FL_SINGLETON flag before get
	  instance variable to get rid of wrong warning about __attached__.
	  [ruby-core:53839] [Bug #8188]

Mon Apr 15 00:13:13 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/file.c (code_page): use cp1252 instead of cp20127 as US-ASCII.
	  fix [ruby-core:53079] [Bug #7996]
	  reported and patched by mmeltner (Michael Meltner).

Mon Apr 15 00:07:31 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/io.h: undef POSIX compliant names on AIX, which are no
	  longer needed.  patch suggested by edelsohn (David Edelsohn) in
	  [ruby-core:53815].  [Bug #8174]

Mon Apr 15 00:07:31 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/io.h: rename SVR3,4 member names as POSIX compliant,
	  to get rid of conflict on AIX.  [ruby-core:53765] [Bug #8174]

Sun Apr 14 23:49:48 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (configuration): not include all CFLAGS in CXXFLAGS, to
	  use different set than C for C++.  [ruby-core:45273] [Bug #6504]

Sun Apr 14 23:43:06 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/fiddle/closure.c (initialize): check mprotect's return value.
	  If mprotect is failed because of PaX or something, its function call
	  will cause SEGV.
	  http://c5664.rubyci.org/~chkbuild/ruby-trunk/log/20130401T210301Z.diff.html.gz

Sun Apr 14 23:19:55 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MAIN_DOES_NOTHING): ensure symbols for tests to be
	  preserved.  [ruby-core:53745] [Bug #8169]

Sun Apr 14 23:19:55 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MAIN_DOES_NOTHING): force to refer symbols for tests
	  to be preserved.  [ruby-core:53745] [Bug #8169]

Sun Apr 14 03:00:51 2013  Naohisa Goto  <ngotogenome@gmail.com>

	* configure.in (AC_CHECK_HEADERS): atomic.h for Solaris atomic_ops.

	* ruby_atomic.h: Skip using Solaris10 atomic_ops on Solaris 9 or
	  earlier if atomic.h is not available. [ruby-dev:47229] [Bug #8228]

Sun Apr 14 02:32:45 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* time.c (GetTimeval): check if already initialized instance.

	* time.c (GetNewTimeval): check if newly created instance.

	* time.c (time_init_0, time_init_1, time_init_copy, time_mload): must
	  be newly created instance.  [ruby-core:53436] [Bug #8099]

Sun Apr 14 02:13:25 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* vm_eval.c (check_funcall_respond_to): preserve passed_block, which
	  is modified in vm_call0_body() via vm_call0(), and caused a bug of
	  rb_check_funcall() by false negative result of rb_block_given_p().
	  re-fix [ruby-core:53650] [Bug #8153].
	  [ruby-core:53653] [Bug #8154]

Fri Apr 12 04:16:30 2013  Naohisa Goto  <ngotogenome@gmail.com>

	* marshal.c (marshal_dump, marshal_load): workaround for segv on
	  Intel Solaris compiled with Oracle SolarisStudio 12.3.
	  Partly revert r38174. [ruby-core:52042] [Bug #7805]

Fri Apr 12 04:12:42 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_conv_enc_opts): convert with one converter, instead
	  of re-creating converters for each buffer expansion.

Fri Apr 12 03:48:25 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (find_library): fix to format message.
	  [ruby-core:53568] [Bug #8130]

Fri Apr 12 03:44:45 2013  Narihiro Nakamura  <authornari@gmail.com>

	* proc.c (bm_free): need to clean up the mark flag of a free and
	  unlinked method entry. [Bug #8100] [ruby-core:53439]

Fri Apr 12 02:27:42 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* addr2line.c: use more generic type:
	  * u_char -> unsigned char
	  * u_short -> unsigned short
	  * u_int -> unsigned int
	  * u_long -> unsigned long
	  * quad_t -> int64_t
	  * u_quad_t -> uint64_t

	* addr2line.c (imax): inline is defined by configure.

Fri Apr 12 02:27:42 2013  Naohisa Goto  <ngotogenome@gmail.com>

	* addr2line.c: quad_t and u_quad_t is not available on Solaris.
	  __inline is not available with old compilers on Solaris.
	  [ruby-dev:47229] [Bug #8227]

Fri Apr 12 02:27:42 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* addr2line.c (putce): suppress unused return value warning.

Fri Apr 12 02:27:42 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* addr2line.c (kprintf): added from FreeBSD libstand's printf.
	  this is consided as async signal safe function.

	* addr2line.c (rb_dump_backtrace_with_lines): use kfprintf.
	  [Bug #8144] [ruby-core:53632]

Fri Apr 12 02:27:42 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* addr2line.c (rb_dump_backtrace_with_lines): output line at once.

Fri Apr 12 02:10:09 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c (rb_export_method): directly override the flag of method
	  defined in prepending class too, not adding zsuper entry.
	  [ruby-core:53106] [Bug #8005]

Fri Apr 12 01:57:52 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/fileutils.rb:  Revert r34669 which altered the way
	  metaprogramming in FileUtils occurred.  [ruby-trunk - Bug #7958]

	* test/fileutils/visibility_tests.rb:  Refactored tests of FileUtils
	  options modules to expose bug found in #7958
	* test/fileutils/test_dryrun.rb:  ditto.
	* test/fileutils/test_nowrite.rb:  ditto.
	* test/fileutils/test_verbose.rb:  ditto.

Fri Apr 12 01:28:46 2013  Luis Lavena  <luislavena@gmail.com>

	* win32/file.c (get_user_from_path):  add internal function that retrieves
	  username from supplied path (refactored).
	* win32/file.c (rb_file_expand_path_internal):  refactor expansion of user
	  home to use get_user_from_path and cover dir_string corner cases.
	  [ruby-core:53168] [Bug #8034]

Fri Apr 12 01:28:46 2013  Luis Lavena  <luislavena@gmail.com>

	* win32/file.c (rb_file_expand_path_internal):  Expand home directory when
	  used as second parameter (dir_string).  [ruby-core:53168] [Bug #8034]
	* test/ruby/test_file_exhaustive.rb: add test to verify.

Mon Apr  8 00:10:59 2013  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c: Fix unlimited memory growth with large values of
	  RUBY_FREE_MIN. patched by tmm1(Aman Gupta).
	  [Bug #8095] [ruby-core:53405]

Sun Apr  7 22:27:12 2013  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c: Avoid unnecessary heap growth. patched by tmm1(Aman Gupta).
	  [Bug #8093] [ruby-core:53393]

Sun Apr  7 03:01:49 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (simple_re_meta): escape all closing characters, not only
	  round parenthesis.  [ruby-core:53578] [Bug #8133]

Sun Apr  7 02:54:40 2013  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c: Improve accuracy of objspace_live_num() and
	  allocated/freed counters. patched by tmm1(Aman Gupta).
	  [Bug #8092] [ruby-core:53392]

Fri Apr  5 00:54:08 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/openssl/ossl_bn.c (ossl_bn_initialize): fix can't create from bn.

Thu Apr  4 02:27:12 2013  Tanaka Akira  <akr@fsij.org>

	* lib/resolv-replace.rb (TCPSocket#initialize): resolve the 3rd
	  argument only if non-nil value is given.
	  [ruby-dev:47150] [ruby-trunk - Bug #8054] reported and analyzed by
	  mrkn.

Thu Apr  4 02:24:59 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* Merge Onigmo d4bad41e16e3eccd97ccce6f1f96712e557c4518.
	  fix lookbehind assertion fails with /m mode enabled. [Bug #8023]
	  fix \Z matches where it shouldn't. [Bug #8001]

Thu Apr  4 02:11:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (w_extended): check for prepended object.
	  [ruby-core:53206] [Bug #8043]

Wed Mar 27 03:02:30 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* vm_exec.c: Correct predefined macro name. This typo is introduced by
	  r36534 and should be backported to ruby_2_0_0.

Wed Mar 27 02:58:44 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* Merge Onigmo 0fe387da2fee089254f6b04990541c731a26757f
	  v5.13.3 [Bug#7972] [Bug#7974]

Wed Mar 27 02:53:53 2013  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/document.rb: move entity_expansion_text_limit accessor to ...
	* lib/rexml/rexml.rb: ... here to make rexml/text independent from
	  REXML::Document. It causes circular require.
	* lib/rexml/document.rb (REXML::Document.entity_expansion_text_limit):
	  deprecated.
	* lib/rexml/document.rb (REXML::Document.entity_expansion_text_limit=):
	  deprecated.
	* lib/rexml/text.rb: add missing require "rexml/rexml" for
	  REXML.entity_expansion_text_limit.
	  Reported by Robert Ulejczyk. Thanks!!! [ruby-core:52895] [Bug #7961]

Wed Mar 27 02:50:45 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* object.c (Init_Object): remove Module#used, which has been
	  introduced in Ruby 2.0 by mistake.  [Bug #7916] [ruby-core:52719]

Mon Mar 25 02:02:15 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c: edited rdoc.
	* rational.c: ditto.

Mon Mar 25 02:02:15 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* complex.c: described syntax of string form.
	* rational.c: ditto.

Mon Mar 25 01:26:26 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/webrick/httpproxy.rb: Fix typos in HTTPProxyServer [Bug #8013]
	  Patch by Nobuhiro IMAI [ruby-core:53127]

Mon Mar 25 01:09:48 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each): pass keyword arguments to zsuper,
	  with current values.  [ruby-core:53114] [Bug #8008]

Mon Mar 25 01:05:15 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/objspace/objspace.c (count_nodes): count also newly added nodes,
	  and fix key for unknown node.  patch by tmm1 (Aman Gupta) in
	  [ruby-core:53130] [Bug #8014]

Mon Mar 25 01:00:03 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_prepend_module): check redefinition of built-in optimized
	  methods.  [ruby-dev:47124] [Bug #7983]

	* vm.c (rb_vm_check_redefinition_by_prepend): ditto.

Mon Mar 25 00:51:57 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* Makefile.in (miniruby, ruby): move MAINLIBC because linker arguments
	  must appear after object files with newer versions of gcc.  patch by
	  tmm1 (Aman Gupta) in [ruby-core:53121] [Bug #8009]

Mon Mar 25 00:47:04 2013  Koichi Sasada  <ko1@atdot.net>

	* iseq.c (iseq_data_to_ary): fix condition.
	  r34303 introduces a bug to avoid all line information from
	  a result of ISeq#to_a. This is a regression problem from 2.0.0p0.

	* test/ruby/test_iseq.rb: add a test of lines after ISeq#to_a.

Mon Mar 25 00:41:23 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/mkconfig.rb: reconstruct comma separated list values.  a
	  command line to Windows batch file is split not only by spaces
	  and equal signs but also by commas and semicolons.

Wed Mar 20 23:21:14 2013  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* test/rubygems/test_gem_installer.rb (test_install_extension_flat):
	  use ruby in build directory in case ruby is not installed.
	  [ruby-core:53265] [Bug #8058]

Wed Mar 20 23:17:33 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/win32ole/test_err_in_callback.rb (TestErrInCallBack#setup):
	  allow using different root for source and build directories.
	  this may fixes a minor problem of r39834.

Wed Mar 20 23:17:33 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/win32ole/test_err_in_callback.rb (TestErrInCallBack#setup): use
	  relative path to get rid of "too long commandline" error.

Wed Mar 20 23:17:33 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/win32ole/test_err_in_callback.rb
	  (TestErrInCallBack#test_err_in_callback): shouldn't create a file in
	  the top of build directory.

Wed Mar 20 23:08:40 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/missing.h: removed __linux__. it's unnecessary.

Wed Mar 20 23:03:27 2013  Tanaka Akira  <akr@fsij.org>

	* configure.in: move OS specific header/function knowledge before
	  automatic header tests.

Wed Mar 20 23:01:42 2013  Tanaka Akira  <akr@fsij.org>

	* configure.in: move header files check to the beginning of
	  "header and library section".
	  test rlim_t with sys/types.h and sys/time.h for MirOS BSD.
	  sys/types.h and sys/time.h is gurded by #ifdef and the above move
	  is required for this change.

Wed Mar 20 22:57:27 2013  Tanaka Akira  <akr@fsij.org>

	* configure.in: move the test for -march=i486 just after
	  RUBY_UNIVERSAL_ARCH/RUBY_DEFAULT_ARCH.

Wed Mar 20 22:56:07 2013  Tanaka Akira  <akr@fsij.org>

	* configure.in: change CFLAGS temporally to test
	  ARCH_FLAG="-march=i486".

Wed Mar 20 22:54:33 2013  Tanaka Akira  <akr@fsij.org>

	* configure.in: don't define ARCH_FLAG="-march=i486" if it causes
	  compilation problem.

Wed Mar 20 22:36:41 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c: disabled _FORTIFY_SOURCE for avoid to hit glibc bug.
	  [Bug #8080] [ruby-core:53349]
	* test/ruby/test_io.rb (TestIO#test_io_select_with_many_files):
	  test for the above.

Wed Mar 20 22:34:52 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/missing.h (__syscall): moved to...
	* io.c: here. because __syscall() is only used from io.c.

	* include/ruby/missing.h: move "#include <sys/type.h>" to ....
	* include/ruby/intern.h: here. because it was introduced for
	  fixing NFDBITS issue. [ruby-core:05179].

Wed Mar 20 22:33:26 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/missing.h (struct timespec): include <sys/time.h>

Wed Mar 20 22:33:26 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: check struct timeval exist or not.
	* include/ruby/missing.h (struct timeval): check HAVE_STRUCT_TIMEVAL
	  properly. and don't include sys/time.h if struct timeval exist.

	* file.c: include sys/time.h explicitly.
	* random.c: ditto.
	* thread_pthread.c: ditto.
	* time.c: ditto.
	* ext/date/date_strftime.c: ditto.

Mon Mar 18 00:12:28 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/commands/setup_command.rb:  Don't delete non-rubygems
	  files when installing RubyGems.
	* test/rubygems/test_gem_commands_setup_command.rb:  Test for the
	  above.

	* lib/rubygems/ext/ext_conf_builder.rb:  Use full path to siteconf.rb
	  in case the extconf.rb changes directories (like memcached does).

	* lib/rubygems/package.rb:  Remove double slash from path.
	* test/rubygems/test_gem_package.rb:  Test for the above.
	* test/rubygems/test_gem_package_old.rb:  ditto.

	* lib/rubygems/source.rb:  Revert automatic HTTPS upgrade
	* lib/rubygems/spec_fetcher.rb:  ditto.
	* test/rubygems/test_gem_remote_fetcher.rb:  ditto.
	* test/rubygems/test_gem_source.rb:  ditto.
	* test/rubygems/test_gem_spec_fetcher.rb:  ditto.

Mon Mar 18 00:11:33 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rubygems/ext/ext_conf_builder.rb (Gem::Ext::ExtConfBuilder.build):
	  it is impossible to predict which file will be installed to where,
	  by the arguments, so use intermediate destination directory always.
	  [Bug #7698]

Mon Mar 18 00:11:33 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rubygems/ext/ext_conf_builder.rb (Gem::Ext::ExtConfBuilder.build):
	  it is impossible to predict which file will be installed to where,
	  by the arguments, so use intermediate destination directory always.
	  [Bug #7698]

Mon Mar 18 00:05:50 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/commands/setup_command.rb:  Install .pem files.
	* test/rubygems/test_gem_commands_setup_command.rb:  Test for the
	  above.

	* lib/rubygems/spec_fetcher.rb:  Test HTTPS upgrade with URI::HTTPS,
	  not URI::HTTP.  Fixes bug in automatic HTTPS upgrade.
	* test/rubygems/test_gem_spec_fetcher.rb:  Test for the above.

	* lib/rubygems.rb:  Version 2.0.2

	* lib/rubygems/test_utilities.rb:  Ensure scheme and uri class match.

Mon Mar 18 00:03:27 2013  Eric Hodel  <drbrain@segment7.net>

	* test/rubygems/test_require.rb:  Fix tests when 'a.rb' exists.
	  [ruby-trunk - Bug #7749]

Mon Mar 18 00:02:27 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems.rb:  Allow specification of directory permissions.
	  [ruby-trunk - Bug #7713]
	* test/rubygems/test_gem.rb:  Test for the above.

Mon Mar 18 00:00:32 2013  Eric Hodel  <drbrain@segment7.net>

	* test/rubygems/test_gem_spec_fetcher.rb:  Removed unused variable.

Mon Mar 18 00:00:32 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/commands/query_command.rb:  Only fetch remote specs when
	  showing details.  [ruby-trunk - Bug #8019]  RubyGems bug #487
	* lib/rubygems/remote_fetcher.rb:  ditto.
	* lib/rubygems/security/policy.rb:  ditto.
	* test/rubygems/test_gem_commands_query_command.rb:  Test for the
	  above.

	* lib/rubygems/security.rb:  Make OpenSSL optional for RubyGems.
	* lib/rubygems/commands/cert_command.rb:  ditto.

	* lib/rubygems/config_file.rb:  Display file with YAML error, not
	  ~/.gemrc

	* lib/rubygems/remote_fetcher.rb:  Only create gem subdirectories when
	  installing gems.
	* lib/rubygems/dependency_resolver.rb:  ditto.
	* lib/rubygems/test_utilities.rb:  ditto.
	* test/rubygems/test_gem_commands_fetch_command.rb:  Test for the
	  above.

	* lib/rubygems/spec_fetcher.rb:  Only try to upgrade
	  http://rubygems.org to HTTPS
	* test/rubygems/test_gem_spec_fetcher.rb:  Test for the above.

	* lib/rubygems.rb:  Update win_platform? check for JRuby compatibility.

	* test/rubygems/test_gem_installer.rb:  Update for Ruby 1.9.2
	  compatibility

Sun Mar 17 23:53:19 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems.rb:  Bump version to 2.0.1 for upcoming bugfix release

	* lib/rubygems/ext/ext_conf_builder.rb:  Restore ruby 1.8 compatibility
	  for [Bug #7698]
	* test/rubygems/test_gem_installer.rb:  Ditto.

	* lib/rubygems/package.rb:  Restore ruby 1.8 compatibility.

	* test/rubygems/test_gem_dependency_installer.rb:  Fix warnings

Sun Mar 17 23:36:05 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/available_set.rb:  Undent for style

	* lib/rubygems/dependency_installer.rb:  Pick latest prerelease gem to
	  install.  Fixes RubyGems bug #468.
	* test/rubygems/test_gem_dependency_installer.rb:  Test for the above.

	* lib/rubygems/dependency_installer.rb:  Don't display "Done installing
	  documentation" if documentation will not be installed.
	* lib/rubygems/rdoc.rb:  ditto

	* lib/rubygems/dependency_list.rb:  Use Array#concat for Ruby 1.x
	  performance.

	* lib/rubygems/installer.rb:  Use formatted program name when comparing
	  executables.  RubyGems pull request #471
	* test/rubygems/test_gem_installer.rb:  Test for the above.

	* lib/rubygems/package.rb:  Use more explicit feature check to work
	  around JRuby bug #552

	* lib/rubygems/ssl_certs/GeoTrust_Global_CA.pem:  Added GeoTrust root
	  certificate.

	* test/rubygems/test_gem_source_list.rb:  Use "example" instead of real
	  hostname

Sun Mar 17 23:28:44 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rubygems/ext/ext_conf_builder.rb (Gem::Ext::ExtConfBuilder.build):
	  clear DESTDIR so RUBYARCHDIR and RUBYLIBDIR are not be overrdden.
	  [Bug #7698]

Sun Mar 17 23:26:31 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rubygems/ext/ext_conf_builder.rb (Gem::Ext::ExtConfBuilder.build):
	  fix for unusal cases again.  install to a temporary directory once
	  and move instaled files to the destination directory, if it is same
	  as the current directory.  [Bug #7698]

Sun Mar 17 23:22:22 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rubygems/ext/ext_conf_builder.rb
	  (Gem::Ext::ExtConfBuilder.hack_for_obsolete_style_gems): remove
	  circular dependencies in install-so too.  [ruby-core:52882]
	  [Bug #7698]

Sun Mar 17 23:19:34 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/rubygems/ext/ext_conf_builder.rb (Gem::Ext::ExtConfBuilder.build):
	  revert use of temporary directory for build, to work some buggy
	  extconf.rb which cannot build outside the source directory.
	  [ruby-core:53056] [Bug #7698]

Sun Mar 17 23:11:35 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/ext/builder.rb:  Fix incompatibilities when installing
	  extensions.  Patch by Nobu.
	  [ruby-trunk - Bug #7698] [ruby-trunk - Bug #7971]
	* lib/rubygems/ext/ext_conf_builder.rb:  ditto.
	* lib/rubygems/installer.rb:  ditto.
	* test/rubygems/test_gem_ext_ext_conf_builder.rb:  Test for the above.
	* test/rubygems/test_gem_installer.rb:  ditto.

	* lib/rubygems/commands/sources_command.rb:  Prefer HTTPS over HTTP.
	* lib/rubygems/defaults.rb:  ditto
	* lib/rubygems/dependency_resolver.rb:  Ditto.
	* lib/rubygems/source.rb:  ditto.
	* lib/rubygems/spec_fetcher.rb:  ditto.
	* lib/rubygems/specification.rb:  ditto.
	* lib/rubygems/test_utilities.rb:  ditto.
	* test/rubygems/test_gem.rb:  Test for the above.
	* test/rubygems/test_gem_commands_sources_command.rb:  ditto.
	* test/rubygems/test_gem_dependency_resolver_api_set.rb:  ditto.
	* test/rubygems/test_gem_remote_fetcher.rb:  ditto.
	* test/rubygems/test_gem_source.rb:  ditto.
	* test/rubygems/test_gem_spec_fetcher.rb:  ditto.

Tue Mar 12 00:56:19 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/thread/test_queue.rb (TestQueue#test_thr_kill): reduce
	  iterations from 2000 to 250. When running on uniprocessor
	  systems, every th.kill needs TIME_QUANTUM_USEC time (i.e.
	  100msec on posix systems). Because, "r.read 1" is 3 steps
	  operations that 1) release GVL 2) read 3) acquire gvl and
	  (1) invoke context switch to main thread. and then, main
	  thread's th.kill resume (1), but not (2). Thus read interrupt
	  need TIME_QUANTUM_USEC. Then maximum iteration is 30sec/100msec
	  = 300.

Tue Mar 12 00:53:34 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (setup_communication_pipe): remove unused function.
	  it was unintentionally added r39683.

Tue Mar 12 00:53:34 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (ARRAY_SIZE): new.
	* thread_pthread.c (gvl_acquire_common): use low priority
	  notification for avoiding timer thread interval confusion.
	  If we use timer_thread_pipe[1], every gvl_yield() request
	  one more gvl_yield(). It lead to thread starvation.
	  [Bug #7999] [ruby-core:53095]
	* thread_pthread.c (rb_reserved_fd_p): adds timer_thread_pipe_low
	  to reserved fds.

Tue Mar 12 00:53:34 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (rb_thread_wakeup_timer_thread_fd): add fd
	  argument and remove hardcoded dependency of timer_thread_pipe[1].
	* thread_pthread.c (consume_communication_pipe): add fd argument.
	* thread_pthread.c (close_communication_pipe): ditto.

	* thread_pthread.c (timer_thread_sleep): adjust the above changes.

	* thread_pthread.c (setup_communication_pipe_internal): factor
	  out pipe initialize logic.

Tue Mar 12 00:53:34 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (rb_thread_create_timer_thread): factor out
	  creating communication pipe logic into separate function.
	* thread_pthread.c (setup_communication_pipe): new helper function.
	* thread_pthread.c (set_nonblock): moves a definition before
	  setup_communication_pipe.

Tue Mar 12 00:53:34 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (consume_communication_pipe): retry when
	  read returned CCP_READ_BUFF_SIZE.

Tue Mar 12 00:53:34 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (set_nonblock): new helper function for set
	  O_NONBLOCK.
	* thread_pthread.c (rb_thread_create_timer_thread): set O_NONBLOCK
	  to timer_thread_pipe[0] too.

Tue Mar 12 00:51:23 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (timer_thread_sleep): use poll() instead of
	  select(). select doesn't work if timer_thread_pipe[0] is
	  greater than FD_SETSIZE.
	* thread_pthread.c (USE_SLEEPY_TIMER_THREAD): add a dependency
	  against poll.

Tue Mar 12 00:51:23 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (USE_SLEEPY_TIMER_THREAD): use more accurate
	  ifdef condtions.

Mon Mar 11 01:16:12 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (unexpand_shvar): get rid of non-portable shell
	  behavior on OpenBSD, so no extra quotes.  [Bug #7959]

Mon Mar 11 01:12:50 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (IS_LABEL_POSSIBLE): allow labels for keyword arguments just
	  after method definition without a parenthesis.  [ruby-core:52820]
	  [Bug #7942]

Mon Mar 11 01:09:23 2013  Zachary Scott  <zachary@zacharyscott.net>

	* error.c: clarify reason for sleep in SignalException example

Mon Mar 11 01:09:23 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* error.c: clarify a document of SignalException. Process.kill()
	  doesn't have any guarantee when signal will be delivered.
	  [Bug #7951] [ruby-core:52864]

Mon Mar 11 01:04:54 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (str_byte_substr): don't set coderange if it's not known.
	  [Bug #7954] [ruby-dev:47108]

Mon Mar 11 00:58:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (realclean-local): miniprelude.c is made by srcs, so it
	  should not removed by distclean but by realclean.  [Bug #6807]

Mon Mar 11 00:54:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enc/depend (ARFLAGS): VisualC++ linker does not allow spaces between
	  output option and the output file name.  [Bug #7950]

	* enc/depend (RANLIB): set default command to do nothing, or make the
	  entire line a label on Windows.

Mon Mar 11 00:50:21 2013  Zachary Scott  <zachary@zacharyscott.net>

	* thread.c: Document Thread::new, clean up ::fork and mention calling
	  super if subclassing Thread

Mon Mar 11 00:47:47 2013  Akinori MUSHA  <knu@iDaemons.org>

	* configure.in (unexpand_shvar): Use the numeric comparison
	  operator instead of '==' which is a ksh extention. [Bug #7941]

Sun Mar 10 00:01:07 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: [ruby-core:52303]

Sat Mar  9 23:55:42 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* random.c (rb_random_ulong_limited): limit is inclusive, but generic
	  rand method should return a number less than it, so increase for the
	  difference.  [ruby-core:52779] [Bug #7935]

Sat Mar  9 23:51:58 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* random.c (rb_random_ulong_limited): fix error message for negative
	  value.  [ruby-dev:47061] [Bug #7903]

Sat Mar  9 23:41:11 2013  Zachary Scott  <zachary@zacharyscott.net>

	* thread.c: Document ThreadGroup::Default

Sat Mar  9 23:31:46 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_call_method): block level control frame does not
	  have method entry, so obtain the method entry from method top-level
	  control frame to be compared with refined method entry.
	  [ruby-core:52750] [Bug #7925]

Sat Mar  9 23:15:06 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* signal.c (sigsegv): suppress unused result warning. Because
	  write(2) is marked __warn_unused_result__ on Linux glibc.

Sat Mar  9 23:08:43 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_set_arguments): no keyword check if any keyword rest
	  argument exists, even unnamed.  [ruby-core:52744] [Bug #7922]

Sat Mar  9 22:50:28 2013  Zachary Scott  <zachary@zacharyscott.net>

	* array.c: Document #<=> return values and formatting
	* bignum.c: ditto
	* file.c: ditto
	* object.c: ditto
	* numeric.c: ditto
	* rational.c: ditto
	* string.c: ditto
	* time.c: ditto

Sat Mar  9 22:45:01 2013  Zachary Scott  <zachary@zacharyscott.net>

	* array.c (rb_ary_diff, rb_ary_and, rb_ary_or): Document return order
	  [RubySpec #7803]

Sat Mar  9 22:38:26 2013  Zachary Scott  <zachary@zacharyscott.net>

	* object.c (rb_obj_comp): Documenting Object#<=> return values
	  Patch by Stefan Rusterholz

Sat Mar  9 22:35:22 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (file_s_fnmatch, fnmatch_brace): encoding-incompatible pattern
	  and string do not match, instead of exception.  [ruby-dev:47069]
	  [Bug #7911]

Sat Mar  9 22:18:43 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/test_rbconfig.rb (TestRbConfig): fix r39372.
	  It must see RbConfig::CONFIG instead of CONFIG.

Sat Mar  9 22:18:43 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/test_rbconfig.rb (TestRbConfig): skip user defined values by
	  configuration options.  [Bug #7902]

Sat Mar  9 22:07:53 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rexml/document.rb (REXML::Document.entity_expansion_text_limit):
	  fix a typo in comment in r39384.

Sat Mar  9 21:52:19 2013  Zachary Scott  <zachary@zacharyscott.net>

	* numeric.c: Examples and formatting for Numeric and Float
	  Based on a patch by Zach Morek and Oren K of newhaven.rb
	  [Github documenting-ruby/ruby#5]

Sat Mar  9 21:46:41 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/globals.rdoc:  Document what setting $DEBUG does.

	* doc/globals.rdoc:  Added pointer to $-d for full documentation.

Sat Mar  9 21:45:38 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/globals.rdoc:  Document what setting $VERBOSE does.  [Bug #7899]

	* doc/globals.rdoc:  Added pointer to $-w and $-v for full
	  documentation.

Sat Mar  9 21:29:45 2013  Naohisa Goto  <ngotogenome@gmail.com>

	* signal.c (ruby_abort): fix typo in r39354 [Bug #5014]

Sat Mar  9 21:29:45 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* signal.c (check_stack_overflow): extract duplicated code and get rid
	  of declaration-after-statement.  [Bug #5014]

Sat Mar  9 21:29:45 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* signal.c (sigsegv): avoid to use async signal unsafe functions
	  when nested sigsegv is happen.
	  [Bug #5014] [ruby-dev:44082]

Sat Mar  9 21:25:45 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* file.c (rb_group_member): added an error check. SUS says,
	  getgroups(small_value) may return EINVAL.

Sat Mar  9 21:23:36 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* process.c (RB_MAX_GROUPS): moved to
	* internal.h (RB_MAX_GROUPS): here.

	* file.c (rb_group_member): use RB_MAX_GROUPS instead of
	  RUBY_GROUP_MAX. They are the same.

Sat Mar  9 21:15:39 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* file.c (access_internal): removed.
	* file.c (rb_file_readable_real): use access() instead of
	  access_internal().
	* file.c (rb_file_writable_real): ditto.
	* file.c (rb_file_executable_real): ditto.

Wed Mar  6 22:13:38 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

merge revision(s) 39297: [Backport #8032]

	* tool/mkconfig.rb: clear exec_prefix which may differ from prefix,
	  before expanding rubyarchdir to remove prefix.

Tue Mar  5 01:20:39 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* tool/merger.rb: add interaction when only ChangeLog is modified.

Tue Mar  5 01:03:16 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* file.c (rb_group_member): get rid of NGROUPS dependency.
	  [Bug #7886] [ruby-core:52537]

Tue Mar  5 00:16:56 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/openssl/ossl.c (class OpenSSL):  Use only inner parenthesis in
	  create_extension examples.

Tue Mar  5 00:16:56 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/openssl/ossl.c (class OpenSSL):  Fixed ExtensionFactory example.
	  Patch by Richard Bradley.  [ruby-trunk - Bug #7551]

Mon Mar  4 23:53:18 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	(merge r39291)
	* configure.in (opt-dir): remove debug print.

Mon Mar  4 23:42:34 2013  Zachary Scott  <zachary@zacharyscott.net>

	* ext/psych/lib/psych/y.rb: Document Kernel#y by Adam Stankiewicz
	  [Github tenderlove/psych#127]

Mon Mar  4 23:37:14 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* tool/mkconfig.rb: remove prefix from rubyarchdir.
	  r39267 expands variables, it changes expansion timing,
	  breaks RbConfig::CONFIG["includedir"] and building
	  extension libraries with installed ruby.

Sun Mar  3 02:45:13 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* vm.c (ENV_IN_HEAP_P): fix off-by-one error.

Sun Mar  3 02:39:01 2013  Ayumu AIZAWA  <ayumu.aizawa@gmail.com>

	* test/ruby/test_thread.rb: fixed typo
	  patched by Hiroki Matsue via https://github.com/ruby/ruby/pull/248

Sun Mar  3 02:22:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (include_modules_at): detect cyclic prepend with original
	  method table.  [ruby-core:52205] [Bug #7841]

Sun Mar  3 02:16:24 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c: call method_removed hook on called class, not on
	  prepending iclass.  [ruby-core:52207] [Bug #7843]

Sun Mar  3 01:57:50 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (warnflags): disable -Werror by default unless
	  development.  [ruby-core:52131] [Bug #7830]

Wed Feb 27 00:20:43 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_process.rb (test_setsid): Added a workaround for
	  MacOS X. Patch by nagachika. [Bug #7826] [ruby-core:52126]

Sun Feb 24 15:16:00 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/net/http.rb:  Removed duplicate Accept-Encoding in Net::HTTP#get.
	  [ruby-trunk - Bug #7924]
	* test/net/http/test_http.rb:  Test for the above.

Wed Feb 20 14:23:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* thread.c: Grammar for #backtrace_locations and ::handle_interrupt

Fri Feb 22 11:10:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* enum.c (Enumerable#chunk: Improved examples, grammar, and formatting
	  Patch by Dan Bernier and Rich Bruchal of newhaven.rb
	  [Backport #7926]

Fri Feb 22 02:33:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/abbrev.rb: Add words parameter to Abbrev::abbrev
	  Patch by Devin Weaver [Backport #7927]

Wed Feb 20 13:37:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* ext/pty/pty.c: Documentation for the PTY module [Backport #7928]

Wed Feb 20 12:18:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* object.c: Document Data class by Matthew Mongeau [Backport #7929]

Wed Feb 20 11:50:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/mutex_m.rb: Add rdoc for Mutex_m module [Backport #7930]

Tue Feb 19 12:30:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* object.c: rdoc formatting for Kernel#Array() [Backport #7931]
	* array.c: Add rdoc for Array() method to Creating Arrays section

Sat Feb 23 16:51:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* thread.c: Documentation for Thread#backtrace_locations
	  [Backport #7932]

Sat Feb 23 16:05:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* vm.c: Typo in ObjectSpace::WeakMap overview [Backport #7933]

Sat Feb 23 16:00:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* thread.c: Improved rdoc for ::handle_interrupt, ::pending_interrupt?
	  and #pending_interrupt? [Backport #7934]

Sat Feb 23 14:19:51 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (HAVE_RB_SCAN_ARGS_OPTIONAL_HASH): for
	  rb_scan_args() optional hash feature.  [Bug #7861]

Sat Feb 23 13:03:22 2013  Akinori MUSHA  <knu@iDaemons.org>

	* lib/ipaddr.rb (IPAddr#in6_addr): Fix a typo with the closing
	  parenthesis.

Sat Feb 23 13:03:22 2013  Akinori MUSHA  <knu@iDaemons.org>

	* lib/ipaddr.rb (IPAddr#in6_addr): Fix the parser so that it can
	  recognize IPv6 addresses with only one edge 16-bit piece
	  compressed, like [::2:3:4:5:6:7:8] or [1:2:3:4:5:6:7::].
	  [Bug #7477]

Sat Feb 23 13:00:49 2013  Akinori MUSHA  <knu@iDaemons.org>

	* configure.in (LIBRUBY_DLDFLAGS): Fix a bug where --with-opt-dir
	  options given were not reflected to LIBRUBY_DLDFLAGS on many
	  platforms including Linux and other GNU-based systems, NetBSD,
	  AIX and BeOS.

Sat Feb 23 13:00:07 2013  Akinori MUSHA  <knu@iDaemons.org>

	* configure.in: Fix a bug introduced in r38342 that the cflagspat
	  substitution is messed up by the way CFLAGS and optflags are
	  modified, which affected FreeBSD and NetBSD/amd64 when
	  configured to use libexecinfo.  This bug resulted in CFLAGS and
	  CXXFLAGS in RbConfig::CONFIG having warnflags expanded in them,
	  forcing third-party C/C++ extensions to follow what warnflags
	  demands, like ANSI/ISO-C90 conformance.  ref [Bug #7101]

Sat Feb 23 12:58:32 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb: remove extra topdir in VPATH, which was in
	  win32/Makefile.sub for some reason and moved from there.
	  [ruby-dev:46998] [Bug #7864]

Tue Feb 23 12:07:00 2013  Kenta MURATA  <mrkn@mrkn.jp>

	* backport r39321 from trunk. [ruby-core:51777] [Bug #7761]

	* ext/bigdecimal/bigdecimal.gemspec: bump to 1.2.0.
	  [ruby-core:51777] [Bug #7761]

Sat Feb 23 08:57:46 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* backport r39410 from trunk

	* doc/NEWS-*: Update NEWS from their respective branches

Sat Feb 23 08:14:43 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* backport r39400-r39407 from trunk.

	* NEWS: many additions

	* object.c: Add doc for Module.prepended

Sat Feb 23 06:07:04 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/installer.rb (build_extensions):  Create extension
	  install destination before building extension.  Patch by Kenta Murata.
	  [ruby-trunk - Bug #7897]
	* test/rubygems/test_gem_installer.rb:  Test for the above.

Sat Feb 23 04:34:44 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* NEWS: pending_interrupt? is both instance and singleton method

Sat Feb 23 02:49:10 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* NEWS: Add Thread#pending_interrupt? and Thread.handle_interrupt

Fri Feb 22 19:22:05 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* lib/rexml/document.rb (REXML::Document.entity_expansion_text_limit):
	  new attribute to read/write entity expansion text limit.  the default
	  limit is 10Kb.

	* lib/rexml/text.rb (REXML::Text.unnormalize): check above attribute.

Thu Feb 21 05:03:38 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/commands/update_command.rb:  Create the installer after
	  options are processed.  [ruby-trunk - Bug #7779]
	* test/rubygems/test_gem_commands_update_command.rb:  Test for the
	  above.

Thu Feb 21 04:54:14 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/installer.rb:  Use gsub instead of gsub! to avoid
	  altering @bin_dir.  Fixes tests on windows.  [ruby-trunk - Bug #7885]

Thu Feb 21 03:16:37 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* NEWS: Floats are frozen too

Thu Feb 21 03:10:53 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* NEWS: Add that Fixnums and Bignums are frozen

Wed Feb 20 17:02:12 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_eval.c (vm_call0_body): check interrupts after method dispatch
	  from C methods. [Bug #7878]

Wed Feb 20 08:05:25 2013 Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compar.c (rb_invcmp): compare by inversed comparison, with preventing
	  from infinite recursion.  [ruby-core:52305] [Bug #7870]

	* string.c (rb_str_cmp_m), time.c (time_cmp): get rid of infinite
	  recursion.

Tue Feb 19 15:49:58 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (unexpand_shvar): regularize a shell variable by
	  unexpanding shell variables in it.

	* configure.in (shvar_to_cpp): do not substitute exec_prefix itself
	  with RUBY_EXEC_PREFIX, which cause recursive definition.
	  [ruby-core:52296] [Bug #7860]

	* configure.in: unexpand arch sitearch and exec_prefix values, so
	  directly specified bindir, libdir, rubyprefix, etc can be properly
	  substituted.  [ruby-core:52296] [Bug #7860]

Tue Feb 19 14:08:46 2013  Eric Hodel  <drbrain@segment7.net>

	* backport r39307 from trunk.  [Bug #7880]

	* lib/rubygems/installer.rb:  Fixed placement of executables with
	  --user-install.  [ruby-trunk - Bug #7779]

	* test/rubygems/test_gem_installer.rb:  Test for above.

Tue Feb 19 13:57:26 2013  Eric Hodel  <drbrain@segment7.net>

	* backport r39247 from trunk. [Bug #7853]

	* lib/rdoc.rb:  Update to release version of 4.0.0

	* lib/rubygems.rb:  Update to release version of 2.0.0

Tue Feb 19 12:25:27 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/Makefile.sub (config.status): site and vendor directories
	  should use sitearch, not arch.  [ruby-dev:46964] [Bug #7823]

Tue Feb 19 07:51:01 2013  Koichi Sasada  <ko1@atdot.net>

	* backport r39275 from trunk. [ruby-dev:46994] [Bug #7774]

	* proc.c (rb_binding_new_with_cfp): create binding object even if
	  the frame is IFUNC. But return a ruby-level binding to keep
	  compatibility.
	  This patch fix degradation introduced from r39067.
	  [Bug #7774] [ruby-dev:46960]

	* test/ruby/test_settracefunc.rb: add a test.

Sat Feb 16 20:43:43 2013  Koichi Sasada  <ko1@atdot.net>

	* backport r39276 from trunk. [ruby-dev:46997] [Bug #7825]

	* vm.c (rb_thread_mark): mark a working Proc of bmethod
	  (a method defined by define_method) even if the method was removed.
	  We could not trace working Proc object which represents the body
	  of bmethod if the method was removed (alias/undef/overridden).
	  Simply, it was mark miss.
	  This patch by Kazuki Tsujimoto. [Bug #7825]

	  NOTE: We can brush up this marking because we do not need to mark
	  `me' on each living control frame. We need to mark `me's
	  only if `me' was free'ed. This is future work after Ruby 2.0.0.

	* test/ruby/test_method.rb: add a test.

Fri Feb 15 00:49:32 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/net/http.rb:  Removed OpenSSL dependency from Net::HTTP.

	* test/net/http/test_http.rb:  Remove Zlib dependency from tests.
	* test/net/http/test_http_request.rb:  ditto.

Fri Feb 15 00:49:32 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/net/http:  Do not handle Content-Encoding when the user sets
	  Accept-Encoding.  This allows users to handle Content-Encoding for
	  themselves.  This restores backwards-compatibility with Ruby 1.x.
	  [ruby-trunk - Bug #7831]
	* lib/net/http/generic_request.rb:  ditto.
	* lib/net/http/response.rb:  ditto
	* test/net/http/test_http.rb:  Test for the above.
	* test/net/http/test_http_request.rb:  ditto.
	* test/net/http/test_httpresponse.rb:  ditto.

Thu Feb 14 13:17:10 2013  Zachary Scott  <zachary@zacharyscott.net>

	* Backport r39168 Warning about TracePoint events to 2.0.0
	  [ruby-core:52073] [Bug #7815]

	* vm_trace.c: note about TracePoint events set

Thu Feb 14 07:04:13 2013  Eric Hodel  <drbrain@segment7.net>

	* Backport r39213 from trunk [ruby-trunk - Bug #7383]

	* lib/rubygems.rb:  Return BINARY strings from Gem.gzip and Gem.gunzip.
	  Fixes intermittent test failures.  RubyGems issue #450 by Jeremey
	  Kemper.
	* test/rubygems/test_gem.rb:  Test for the above.

Thu Feb 14 07:01:12 2013  Eric Hodel  <drbrain@segment7.net>

	* Backport part of r39166 from trunk [ruby-trunk - Bug #7809]

	* lib/rubygems/package.rb:  Include checksums.yaml.gz signatures for
	  verification.
	* test/rubygems/test_gem_package.rb:  Test for the above.

Wed Feb 13 15:34:21 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json: merge JSON 1.7.7.
	  This includes security fix. [CVE-2013-0269]
	  https://github.com/flori/json/commit/d0a62f3ced7560daba2ad546d83f0479a5ae2cf2
	  https://groups.google.com/d/topic/rubyonrails-security/4_YvCpLzL58/discussion

Sat Feb  9 21:13:35 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* backport r39167 from trunk. [ruby-core:52059] [Bug #7812]

	* BSDL: update copyright notice for 2013.

Fri Feb  8 19:56:54 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* array.c (rb_ary_dup): reverted r39004.  see [Bug #7768], and
	  release manager finally decided to revert it.

Fri Feb  8 16:09:45 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_ensure): preserve errinfo across ensure proc before
	  JUMP_TAG().  [ruby-core:52022] [Bug #7802]

Fri Feb  8 16:08:28 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/envutil.rb (assert_separately): check also terminating
	  signal not only if core dumped.

Fri Feb  8 13:12:04 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/generator/darkfish.rb:  Set encoding on output template to
	  user-specified encoding.
	* test/rdoc/test_rdoc_generator_darkfish.rb:  Test for above.

	* lib/rdoc.rb:  Bump version

Fri Feb  8 11:53:33 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/security/policy.rb:  Raise proper exceptions when
	  verifying unsigned gems (instead of crashing).
	* test/rubygems/test_gem_security_policy.rb:  Tests for the above.

Fri Feb  8 10:44:44 2013  Eric Hodel  <drbrain@segment7.net>

	* test/rubygems/test_gem_dependency_installer.rb:  Improve coverage of
	  --install-dir feature of gem install.

Fri Feb  8 10:11:09 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/config_file.rb:  Add missing require for
	  user_interaction.rb

	* lib/rubygems/dependency_installer.rb:  Minor refactor for clarity.

Fri Feb  8 09:35:17 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MakeMakefile#configuration): set all ruby names.
	  hdrdir now needs RUBY_VERSION_NAME.

Fri Feb  8 08:58:26 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/package/old.rb:  Fix loading old format gems on ruby
	  1.8.  This commit is only so trunk and rubygems master have the same
	  code.

Fri Feb  8 08:53:27 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: fixing string quotation
	  when dumping Ruby strings. Thanks Ingy

	* test/psych/test_psych.rb: appropriate tests.

	* test/psych/test_yaml.rb: ditto

Fri Feb  8 08:50:42 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: change output reference
	  ids to be sequential numbers.

Fri Feb  8 07:47:56 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/package/old.rb:  Disallow installation of old-format
	  gems when a security policy is active.
	* test/rubygems/test_gem_package_old.rb:  Test for above.

Fri Feb  8 07:34:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/net/http.rb (HTTP.post_form): Fix module scope in documentation
	  Patch by David Albert [Bug #7794] [ruby-core:51955]

Fri Feb  8 07:33:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* compar.c (cmp_equal): Document ignored exception and return false
	  By Makoto Kishimoto [Bug #7790] [ruby-dev:46925] [ruby-dev:46910]

Fri Feb  8 07:17:00 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/dependency_installer.rb:  Only install local gems if
	  they end in '.gem'.  Fixes github rubygems issue #407.
	* test/rubygems/test_gem_dependency_installer.rb:  Test for the above.

Fri Feb  8 00:02:48 2013  Tanaka Akira  <akr@fsij.org>

	* process.c (obj2gid): use getgrnam_r() only if getgrnam_r() and
	  _SC_GETGR_R_SIZE_MAX is available.
	  MirOS BSD (MirBSD 10 GENERIC#1382 i386) have getgrnam_r() but
	  no _SC_GETGR_R_SIZE_MAX.
	  (obj2uid): use getpwnam_r() only if getpwnam_r() and
	  _SC_GETPW_R_SIZE_MAX is available.
	  This is consistency for obj2gid.
	  MirOS BSD have neither getpwnam_r() nor _SC_GETPW_R_SIZE_MAX.

Thu Feb  7 22:01:18 2013  Tanaka Akira  <akr@fsij.org>

	* configure.in: define linker for shared library on MirOS BSD.

Thu Feb  7 21:09:23 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/rubygems/test_gem_config_file.rb
	  (TestGemConfigFile#test_check_credentials_permissions): skip on
	  Windows. see [Bug #7784] [ruby-core:51864] and r39070.

Thu Feb  7 20:52:40 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (config.status): added variables which were
	  missing at r39130.

Thu Feb  7 15:33:17 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MakeMakefile#merge_libs): insert following reversal
	  ordered elements just after the duplicated element, not overwriting
	  successive elements.  [ruby-core:50314] [Bug #7467]

Thu Feb  7 14:56:15 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/package.rb:  Ensure digests are generated for signing.
	* test/rubygems/test_gem_package.rb:  Test for the above.

	* lib/rubygems/security/policy.rb:  Ensure digests are present when
	  verifying a gem and match the number of signatures bidirectionally.
	* test/rubygems/test_gem_security_policy.rb:  Test for the above.

	* lib/rubygems.rb:  Documentation improvements (by zzak)

Thu Feb  7 05:52:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* doc/pty/README: Remove static documentation file
	* ext/pty/pty.c: Add License to PTY module overview

Thu Feb  7 02:31:10 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* vm_insnhelper.c: attr_writer should return its argument [Bug #7773]

	* test/ruby/test_basicinstructions.rb: Test for above

Thu Feb  7 01:35:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* doc/security.rdoc: Link to japanese version of CVE page patch by
	  nagachika

Wed Feb  6 23:30:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* doc/pty/README.expect: Removed static documentation file
	* ext/pty/lib/expect.rb: Documentation for IO#expect

Wed Feb  6 22:25:00 2013  Charlie Somerville  <charlie@charliesomerville.com>

	* hash.c (env_reject_bang): hide keys array from ObjectSpace
	* hash.c (env_select_bang): ditto

Wed Feb  6 17:33:01 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (multiarch): add option to move architecture dependent
	  directories.  [Feature #6111]

	* template/ruby.pc.in: add arch dependent paths.

	* configure.in (rubyarchhdrdir, sitearchhdrdir, vendorarchhdrdir): add
	  options to customize architecture dependent header directories.

	* configure.in (rubyarchprefix, sitearchdir, vendorarchdir): add
	  options to customize architecture dependent library directories.

	* template/ruby.pc.in, tool/mkconfig.rb, tool/rbinstall.rb: use
	  configured values.

	* tool/mkconfig.rb: expand rubyarchdir to extract prefix.

	* configure.in (RUBY_VERSION_NAME), template/ruby.pc.in: add
	  substitution and define.

	* configure.in, version.c: parametric architecture name for paths.

	* configure.in (shvar_to_cpp): convert sh variable references
	  by replacing with string literal forms in cpp.

Wed Feb  6 17:05:26 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc:  Import RDoc 4.0.0.rc.2

Mon Feb  4 02:22:49 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_process.rb (test_setsid): ensure to call
	  Process.wait(). Reported by George Koehler. Thanks.

Mon Feb  4 02:18:00 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_process.rb (test_setsid): skip when platform is
	  OpenBSD. Contributed from George Koehler.
	  [Bug #7789] [ruby-core:51889]

Wed Feb  6 13:35:20 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (rb_method_entry_location, rb_{mod,obj}_method_location): new
	  functions to obtain source location of method definition.

	* vm_method.c (rb_obj_respond_to): show the location of old style
	  respond_to? method.

Wed Feb  6 13:03:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* doc/security.rdoc: Add link to CVEs on ruby-lang.org/en/security

Wed Feb  6 12:49:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* NEWS: Add note about removal of CSV::load and CSV::dump from r39077

Wed Feb  6 05:57:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/racc/parser.rb: Hide copyright notice from Racc doc

Wed Feb  6 05:50:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* doc/rubygems/*: Removed outdated documentation files
	* lib/rubygems/LICENSE.txt: Include license file
	* lib/rubygems.rb: Move Gem module documentation so rdoc can parse it
	  and link to LICENSE.txt
	* lib/rubygems/*: Hide useless documentation from Gem module rdoc

Wed Feb  6 03:45:19 2013  Zachary Scott  <zachary@zacharyscott.net>

	* doc/security.rdoc: Remove documentation for unsafe CSV.load which
	  was deleted in r39077

Wed Feb  6 03:27:19 2013  James Edward Gray II  <james@graysoftinc.com>

	* lib/csv.rb: Remove the dangerous serialization feature.

Wed Feb  6 00:56:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/irb.rb: Remove example from restrictions, it works [Github #246]
	  Based on patch by Ryunosuke SATO

Wed Feb  6 00:46:53 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* vm.c (rb_vm_stack_to_heap): call rb_vm_get_binding_creatable_next_cfp
	  instead of rb_vm_get_ruby_level_next_cfp to prevent a segfault by
	  calling Kernel#callcc. See r39067 for more details.
	  [ruby-dev:46908] [ruby-trunk - Bug #7774]

	* test/ruby/test_settracefunc.rb: add a test.

Tue Feb  5 18:48:00 2013  Charlie Somerville  <charlie@charliesomerville.com>

	* doc/security.rdoc: add regex, eval and drb sections

Tue Feb  5 17:24:02 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/servlet.rb:  Fixed root search paths, filesystem paths
	  instead of HTTP paths were returned.
	* test/rdoc/test_rdoc_servlet.rb:  Test for above.

Tue Feb  5 16:37:00 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/config_file.rb:  Ignore permissions check on windows.
	  Windows writes 0600 file as 0644 permissions making the check
	  useless.

Tue Feb  5 16:25:25 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_method.c (rb_obj_respond_to): drop optional include_all flag if
	  respond_to? method is defined in old style.  [Bug #7722]

Tue Feb 05 15:04:34 2013  Koichi Sasada  <ko1@atdot.net>

	* proc.c (rb_binding_new_with_cfp): permit to create binding object
	  of IFUNC frame.
	  When `rb_binding_new_with_cfp()' is called, VM finds out the first
	  normal (has iseq) frame and create a binding object of this frame
	  and create Env objects. `ep's of related frames are updated
	  (`ep's point Env object managed spaces).
	  However, `ep' of skipped IFUNC frame was not updated and
	  old invalid `ep' was remained. It causes serious problems.
	  To solve this issue, permit IFUNC to create binding.
	  (Maybe there is no problem on it)
	  [ruby-dev:46908] [ruby-trunk - Bug #7774]

	* test/ruby/test_settracefunc.rb: add a test.

	* vm.c (rb_vm_get_binding_creatable_next_cfp), vm_core.h: added.

	* vm_trace.c: fix to use `rb_vm_get_binding_creatable_next_cfp()'.

Tue Feb  5 14:43:15 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Fix error message, patch by pypypy [Bug #7777]

Tue Feb  5 14:36:04 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* numeric.c (fix_pow): Handle special cases when base is 0, -1 or +1
	  [Bug #5713] [Bug #5715]

	* rational.c (nurat_expt): ditto

Tue Feb  5 13:27:53 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/console.c (rawmode_opt): use default values by `stty
	  raw`.

Tue Feb  5 12:50:47 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* range.c: Use div instead of / for bsearch

	* test/ruby/test_range.rb: Test showing bug when requiring mathn

Tue Feb  5 12:48:38 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* enumerator.c: Use to_enum for Enumerable methods returning
	  Enumerators.
	  This makes Lazy#cycle no longer needed, so it was removed.
	  Make Enumerator#chunk and slice_before return lazy Enumerators.
	  [Bug #7715]

	* internal.h: Remove ref to rb_enum_cycle_size; no longer needed

	* enum.c: Make enum_cycle_size static.

	* test/ruby/test_lazy_enumerator.rb: Test for above

Tue Feb  5 12:48:10 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* enumerator.c: Finalize and document Lazy.new. [Bug #7248]
	  Add Lazy#to_enum and simplify Lazy#size.

	* test/ruby/test_lazy_enumerator.rb: tests for above

Tue Feb  5 11:35:35 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/commands/push_command.rb:  Fixed credential download for
	  `gem push --host`
	* lib/rubygems/gemcutter_utilities.rb:  ditto.
	* test/rubygems/test_gem_commands_push_command.rb:  Test for the above.
	* test/rubygems/test_gem_gemcutter_utilities.rb:  ditto.

	* lib/rubygems/config_file.rb:  Abort if the `gem push` credentials
	  file has insecure permissions.
	* test/rubygems/test_gem_config_file.rb:  Test for the above.

	* lib/rubygems/ext/builder.rb:  Do not look for Gemfile, Isolate, etc.
	  while building gem extensions.

	* lib/rubygems/package.rb:  Unset spec and files list if a gem's
	  signatures cannot be verified.
	* test/rubygems/test_gem_package.rb:  Test for the above.

	* lib/rubygems/specification.rb:  Reduce use of eval.
	* lib/rubygems/test_case.rb:  ditto.

	* test/rubygems/test_gem_specification.rb:  Test setting
	  specification_version for legacy gems.  Dup Gem.ruby before
	  untainting in case it's frozen.

	* lib/rubygems.rb:  Reduce use of eval.  Only read files when looking
	  for Gemfile, Isolate, etc.
	* test/rubygems/test_gem.rb:  Test for the above.

Tue Feb  5 10:15:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* doc/security.rdoc: Wrap security guide at 80 columns

Tue Feb  5 10:15:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* doc/security.rdoc: Grammatical error on security guide
	  Patch by Josh Bassett [Github fixes #245]

Tue Feb  5 10:00:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/racc/parser.rb: Update #do_parse and #yyparse from upstream
	  See [Github tenderlove/racc@7d954b5]

Tue Feb  5 09:55:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/racc: Merge Racc documentation downstream, add grammar ref file

Tue Feb  5 08:03:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/irb.rb, lib/irb/ext/save-history.rb: Add documentation on how to
	  enabled irb history [ruby-core:51347] [Bug #7679]

Tue Feb  5 07:35:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/irb.rb, lib/irb/context.rb: Add documentation on how to enable
	  auto-indentation and autocompletion using irbrc and irb_context
	  [ruby-core:51209] [Bug #7642] and [ruby-core:51348] [Bug #7680]

Tue Feb  5 05:20:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* doc/standard_library.rdoc: Document list of libraries and extensions
	  and their purpose or short description
	* lib/README: Remove lib/README in favor of doc/standard_library.rdoc

Tue Feb  5 04:40:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* ext/json/lib/json.rb: Move module overview definition for rdoc

Tue Feb  5 03:00:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/tracer.rb: Move class overview definition and reformat

Mon Feb  4 15:10:10 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/console.c (rawmode_opt): initialize options for the
	  case all options are not given.

Mon Feb  4 12:44:13 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_dump.c (control_frame_dump): capitalize prefix of `ep'
	  if `ep' points an env object.

Mon Feb  4 04:20:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/English.rb: Add English module for RDoc to parse, then
	  remove_const to avoid confusion. Include full list of aliases and
	  their associated global variable.

Mon Feb  4 02:40:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/yaml.rb (YAML::EngineManager): Documentation for #yamler and
	  #yamler= for using the removed Syck gem as the YAML::ENGINE

Sun Feb  3 16:54:27 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/io-console.gemspec: bump.  [Bug #7762]

	* test/io/console/test_io_console.rb (test_stringio_getch): use more
	  descriptive assertions.

	* ext/io/console/console.c (rawmode_opt): min is minimum characters,
	  not tenths.

Sun Feb  3 16:13:00 2013  Charlie Somerville  <charlie@charliesomerville.com>

	* doc/security.rdoc: add first cut at a Ruby security document

Sun Feb  3 10:25:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* random.c: Document range argument for Kernel#rand.
	  [ruby-core:51794] [Bug #7770]

Sun Feb  3 10:00:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* numeric.c: Document Float constants [ruby-core:51484] [Bug #7709]

Sun Feb  3 09:38:44 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/profiler.rb (PROFILE_CALL_PROC, PROFILE_RETURN_PROC): add b_call
	  and b_return to profile block calls.

	* lib/profiler.rb (PROFILE_CALL_PROC, PROFILE_RETURN_PROC): split
	  PROFILE_PROC for call and return events.

Sat Feb  2 14:32:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/minitest/mock.rb, lib/minitest/hell.rb: nodoc top-level module

Sat Feb  2 14:05:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/debug.rb: Documentation for DEBUGGER__ class methods based on
	  patch by Vincent Batts [ruby-core:51253]

Sat Feb  2 13:37:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/net/smtp.rb: Fix rdoc title for Net::SMTP

Sat Feb  2 13:32:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/net/pop.rb: Fix rdoc title for Net::POP3

Sat Feb  2 13:00:11 2013  Yusuke Endoh  <mame@tsg.ne.jp>

	* lib/gserver.rb (GServer#start): fix a timing issue.  patch from
	  Charles Nutter.  [Bug #7081]

Sat Feb  2 12:36:54 2013  Yusuke Endoh  <mame@tsg.ne.jp>

	* lib/fileutils.rb (copy_entry, wrap_traverse): preserve attributes of
	  directories on FileUtils.cp_r.  The fix was proposed by Jan
	  Wedekind.  [Bug #7246]

	* test/fileutils/test_fileutils.rb: add a test for above.

Sat Feb  2 12:30:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/uri/ftp.rb (URI::FTP.new2): nodoc method from r39013 [Bug #7301]

Sat Feb  2 12:15:36 2013  Yusuke Endoh  <mame@tsg.ne.jp>

	* lib/uri/ftp.rb (URI::FTP.new2): remove the rdoc because it is not
	  well tested yet.  [Bug #7301]

Sat Feb  2 12:07:41 2013  Yusuke Endoh  <mame@tsg.ne.jp>

	* ChangeLog: Forgot to add a reference to the ChangeLog of the
	  previous commit.

Sat Feb  2 12:05:18 2013  Yusuke Endoh  <mame@tsg.ne.jp>

	* lib/fileutils.rb: chmod/chmod_R with a string mode (e.g., "+x")
	  caused error in verbose mode.  [Bug #7373]

	* test/fileutils/test_fileutils.rb: add a test for above.

Sat Feb  2 11:44:42 2013  Yusuke Endoh  <mame@tsg.ne.jp>

	* lib/English.rb: Remove some confusing words from rdoc.  [Bug #7406]

Sat Feb  2 10:17:12 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* NEWS: add keyword arguments.

Sat Feb  2 07:45:44 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* proc.c (proc_curry): Fix arity check [Bug #5747]

	* test/ruby/test_proc.rb: Test for above

Sat Feb  2 07:44:15 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* proc.c: Add {*}_min_max_arity and refactor.
	  [Bug #7765]

	* test/ruby/test_proc.rb: Fix wrong test

Fri Feb  2 00:46:00 2013  Charlie Somerville  <charlie@charliesomerville.com>

	* marshal.c: add security considerations to marshal overview, refer to
	  overview from Marshal.load documentation [#7759]

Fri Feb  1 23:04:00 2013  Charlie Somerville  <charlie@charliesomerville.com>

	* array.c (rb_ary_dup): make returned array the same class as the original
	  array [Bug #7768] [ruby-core:51792]
	* test/ruby/test_array.rb (class TestArray): add test

Fri Feb  1 16:35:34 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (r_object0): prohibit setting instance variables of
	  existing class/module.

Fri Feb  1 14:34:29 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/readline/extconf.rb, ext/readline/readline.c: check
	  RL_PROMPT_START_IGNORE and RL_PROMPT_END_IGNORE directly in
	  readline.c.  Patch by Zachary Scott.  [Bug #7397] [ruby-core:49561]

Thu Jan 31 21:55:00 2013  Charlie Somerville  <charlie@charliesomerville.com>

	* marshal.c (marshal_load): Add documentation warning against using
	  Marshal.load on untrusted data [Bug #7759] [ruby-core:51765]

Thu Jan 31 16:33:27 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (local_push_gen): no assigned but unused variable warnings
	  in eval as well as -e.  [Feature #7730] [ruby-core:51580]

Wed Jan 30 12:30:08 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_signal.rb (test_trap_puts): Fix typo. "sync"
	  should be "STDOUT.sync".

Thu Jan 31 15:39:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* string.c (rb_str_aset_m): Documentation for String#[]= fix
	  Raises an IndexError if Regexp match is out of range.
	  Github fixes #243 Patch by Dmtiriy Budnik

Thu Jan 31 13:54:44 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/raddrinfo.c (rsock_unix_sockaddr_len): return
	  sizeof(sa_family_t) if path is empty.  see "Autobind Feature" in
	  unix(7) for details.

	* ext/socket/lib/socket.rb (unix_socket_abstract_name?): treat an
	  empty path as an abstract name.

	* test/socket/test_unix.rb: related test.

Wed Jan 30 20:58:50 2013  Tanaka Akira  <akr@fsij.org>

	* ext/socket/basicsocket.c (bsock_getsockname): ignore truncated
	  part of socket address.
	  (bsock_getpeername): ditto.
	  (bsock_local_address): ditto.
	  (bsock_remote_address): ditto.

	* ext/socket/unixsocket.c (unix_path): ditto.
	  (unix_addr): ditto.
	  (unix_peeraddr): ditto.

	* ext/socket/init.c (cloexec_accept): ditto.

Wed Jan 30 17:08:20 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/win32.h (fstat): revert r37337, which uses _fstati64()
	  instead of fstati64() on mingw32.  [Bug #7276]

Wed Jan 30 15:26:37 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/unixsocket.c (rsock_init_unixsock): use rb_inspect()
	  because rb_sys_fail_str() fails if its argument contains NUL.

	* test/socket/test_unix.rb: related test.

Wed Jan 30 15:21:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_dump.c (rb_vm_bugreport): show the most important message, Crash
	  Report log information, first.

Wed Jan 30 15:00:05 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* array.c (rb_ary_bsearch): Raise TypeError on bad return from block

	* range.c (range_bsearch): ditto

	* test/ruby/test_array.rb (class): Test for above

	* test/ruby/test_range.rb (class): ditto

Wed Jan 30 14:46:28 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* range.c: Restrict bsearch to integers [#7728]

	* test/ruby/test_range.rb: Test for above

Wed Jan 30 14:10:52 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* array.c (rb_ary_bsearch): Return enumerator if no block [#7725]

	* range.c (range_bsearch): ditto

	* test/ruby/test_array.rb: Test for above

	* test/ruby/test_range.rb: ditto

Wed Jan 30 13:53:43 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Take conjugate for inner product
	  [rubyspec:5a01ad5719f2] [ruby-dev:46101]

Wed Jan 30 13:22:05 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (local_push_gen): warn assigned but unused variables also in
	  toplevel, except for -e option.  [Feature #7730] [ruby-core:51580]

Wed Jan 30 13:17:53 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* cont.c (cont_restore_thread): svar should be separate per fibers.
	  [ruby-core:51331] [Bug #7678]

Wed Jan 30 07:15:04 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* re.c (reg_operand): Simplify and reuse error handling [Bug #7539]

	* test/ruby/test_regexp.rb: Test for above

Wed Jan 30 07:00:16 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* object.c: Improve error for failed implicit conversions [Bug #7539]

	* error.c: Adapt rdoc

	* test/ruby/test_object.rb: Test for above

Tue Jan 29 21:40:12 2013  Tanaka Akira  <akr@fsij.org>

	* lib/net/http/generic_request.rb (encode_multipart_form_data): remove
	  tempfile explicitly.

Tue Jan 29 19:27:18 2013  Benoit Daloze  <eregontp@gmail.com>

	* array.c: Improve documentation about
	  comparison by hash for concerned methods. [ruby-core:51266]

Tue Jan 29 17:03:28 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_backtrace.c: fix issue of rb_debug_inspector_open().
	  The order of making binding should be stack (frame) top to bottom.
	  [Bug #7635]
	  And also fix issue of collecting klass. Collecting klass is same
	  as TracePoint#defined_class.
	  (previous version, it returns T_ICLASS (internal objects).

	* test/-ext-/debug/test_debug.rb: add a test.

	* ext/-test-/debug/extconf.rb, init.c, inspector.c: ditto.

	* vm_backtrace.c: remove magic number and add enum CALLER_BINDING_*.

	* vm_backtrace.c, include/ruby/debug.h: add new C api (experimental)
	  rb_debug_inspector_frame_self_get().

	* vm.c, vm_core.h, vm_trace.c: move decl. of
	  rb_vm_control_frame_id_and_class() and constify first parameter.

Tue Jan 29 16:50:58 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_trace.c (rb_tracepoint_enable, rb_tracepoint_disable): check safe
	  level as well as set_trace_func.

	* vm_trace.c (set_trace_func, thread_{add,set}_trace_func_m): check
	  safe level as well as 1.8.

Tue Jan 29 16:49:19 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* proc.c (rb_mod_method_arity): return original arity of the method if
	  aliased because of visibility change, like as Method#arity.

Tue Jan 29 12:05:18 2013  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_marshal.rb: remove temporally files early.

	* test/ruby/test_process.rb: ditto.

	* test/psych/test_exception.rb: ditto.

Tue Jan 29 09:26:20 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/socket.c (sock_s_pack_sockaddr_un): calculate the
	  correct address length of an abstract socket.

	* test/socket/test_unix.rb: related test.

Mon Jan 28 18:02:16 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_backtrace.c (rb_debug_inspector_frame_{class,binding,iseq}_get):
	  use long as index as well as RARRAY_LEN().

Mon Jan 28 17:51:38 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/envutil.rb (assert_separately): imply no core dump.

Mon Jan 28 12:32:31 2013  Tanaka Akira  <akr@fsij.org>

	* ext/fcntl/fcntl.c: update document.  use "file descriptor" instead
	  of "file handle" because it is not used other Ruby documents and
	  it is confusing with Windows file handle.
	  correct F_DUPFD behavior.

Sat Jan 26 22:39:12 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (w_object): dump instance variables of the result of
	  marshal_dump not the original object.  [ruby-core:51163] [Bug #7627]

	* complex.c (nucomp_marshal_dump): need to copy instance variables.

	* rational.c (nurat_marshal_dump): ditto.

Sat Jan 26 13:35:56 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/fcntl/fcntl.c:  Document Fcntl constants

Sat Jan 26 12:54:40 2013  Eric Hodel  <drbrain@segment7.net>

	* hash.c (rb_env_size):  Restored documentation for ENV.size

	* lib/drb/drb.rb:  Documented DRb::DRb#run.

	* lib/erb.rb (class ERB):  Improved documentation of ERb.

	* transcode.c:  Documented Encoding::Converter constants.

Sat Jan 26 10:09:57 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/webrick/accesslog.rb:  Improved WEBrick documentation.
	* lib/webrick/cgi.rb:  ditto.
	* lib/webrick/config.rb:  ditto.
	* lib/webrick/cookie.rb:  ditto.
	* lib/webrick/httpauth/authenticator.rb:  ditto.
	* lib/webrick/httpauth/basicauth.rb:  ditto.
	* lib/webrick/httpauth/digestauth.rb:  ditto.
	* lib/webrick/httpproxy.rb:  ditto.
	* lib/webrick/httprequest.rb:  ditto.
	* lib/webrick/httpresponse.rb:  ditto.
	* lib/webrick/https.rb:  ditto.
	* lib/webrick/httpserver.rb:  ditto.
	* lib/webrick/httpservlet/cgihandler.rb:  ditto.
	* lib/webrick/httpservlet/filehandler.rb:  ditto.
	* lib/webrick/httpservlet/prochandler.rb:  ditto.
	* lib/webrick/httputils.rb:  ditto.
	* lib/webrick/httpversion.rb:  ditto.
	* lib/webrick/log.rb:  ditto.
	* lib/webrick/server.rb:  ditto.
	* lib/webrick/ssl.rb:  ditto.
	* lib/webrick/utils.rb:  ditto.
	* lib/webrick/version.rb:  ditto.

Sat Jan 26 08:29:33 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/raddrinfo (rsock_unix_sockaddr_len): renamed from
	  rsock_unixpath_len, because it returns not the length of the path,
	  but the length of a socket address for the path.

Sat Jan 26 01:12:23 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/ruby/test_io.rb (test_ioctl_linux): skip if a platform is
	  not x86 because linux ioctl request number depend on cpu arch.
	  At least, alpha, mips, sparc and ppc have a different number.
	  [Bug #7718] [ruby-core:51544]

Fri Jan 25 19:14:24 2013  Masaki Suketa <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c: use TlsAlloc instead of __declspec(thread)
	  to avoid SEGV if win32ole.so loaded with LoadLibrary in Windows
	  XP or earlier.

Fri Jan 25 16:47:31 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/raddrinfo.c (rsock_unixpath_len, init_unix_addrinfo),
	  ext/socket/unixsocket.c (unixsock_connect_internal,
	  rsock_init_unixsock): calculate the correct address length of
	  an abstract socket.  Without this fix, sizeof(struct sockaddr_un)
	  is specified as the length of an abstract socket for bind(2) or
	  connect(2), so the address of the socket is filled with extra NUL
	  characters.  See unix(7) for details.

	* ext/socket/lib/socket.rb (unix_server_socket): don't access the
	  file system if the platform is Linux and path starts with NUL,
	  which means that the socket is an abstract socket.

	* test/socket/test_unix.rb: related test.

Fri Jan 25 13:02:27 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/drb/drb.rb:  Updated documentation based on patch from Vincent
	  Batts.  [ruby-trunk - Bug #7714]
	* lib/drb/ssl.rb:  ditto.

Fri Jan 25 12:23:29 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/drb/drb.rb:  Improved documentation by adding or hiding methods.
	* lib/drb/eq.rb:  ditto.
	* lib/drb/extserv.rb:  ditto.
	* lib/drb/gw.rb:  ditto.
	* lib/drb/invokemethod.rb:  ditto.
	* lib/drb/observer.rb:  ditto.
	* lib/drb/ssl.rb:  ditto.
	* lib/drb/timeridconv.rb:  ditto.
	* lib/drb/unix.rb:  ditto.

	* sample/drb/gw_cu.rb:  Fixed bug in DRb gateway sample.

Fri Jan 25 12:01:56 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h: modify a comment about rb_iseq_t::local_size.
	  A patch by davidbalbert (David Albert) [Bug #6750]

Fri Jan 25 10:36:31 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/mkmf.rb:  Documented MakeMakefile constants.  Hide implementation
	  details from RDoc

Fri Jan 25 10:04:07 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/compatibility.rb:  Hide compatibility shims from RDoc

	* lib/rubygems/config_file.rb:  Hide RbConfig use from RDoc

	* lib/rubygems/test_case.rb:  Added note to use realpath when 1.8
	  support is dropped.

Fri Jan 25 09:14:43 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/generator/darkfish.rb:  Fixed debug message.  RDoc bug #174
	  by Thomas Leitner.

	* lib/rdoc/store.rb:  Fixed deletion of ri attribute data when a class
	  was loaded then saved.  RDoc bug #171 by Thomas Leitner.
	* test/rdoc/test_rdoc_store.rb:  Test for above.

Thu Jan 24 19:55:25 2013  Shota Fukumori  <her@sorah.jp>

	* NEWS (yaml): Write about bundled libyaml.

Thu Jan 24 16:54:34 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/calling_methods.rdoc:  Added a Method Lookup section.
	* doc/syntax/refinements.rdoc (Method Lookup):  Clarified that
	  refinement methods are looked up in classes, not instances.

Thu Jan 24 16:49:17 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* enum.c (enum_zip): Fix error message

	* array.c (take_items): Same, for Array#zip

Thu Jan 24 16:47:26 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* enumerator.c (lazy_zip): raise error for bad arguments
	  [Bug #7706]

Thu Jan 24 16:05:08 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* enumerator.c: Optimize Lazy#zip when passed only arrays
	  [Bug #7706]

Thu Jan 24 15:21:17 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* enumerator.c: Fix state handling for Lazy#zip,{drop_take}{_while}
	  [bug #7696] [bug #7691]

Thu Jan 24 11:43:47 2013  Narihiro Nakamura  <authornari@gmail.com>

	* eval.c (f_current_dirname): Add documentation about "__dir__
	  returns always an absolute path". [Bug #7729]

Thu Jan 24 10:28:30 2013  Eric Hodel  <drbrain@segment7.net>

	* NEWS (RDoc):  Added mention of page support and markdown support.

Thu Jan 24 09:40:13 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/refinements.rdoc:  Added refinements document based on
	  the specification from the wiki.
	* doc/syntax.rdoc:  Added link to refinements document.

Wed Jan 23 16:29:09 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (rb_w32_spawn, rb_w32_aspawn_flags): fix missing
	  initialization.  pointed out by phasis68 (Heesob Park) at
	  [ruby-core:51579].  [Bug #7721]

Wed Jan 23 16:18:04 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MakeMakefile#try_constant): fix for large unsigned.

	* lib/mkmf.rb (MakeMakefile#try_constant): fix for larger constants.

	* test/mkmf/test_constant.rb: tests for try_constant.
	  TODO: define check_constant and use it.

Wed Jan 23 13:35:37 2013  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (ruby_init_stack): ignore `STACK_END_ADDRESS'
	  if Ruby interpreter is running on co-routine.
	  [Feature #2294]
	  https://bugs.ruby-lang.org/issues/2294#note-18

Wed Jan 23 12:28:22 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (rb_w32_spawn, rb_w32_aspawn_flags): check the results
	  of acp_to_wstr() which can return NULL.  [ruby-core:51557] [Bug #7721]

Wed Jan 23 10:40:49 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/assignment.rdoc (Implicit Array Assignment):  Clarify
	  that "left-hand side" means "of the assignment".  Suggested by Jorge
	  Dias.
	* doc/syntax/assignment.rdoc (Multiple Assignment):  ditto.

Wed Jan 23 10:34:47 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/assignment.rdoc (Local Variables and Methods):  Fixed
	  example showing caching of a method's results into a local variable.
	  Added not about using an explicit receiver to call a method that
	  matches a local variable.  Suggested by markov_twain on twitter.

Wed Jan 23 10:20:08 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/README:  Fixed typo.  Patch by Pradeep Sahoo.
	  Fixes #240 on github

Wed Jan 23 09:53:39 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/servlet.rb:  Fixed display of site and home documentation.
	  Fixes rdoc issue #170 by Thomas Leitner.
	* test/rdoc/test_rdoc_servlet.rb:  Test for above.

	* lib/rdoc/code_object.rb:  Split #initialize_visibility from
	  #initialize for reuse when loading a stored object.
	  Fixes rdoc issue #171 by Thomas Leitner.

	* lib/rdoc/any_method.rb:  Initialize visibility for #display?  For
	  rdoc issue #171
	* lib/rdoc/attr.rb:  ditto.
	* lib/rdoc/class_module.rb:  ditto.
	* lib/rdoc/top_level.rb:  ditto.
	* test/rdoc/test_rdoc_any_method.rb:  Test for above.
	* test/rdoc/test_rdoc_attr.rb:  ditto.
	* test/rdoc/test_rdoc_class_module.rb:  ditto.
	* test/rdoc/test_rdoc_constant.rb:  ditto.
	* test/rdoc/test_rdoc_top_level.rb:  ditto.

Wed Jan 23 06:43:26 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/test_case.rb:  Use Dir.tmpdir for rubygems tests instead
	  of ./tmp/test.  Fixes [ruby-trunk - Bug #7717]

Tue Jan 22 22:58:03 2013  Akinori MUSHA  <knu@iDaemons.org>

	* misc/ruby-electric.el (ruby-electric-curlies): Fix the bug where
	  an open curly inserted in a string is always replaced with a
	  hash sign.

Mon Jan 21 15:41:33 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/mkconfig.rb: BASERUBY is transient at core build.

Mon Jan 21 13:51:21 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb ($extmk): traverse parent directories for the case
	  srcdir is a symlink.

Sun Jan 20 23:55:37 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* marshal.c (w_object, r_object0): separate respond_to checks and
	  calling, and get back to the old behavior for 2.0.  [Bug #7564]

Sun Jan 20 22:24:28 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/vpath.rb (VPath#def_options): hack for msys make, which
	  converts a command line argument to non-msys command seems like a
	  path list automagically.  [Bug #7710] [ruby-core:51489]

Sat Jan 19 11:35:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* struct.c (Struct.new): Document Struct.new with block
	  Patch by Hiroyuki Iwatsuki [Bug #7674]

Sat Jan 19 09:52:46 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/miscellaneous.rdoc:  Added section on defined?

Sat Jan 19 09:27:31 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/assignment.rdoc (Local Variables and Methods):  Made it
	  more clear that local variables are created by the parser, not
	  execution.  Thanks to John Hawthorn.

Sat Jan 19 09:15:58 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/assignment.rdoc:  Improved links
	* doc/syntax/methods.rdoc:  ditto.

	* doc/syntax.rdoc:  Added link to assignment document

Sat Jan 19 08:47:33 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/assignment.rdoc:  Added a syntax document on assignment.

Fri Jan 18 14:11:01 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/methods.rdoc:  Added Array Decomposition.

Fri Jan 18 12:54:21 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/rbinstall.rb (gem): Gem.ensure_gem_subdirectories makes
	  subdirectories group-writable, so make them with $dir_mode.

Fri Jan 18 11:24:33 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/win32ole/win32ole.c (ole_initialize): uninitialize OLE at thread
	  ends.  [Bug #2618] [ruby-core:27634]

	* ext/win32ole/win32ole.c (ole_initialize): initialize OLE for each
	  threads.  [Bug #2618] [ruby-core:27634]

Thu Jan 17 22:10:35 2013  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rubygems/ext/builder.rb (Gem::Ext::Builder.make): Remove
	  .time dependency from *.rb install target. It causes needless
	  *.rb install. [Bug #7698] [ruby-core:51437]
	  Reported by Tadashi Saito. Thanks!!!
	* test/rubygems/test_gem_installer.rb
	  (TestGemInstaller#test_install_extension_and_script): Add a test
	  for the above change.

Thu Jan 17 21:08:20 2013  Kouhei Sutou  <kou@cozmixng.org>

	* eval.c: Fix a typo in ruby_finalize() documentation.

Thu Jan 17 20:28:18 2013  Benoit Daloze  <eregontp@gmail.com>

	* object.c: Typo in Kernel#hash documentation.
	  Patch by zed_0xff [Github Fixes #237]

Thu Jan 17 10:48:56 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/scalar_scanner.rb: use constants rather than
	  calculating Inf and NaN.

Thu Jan 17 10:21:05 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/miscellaneous.rdoc:  Added Ending an Expression and
	  indentation.

Thu Jan 17 09:30:21 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/installer.rb:  Untaint string when checking output
	  for $SAFE=1

	* lib/rubygems/specification.rb:  Keep previously loaded specs as
	  active.  This prevents double loading when refreshing the gem list.
	* test/rubygems/test_gem.rb:  Test for above

	* lib/rubygems.rb:  Bump version to 2.0.0.rc.2

Thu Jan 17 09:08:37 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/control_expressions.rdoc:  Added ? : ternary if

Thu Jan 17 08:36:04 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/miscellaneous.rdoc:  Added documentation for alias, undef,
	  BEGIN, END.
	* doc/syntax/modules_and_classes.rdoc (Constants):  Fixed unwrapped
	  paragraph with trailing whitespace.
	* doc/syntax/modules_and_classes.rdoc (Scope):  Added section pointing
	  to alias and undef documentation.
	* doc/syntax.rdoc:  Added link to miscellaneous section.

Thu Jan 17 07:50:26 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/control_expressions.rdoc (Flip-Flop):  Added a section on
	  the flip-flop.

Thu Jan 17 06:59:51 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/control_expressions.rdoc (if Expressions):  Fixed markup
	  error.  Fixes #235 on github by FlyingFoX.

Thu Jan 17 06:53:58 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/literals.rdoc (Strings):  Fixed typo.  Fixes #236 on
	  github by Doug Yun.

Wed Jan 16 18:45:46 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/win32ole/lib/win32ole.rb: use TracePoint to hook all thread
	  creation not only by Thread.new and to get rid of interference with
	  svar scope.  [Bug #7681] [ruby-core:51365]

Wed Jan 16 09:35:53 2013  Eric Hodel  <drbrain@segment7.net>

	* .document:  Removed extra space
	* lib/irb/lc/.document:  Hide help-message
	* lib/minitest/.document:  Hide README.txt
	* lib/rake/lib/.document:  Hide project.rake
	* lib/rdoc/generator/template/json_index/.document:  Hide JavaScript
	  files
	* lib/rubygems/ssl_certs/.document:  Hide PEM files.

Wed Jan 16 03:54:28 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/control_expressions.rdoc:  Omit optional "then" for if and
	  unless expressions.  Improved description of "a if a = 0.zero?"
	  NameError.  Note that "do" for for loop is optional.

Wed Jan 16 03:28:47 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/calling_methods.rdoc:  Link to defining methods.
	* doc/syntax/methods.rdoc:  Link to calling methods, fixed typo.

Wed Jan 16 03:15:00 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/methods.rdoc:  Fixed link
	* doc/syntax/modules_and_classes.rdoc:  Fixed link
	* doc/syntax.rdoc:  Updated with links to the recently added pages

Wed Jan 16 03:05:50 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/control_expressions.rdoc (redo Statement):  Added note
	  about retry.
	* doc/syntax/exceptions.rdoc:  Added retry statement

Tue Jan 15 23:12:34 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/vpath.rb (VPath#list): default separator to PATH_SEPARATOR from
	  configure.in for make, not same name constant of File for use in ruby.

Tue Jan 15 22:30:04 2013  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/ext/save-history.rb: identify rightly a status of a
	  history file that already exists [Bug #7694]. Thanks Nobuhiro IMAI
	  for this patch.

Tue Jan 15 15:55:28 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/control_expressions.rdoc:  Added description of control
	  expressions in ruby.

Tue Jan 15 13:33:00 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/methods.rdoc (Method Names):  Added method names including
	  operator methods.
	* doc/syntax/methods.rdoc (Return Values):  Added note that assignment
	  methods ignore return values.
	* doc/syntax/precedence.rdoc:  Added document describing precedence.

Tue Jan 15 11:49:31 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/methods.rdoc (Block Argument):  Added section on block
	  argument.  Thanks to Andy Lindeman.

Tue Jan 15 10:54:59 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/calling_methods.rdoc (Arguments):  Added improved
	  introduction to arguments including passing style and lazy
	  evaluation.  Thanks to Matt Aimonetti.
	* doc/syntax/calling_methods.rdoc (Positional Arguments):  Added
	  description for sending a message to a method with *arguments
	* doc/syntax/calling_methods.rdoc (Default Positional Arguments):
	  Added description.  Thanks to Andy Lindeman.
	* doc/syntax/calling_methods.rdoc (Block Local Arguments):
	  Added description of block locals.  Thanks to Justin Collins.
	* doc/syntax/calling_methods.rdoc (Hash to Keyword Arguments):  Added
	  section describing ** operator.  Thanks  to Justin Collins.

Tue Jan 15 10:40:18 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* test_lazy_enumerator: Test that map & flat_map also require a block

Tue Jan 15 09:22:47 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (gvl_init): Reset gvl.wait_yield explicitly when
	  fork()ing. Patch by Apollon Oikonomopoulos. Thanks!
	  [Bug #7693][ruby-core:51424]

Tue Jan 15 09:27:56 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/calling_methods.rdoc (Receiver):  Added :: as pointed out
	  by Tony Arcieri
	* doc/syntax/calling_methods.rdoc (Block Argument):  Fixed { } block
	  examples as pointed out by David Copeland.

Tue Jan 15 09:10:29 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/methods.rdoc (Array/Hash Argument):  Moved above Keyword
	  Arguments
	* doc/syntax/methods.rdoc (Keyword Arguments):  Described ** for
	  gathering arbitrary keyword arguments.

Tue Jan 15 08:56:37 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/calling_methods.rdoc:  Added document describing method
	  calls.

Tue Jan 15 07:39:21 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/top_level.rb:  Fixed extension trimming for page names in
	  RDoc HTML output.  [ruby-trunk - Bug #7673]
	* test/rdoc/test_rdoc_top_level.rb:  Test for above.

Mon Jan 14 23:06:41 2013  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/ext/save-history.rb: outputs its history to
	  owner-only-readable file and change the permission of a file that
	  already exists [Bug #7694]. Thanks Nobuhiro IMAI for bug reports.

Mon Jan 14 17:12:48 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* enumerator.c (lazy_flat_map_func): flat_map should call each only
	  when the value of a block returns a forcable object.
	  [ruby-core:51401] [Bug #7690]

	* enumerator.c (lazy_flat_map): add documentation.

	* test/ruby/test_lazy_enumerator.rb: related test.

Mon Jan 14 16:42:28 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* enumerator.c: Require block for Lazy#{take|drop}_while [Bug #7692]

Mon Jan 14 14:41:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_to_s): use CRuby style.

Mon Jan 14 14:39:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c: use `RB_TYPE_P(x, t)` instead of
	  `TYPE(x) == t`.

Mon Jan 14 10:18:56 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* enumerator.c: Fix size for Enumerator::Lazy#flat_map

Mon Jan 14 07:12:52 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix/lup_decomposition: Fix bugs with LUP Decomposition of
	  rectangular matrices. [rubyspec:ba849801a85]

Mon Jan 14 06:46:53 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* regparse.c (add_ctype_to_cc): don't check dup warn on adding
	  negative ctype to cclass. [Bug #7471] [ruby-core:50344]

Mon Jan 14 06:06:03 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix/eigenvalue_decomposition: Backport bugfix of Jama 1.0.3
	  [rubyspec:df87040be371]

Sun Jan 13 16:45:00 2013  Zachary Scott <zachary@zacharyscott.net>

	* ext/psych/yaml/scanner.c: Fix typos, patch by James Dabbs
	  [Github tenderlove/psych#118]

Sun Jan 13 15:00:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_sub):
	  need to specify precision for converting Rational and Float.
	  [ruby-dev:46544] [Bug #7404]

	* ext/bigdecimal/bigdecimal.c (BigDecimal_mult): ditto.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_divide): ditto.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_DoDivmod): ditto.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_divremain): ditto.

	* test/bigdecimal/test_bigdecimal.rb: add tests for the above fixes.

Sun Jan 13 14:48:55 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix/eigenvalue_decomposition: Fix eigensystem with complex
	  eigenvectors. Patch by pypypy567.
	  [Bug #7208] [ruby-dev:46251] [rubyspec:242f8e55bd]

	* lib/matrix/lup_decomposition.rb: Fix error for rectangular matrices
	  [bug#7620] [ruby-core:51118] [rubyspec:41f833ee2]

Sun Jan 13 14:06:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/irb.rb, lib/prime.rb: Typos in overview
	  Patch by Ershad K [Github Fixes #234]

Sun Jan 13 13:40:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/open3.rb : Typo in Open3 overview. Patch by zed_0xff
	  [Github Fixes #233]

Sat Jan 12 17:42:00 2013  Kenta Murata  <mrkn@cookpad.com>

	* numeric.c (do_coerce): fix for the exceptions which the coerce
	  method raises.  The optimization done by r38756 is preserved.
	  [Bug #7645] [ruby-core:51213]

Sat Jan 12 16:12:46 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/setup.mak (-runtime-): see msvcrt from link header on mswin
	  instead of running testing executable file, for cross compiling.

Sat Jan 12 08:58:47 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: merge key values that
	  contain something besides a hash should be left in tact.

	* test/psych/test_merge_keys.rb: test for change

Sat Jan 12 07:52:47 2013  Masaki Suketa <masaki.suketa@nifty.ne.jp>

	* ext/win32ole/win32ole.c (ole_set_byref): support VT_UI8|VT_BYREF,
	  VT_I8|VT_BYREF in cygwin and mingw.

	* ext/win32ole/win32ole.c (ole_variant2val): ditto.

	* test/win32ole/test_win32ole_variant.rb (test_s_new_with_i8_byref):
	  ditto.

	* test/win32ole/test_win32ole_variant.rb (test_s_new_with_ui8_byref):
	  ditto.

Sat Jan 12 02:45:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* man/ruby.1 (options): include --*-encoding from r38784

Fri Jan 11 23:34:48 2013  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* ruby.c (usage): sort --*-encoding in help. (same order of -E)

Fri Jan 11 16:56:29 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/mkconfig.rb: use configured libdir value to fix
	  --enable-load-relative on systems where libdir is not default value,
	  overridden in config.site files.  [ruby-core:47267] [Bug #6903]

Fri Jan 11 11:59:32 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (dispose_string): use rb_str_free for freeing string in
	  parse.y. by Sokolov Yura <funny.falcon@gmail.com>
	  https://github.com/ruby/ruby/pull/87 fix GH-87

Fri Jan 11 09:56:22 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* insns.def (defineclass): private constants should not be accessed
	  by scoped module definitions.  The bug was introduced in r38495.

	* test/ruby/test_module.rb: related test.

Fri Jan 11 02:11:59 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/rbconfig/obsolete.rb (respond_to_missing?): use send because
	  RbConfig.respond_to_missing? is now private.

Thu Jan 10 22:00:58 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h (VM_DEBUG_BP_CHECK): set 0 as default.
	  This flag specifies checking BP consistency on each frame popping.
	  Now, we don't have any trouble on it, so I remove it.
	  If you feel any bugs about VM execution, then set it to 1.

Thu Jan 10 21:03:05 2013 TAKANO `takano32' Mitsuhiro <tak@no32.tk>

	* cont.c: define FIBER_USE_NATIVE as 0 in ia64.

Thu Jan 10 19:39:05 2013  TAKANO `takano32' Mitsuhiro <tak@no32.tk>

	* thread.c: fix RB_GC_SAVE_MACHINE_REGISTER_STACK define for ia64.

Thu Jan 10 17:45:39 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* Makefile.in, win32/Makefile.sub ($(MKFILES)): continue if Makefile
	  unchanged.

Thu Jan 10 16:31:20 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_insnhelper.c (vm_search_super_method): raise a TypeError
	  instead of a NotImplementedError if self is not an instance of the
	  current class.  [ruby-dev:39772] [Bug #2402]

Thu Jan 10 16:47:18 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/tk/extconf.rb (find_tcltk_header): use have_header instead of
	  try_cpp, which is incredibly slow with VC.

Thu Jan 10 15:55:28 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* numeric.c (do_coerce): remove an unused variable.

Thu Jan 10 15:35:55 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* tool/gen_dummy_probes.rb: remove comments in probes.d to fix the
	  compilation error introduced by r38755.

Thu Jan 10 11:15:04 2013  Kenta Murata  <mrkn@cookpad.com>

	* numeric.c (do_coerce): speed optimization by using rb_check_funcall
	  instead of rb_rescue + rb_funcall.
	  This fix is based on the patch by Benoit Daloze.
	  [Bug #7645] [ruby-core:51213]

Thu Jan 10 11:15:04 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* probes.d: updating probes to be more symmetrical, adding
	  documentation.

	* load.c: ditto

Thu Jan 10 04:23:07 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/scalar_scanner.rb: strip trailing dots from
	  floats so that Float() will not raise an exception.

	* test/psych/test_numeric.rb: test to ensure "1." can be loaded

	* test/psych/test_string.rb: make sure "1." can round trip

Thu Jan 10 03:38:40 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: ascii only binary strings
	  will be dumped as unicode.  Thanks Paul Kunysch!

	* test/psych/test_string.rb: appropriate test

Thu Jan 10 03:29:55 2013  Koichi Sasada  <ko1@atdot.net>

	* compile.c (compile_array_): modify wrong optimization.
	  A script "[print(1)]; print(2)" should output "12".
	  However, the compiler had eliminated "[print(1)]" expression
	  because it is void expression (unused array).
	  Of course, side-effect should be remained.
	  This issue is reported by Masaya Tarui.

	* bootstraptest/test_literal.rb: add a test.

Wed Jan  9 22:07:42 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* load.c (load_lock): if thread shield is destroyed and there is no
	  waiting thread, insert new thread shield into load_table.
	  [Bug #7530] [ruby-core:50645]

Wed Jan  9 21:43:32 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* load.c (load_lock): revert r38744. it should acquire new thread
	  shield.

Wed Jan  9 15:40:18 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (th_init, ruby_thread_init): initialize root_svar with Qnil,
	  since lep_svar_place() expects uninitialized svar to be nil, not 0.

Wed Jan  9 13:20:23 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* test/ruby/test_require.rb: improve test for r38744.
	  fix to use Tempfile instead of temporary file in current directory.
	  the patch is from nobu (Nobuyoshi Nakada).

Wed Jan  9 09:53:23 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* load.c (load_lock): fix not to delete thread shield twice.
	  it may break the shield locked by another thread.
	  [Bug #7530] [ruby-core:50645]

	* test/ruby/test_require.rb: a test for above.

Wed Jan  9 02:13:22 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (RBasic): to be aligned on a VALUE size
	  boundary.  [Bug #7647]

Tue Jan  8 14:41:41 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_core.h (rb_iseq_t): move flip_cnt from struct iseq_compile_data,
	  because it has same life span as enclosing iseq.  [Bug #7671]
	  [ruby-core:51296]

Mon Jan  7 23:43:00 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (rmpd_power_by_big_decimal):
	  add RB_GC_GUARD to prevent the intermediate object is GCed too early.
	  This patch was made by Yusuke Endoh.  [Bug #7044] [ruby-core:47632]

	* test/bigdecimal/test_bigdecimal.rb: add a reproduction test for
	  the issue [Bug #7044]

Mon Jan  7 21:40:36 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* vm_method.c (Init_eval_method): main.public and main.private
	  should be private.

	* proc.c (Init_Proc): main.define_method should be private.

	* test/ruby/test_module.rb: related test.

Mon Jan  7 20:48:47 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* eval.c (Init_eval): main.include should be private.
	  [ruby-core:51293] [Bug #7670]

	* test/ruby/test_module.rb (test_top_include_is_private): a new test
	  for the above change.

Mon Jan  7 20:29:50 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* NEWS: remove description about `require "refinement"'.

Mon Jan  7 20:15:49 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* eval.c (Init_eval): enable Refinements by default.
	  [ruby-core:51286] [Bug #7667]

	* eval.c (rb_mod_refine, top_using): show a warning when
	  Module#refine or main.using is called at the first time.

	* ext/refinement/*: removed the extension library "refinement".

	* test/ruby/test_refinement.rb: fix for the above changes.

Mon Jan  7 17:34:22 2013  Koichi Sasada  <ko1@atdot.net>

	* include/ruby/ruby.h (RUBY_EVENT_SPECIFIED_LINE): make it special.
	  This flag is not contained by RUBY_EVENT_TRACEPOINT_ALL.
	  This event is experimental one. It is possible to remove/rename
	  flag name after 2.0.1.

	* vm_trace.c (get_event_id): return :line if SPECIFIED_LINE was
	  occurred. `:specified_line' never been returned.

Mon Jan  7 15:42:10 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (f_kwrest): allow bare kwrest_mark as valid syntax.  its
	  semantics is still undefined.  [Bug #7662] [ruby-core:51269]

Mon Jan  7 15:31:58 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (f_kwrest): reject duplicated kwrest argument name.

Mon Jan  7 15:24:10 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c (rb_threadptr_exec_event_hooks_orig): pop tag before
	  JUMP_TAG() if frame is `finish' frame.
	  Without this patch, there is an inconsistency between control
	  frame stack and tags stack.
	  [Bug #7668]

	* test/ruby/test_settracefunc.rb: add a test for above.

Mon Jan  7 15:21:48 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* Makefile.in, common.mk (fake, yes-fake, no-make): these dependencies
	  are not platform dependent.

	* win32/Makefile.sub ($(arch)-fake.rb): workaround.

Mon Jan  7 12:09:24 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_callee_setup_arg_complex, vm_yield_setup_block_args):
	  set keyrest hash after making rest array, so that the last element
	  will not be overwritten.  [ruby-core:51278] [Bug #7665]

Mon Jan  7 09:37:24 2013  Koichi Sasada  <ko1@atdot.net>

	* NEWS: add a NEWS entry about RubyVM.

Sun Jan  6 19:06:57 2013  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* win32/Makefile.sub: Fix build with VC.
	  Patch by Charlie Savage. Fixes [ruby-core:51261]

Sun Jan  6 18:43:48 2013  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* bootstraptest/test_io.rb: add a test for [ruby-dev:46834].

	* io.c (rb_cloexec_fcntl_dupfd) Use an emulation with dup(2) when
	  fcntl(2) and/or F_DUPFD is unavailable.
	  Suggested by akr.

	* configure.in (HAVE_FCNTL): NativeClient does not provide fcntl(2).

Sun Jan  6 11:11:26 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/modules_and_classes.rdoc:  Fixed typo.

Sun Jan  6 05:35:18 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/modules_and_classes.rdoc:  Added singleton classes
	  documentation.

Sun Jan  6 02:22:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/webrick/httpservlet/abstract.rb (WEBrick::HTTPServlet): Typo in
	  example. Patch by shlensky [Fixes #232 on github]

Sat Jan  5 21:15:10 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http/generic_request.rb:
	  Amazon ECA API and GTE/1.3 disallow requests whose host has port
	  number if its port number equals to default port number of the
	  scheme. [Bug #7650]

Sat Jan  5 13:58:59 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/modules_and_classes.rdoc:  Improved description of methods
	  on a module or class as suggested by Tobias Buhlmann

Sat Jan  5 13:38:07 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* string.c (rb_str_enumerate_lines): fix invalid byte sequence error
	  when a separator is passed. The patch is from yoshidam (Yoshida
	  Masato).
	  [Bug #7646] [ruby-dev:46827]

	* test/ruby/test_string.rb: a test for above.

Sat Jan  5 12:25:42 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/envutil.rb (Test::Unit::Assertions#assert_in_out_err):
	  check stdout and stderr both.

Sat Jan  5 10:21:54 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/modules_and_classes.rdoc:  Added documentation of syntax
	  for Modules and Classes.
	* doc/syntax/methods.rdoc:  Moved some text to the Modules and
	  Classes syntax document.

Sat Jan  5 08:38:27 2013  Eric Hodel  <drbrain@segment7.net>

	* doc/syntax/methods.rdoc:  Added return values and scope sections,
	  slightly modified from the original patch.  Fixes #227 from github by
	  Dave Brown.

Sat Jan  5 08:21:41 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (rb_cloexec_fcntl_dupfd): improve #ifdef condition.
	* io.c (rb_maygvl_fd_fix_cloexec): ditto.

Sat Jan  5 07:54:59 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/commands/cleanup_command.rb:  Clean all possible gems
	  using multiple passes.  Fixes RubyGems bug #422.  Refactored for
	  maintainability.
	* test/rubygems/test_gem_commands_cleanup_command.rb:  Test for above.

Sat Jan  5 05:04:39 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* gc.c (vm_xrealloc): add a few comment why we avoid realloc(ptr,0).

Fri Jan  4 20:17:06 2013  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* Makefile.in (RBCONFIG): Moved from common.mk in order to use the
	  variable in Makefile.in.

	* win32/Makefile.sub (RBCONFIG): Ditto.

Fri Jan  4 19:45:50 2013  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* common.mk (run, parse): Use BTESTRUBY instead of MINIRUBY to handle
	  cross-compiling cases, e.g. NativeClient.

Fri Jan  4 17:58:16 2013  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* common.mk (yes-btest): btest depends on also $(arch)-fake.rb and
	  rbconfig.rb on building for NativeClient.

	* Makefile.in (fake): Avoid generating $(arch)-fake.rb unless cross
	  compiling.

	* configure.in (CROSS_COMPILING): New substitution.

Fri Jan  4 16:26:45 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/doctor.rb:  Process directories in order in case the
	  filesystem doesn't.  [ruby-trunk - Bug #7618]

	  Process specifications before other directories in case of bugs.
	* test/rubygems/test_gem_doctor.rb:  Test for above.

	* lib/rubygems.rb:  Updated version.

	* test/rubygems/test_require.rb:  Fixed double require of
	  benchmark.rb.  RubyGems bug #420.

	* test/rubygems/test_gem_commands_check_command.rb:  Fixed unused
	  variable warnings.
	* test/rubygems/test_gem_commands_query_command.rb:  ditto
	* test/rubygems/test_gem_installer.rb:  ditto

Fri Jan  4 15:05:25 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc/cross_reference.rb:  Fixed matching of C#=== or #===.  RDoc
	  bug #164
	* test/rdoc/test_rdoc_cross_reference.rb:  Test for above.

	* lib/rdoc/parser/changelog.rb:  Fixed parsing of dates.  RDoc bug #165
	* test/rdoc/test_rdoc_parser_changelog.rb:  Test for above.

	* lib/rdoc/parser.rb:  Fixed parsing multibyte files with incomplete
	  characters at byte 1024.  [ruby-trunk - Bug #6393]
	  Fixed handling of -E.  [ruby-trunk - Bug #6392]
	* test/rdoc/test_rdoc_options.rb:  Test for above.
	* test/rdoc/test_rdoc_parser.rb:  ditto.
	* test/rdoc/test_rdoc_parser_c.rb:  ditto.
	* test/rdoc/test_rdoc_parser_changelog.rb:  ditto.
	* test/rdoc/test_rdoc_parser_markdown.rb:  ditto.
	* test/rdoc/test_rdoc_parser_rd.rb:  ditto.
	* test/rdoc/test_rdoc_rdoc.rb:  ditto.

	* lib/rdoc/tom_doc.rb:  Fixed parsing of [] in TomDoc arguments list.
	  RDoc bug #167
	* test/rdoc/test_rdoc_tom_doc.rb:  Test for above.

	* lib/rdoc.rb:  Update version.

Fri Jan  4 11:51:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/forwardable.rb: Fix rdoc parameters for ::def_single_delegator.
	  Patch by Vladimir Andrijevik [Github Fixes #230]

Fri Jan  4 00:35:11 2013  Yuki Yugui Sonoda  <yugui@yugui.jp>

	Fix failures on btest for NativeClient.
	* bootstraptest/runner.rb (nacl?): New method to distinguish NaCl
	  cross build.

	* bootstraptest/test_io.rb: Skip unsupported operations.

	* bootstraptest/test_literal.rb: ditto.

Fri Jan  4 00:29:40 2013  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* io.c (rb_cloexec_fcntl_dupfd): Fix failures in
	  bootstrap_test/test_io.rb.  NativeClient does not support F_DUPFD
	  but supports dup2(2).

Thu Jan  3 17:46:50 2013  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/element.rb (REXML::Elements#add): Remove too much
	  "elements" in document. Sorry...

Thu Jan  3 17:42:32 2013  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/element.rb (REXML::Elements#each): Add missing
	  "elements" in document. [ruby-talk:402713]
	  Reported by Wesley Rishel. Thanks!!!

Thu Jan  3 15:13:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* ext/psych/lib/psych.rb (Psych.load): Return value of
	  Psych::SyntaxError.message should be same as example.
	  Patch by Ippei Obayashi [ruby-core:51193] [Bug #7636]

Thu Jan  3 14:58:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* lib/forwardable.rb (SingleForwardable): Fix example in overview
	  Patch by Vladimir Andrijevik [Github Fixes #231]

Thu Jan  3 14:32:47 2013  Yuki Yugui Sonoda  <yugui@yugui.jp>

	* configure.in (OBJCOPY):  Fixes build error for NativeClient.
	  Avoid disabling OBJCOPY for NativeClient.

	* thread_pthread.c (rb_reserved_fd_p): USE_SLEEPY_TIMER_THREAD is
	  always defined.  Fixes compilation error for NativeClient.

Wed Jan 02 03:09:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* ext/zlib/zlib.c (Zlib::GzipReader): Fix typo by zed_0xff
	  [Fixes Github #229]

Wed Jan 02 02:29:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* hash.c (rb_hash_update): Revert documentation from r38672
	  See: https://github.com/ruby/ruby/pull/228#issuecomment-11791013

Wed Jan 02 02:16:00 2013  Zachary Scott  <zachary@zacharyscott.net>

	* hash.c (rb_hash_update): Documentation for Hash#merge and shallow
	  copies Patch by Yorick Peterse [Fixes Github #228]

Mon Dec 31 15:10:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* vm_backtrace.c: Add documentation for Kernel#caller_locations,
	  Kernel#caller, and Thread::Backtrace::Location

Mon Dec 31 13:05:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* test/ruby/test_backtrace.rb: Add test for r37957 [Feature #7434]

Sun Dec 30 23:33:36 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (simple_re_meta): escaped closing parenthesis has different
	  meaning.  [Bug #7610] [ruby-core:51088]

Sun Dec 30 12:09:47 2012  Charlie Somerville  <charlie@charliesomerville.com>

	* configure.in: use 4 argument form of AC_CHECK_HEADERS to force
	  autoconf to use compiler's result

Sun Dec 30 10:58:04 2012  Kazuki Tsujimoto  <kazuki@callcc.net>

	* test/ruby/test_keyword.rb: add a test for passing hash
	  as a last argument. [ruby-dev:46712] [Bug #7529]

Sun Dec 30 10:51:29 2012  Kazuki Tsujimoto  <kazuki@callcc.net>

	* vm_insnhelper.c: set keyword hash on Proc/block calls.
	  [ruby-core:51172] [Bug #7630]

	* test/ruby/test_keyword.rb: add tests for above.

Sat Dec 29 21:57:11 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/completion.rb: treat rightly completion for symbol on irb
	  [Bug #7632].

Sat Dec 29 21:51:30 2012  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/curses/curses.c (window_cury, window_curx, window_maxy,
	  window_maxx, window_begy, window_begx): use RB_UNUSED_VAR()
	  to suppress unused-but-set-variable warnings.

Sat Dec 29 16:45:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* iseq.c (RubyVM::InstructionSequence): rdoc formatting

Sat Dec 29 15:28:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* iseq.c (RubyVM::InstructionSequence):	Add rdoc for new iseq features
	  added from r38085, this includes ::of, #path, #absolute_path,
	  #label, #base_label, #first_lineno, and #inspect

Sat Dec 29 14:06:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* iseq.c (rb_iseq_line_trace_all, rb_iseq_line_trace_specify): Add
	  rdoc for experimental C level api of iseq, from r38076

Sat Dec 29 11:37:36 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_obj_clone): attach clone to its singleton class during
	  cloning singleton class so that singleton_method_added will be called
	  on it.  based on the patch by shiba (satoshi shiba)[Bug #5283] in
	  [ruby-dev:44477].  [Bug #5283]

Sat Dec 29 10:10:39 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (crt_externs.h): use standard macro AC_CHECK_HEADERS.

Fri Dec 28 23:12:44 2012  Charlie Somerville  <charlie@charliesomerville.com>

	* configure.in: check for the whether crt_externs.h is present when compiling
	  for darwin (this header is missing in the iOS SDK)
	* eval_intern.h: check HAVE_CRT_EXTERNS_H before including crt_externs.h, if
	  not defined, include missing/crt_externs.h instead
	* hash.c: ditto
	* missing/setproctitle.c: ditto
	* missing/crt_externs.h: declare _NSGetEnviron() function and define environ
	  for iOS

Fri Dec 28 21:40:36 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/context.rb: IRB::Context#new: Check from JobManager
	  inside IRB namespace [Bug #7628]. Thanks rafaelfranca for bug
	  report and its patch.

Fri Dec 28 17:06:17 2012  Akinori MUSHA  <knu@iDaemons.org>

	* misc/ruby-electric.el (ruby-electric-curlies): Automatically
	  indent closing curly brackets when
	  ruby-electric-newline-before-closing-bracket is true.

Fri Dec 28 11:50:42 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_yield_setup_block_args): pass single argument to
	  single optional parameter unchanged without splatting.  [Bug #7621]
	  [ruby-dev:46801]

Fri Dec 28 11:17:47 2012  Shugo Maeda  <shugo@ruby-lang.org>

	* proc.c (method_eq): fix the documentation to refer to owner.
	  [ruby-core:51105] [Bug #7613]

	* test/ruby/test_method.rb (test_alias_onwer): new test to confirm
	  that `a == b' returns false if owners of a and b are different.

Fri Dec 28 07:07:43 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* def/id.def: use split(/^/) instead of String#lines to support
	  Ruby 1.8.5 as BASERUBY.

Thu Dec 27 21:56:56 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* variable.c (rb_mod_remove_const): fix segv caused by r38558.

Tue Dec 28 01:13:48 2012  James Edward Gray II  <james@graysoftinc.com>

	* lib/csv.rb: Added more Hash methods to CSV::Row.

Thu Dec 27 23:27:15 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/ruby-lex.rb: make lex_state to EXPR_END when next token
	  is an operator after SYMBEG [Bug #6378].

Thu Dec 27 21:30:21 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/ruby-lex.rb: allow to handle recursive heredocs on
	  irb[Bug #5648].

Thu Dec 27 20:45:29 2012  Masaki Matsushita  <glass.saga@gmail.com>

	* ext/stringio/stringio.c (strio_getline): fix not to raise TypeError
	  when limit is nil.
	  [Bug #7232] [ruby-core:48531]

	* test/stringio/test_stringio.rb: a test for above.

Thu Dec 27 21:08:23 2012  Charlie Somerville  <charlie@charliesomerville.com>

	* vm_core.h (VM_DEFINECLASS_TYPE): explicit cast to enum type to avoid 64->32
	  shorten warning

Thu Dec 27 20:11:29 2012  Masaki Matsushita  <glass.saga@gmail.com>

	* ext/stringio/stringio.c (strio_ungetc): raise IOError instead of RuntimeError
	  if the string is frozen.
	  [Bug #7231] [ruby-core:48530]

	* ext/stringio/stringio.c (strio_ungetbyte): ditto.

	* test/stringio/test_stringio.rb: a test for above.

Wed Dec 26 23:55:18 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/context.rb: fix IRB::Inspector#keys_with_inspector [Bug #7598]

Wed Dec 26 23:26:15 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/context.rb: IRB::Context#use_readline= has been obsolete
	  [Bug #6339].

Wed Dec 26 21:32:46 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/context.rb: make a correct prompt from
	  IRB.conf[:IRB_NAME] on irb [Bug #6338]. Patched by sho-h.

Wed Dec 26 21:09:19 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/ext/math-mode.rb: make not able to change math-mode
	  after irb starting [Bug #6302]. Patched by sho-h.

Wed Dec 26 12:52:36 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/init.rb: change default debug level for
	  irb[ruby-dev:46805], [Bug #6301].

Wed Dec 26 11:54:11 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: enable -fPIE when checking -pie for fixing
	  OpenBSD build error. Patch by George Koehler. Thank you!
	  [Bug #7606] [ruby-core:51082]

Wed Dec 26 07:31:24 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_enc_cr_str_copy_for_substr): empty string is always
	  valid or 7bit.

	* string.c (rb_str_enumerate_lines, rb_str_chop): reduce duplicated
	  code.

	* string.c (rb_str_enumerate_chars): prevent shared copy from GC.

Wed Dec 26 01:31:16 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/init.rb, lib/irb/context.rb: fix conf.debug_level=
	  [Bug #6301] and fix irb command option: -- irb_debug_level for irb.

Wed Dec 26 00:59:18 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/ruby-lex.rb: improve RubyLex performance for large files
	  [Bug #5202]. Patch by ryanmelt.

Tue Dec 25 22:21:06 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/output-method.rb: raise right exception when
	  IRB::OutputMethod#print don't defined [Bug #6657].

Tue Dec 25 22:06:33 2012  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c (rb_threadptr_exec_event_hooks_and_pop_frame):
	  pop a frame before JUMP_TAG() if exception occurred.
	  This change fix bug of Ruby 1.9.
	  [ruby-core:51128] [ruby-trunk - Bug #7624]

	* vm_core.h (EXEC_EVENT_HOOK_AND_POP_FRAME): add to use
	  `rb_threadptr_exec_event_hooks_and_pop_frame()'.

	* vm.c (vm_exec): use EXEC_EVENT_HOOK_AND_POP_FRAME() while
	  exception handling. While exception handling, if an exception
	  is raised in hooks, need to pop current frame and raise this
	  raised exception by hook.

	* test/ruby/test_settracefunc.rb: add a test.

Tue Dec 25 21:08:53 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/init.rb, lib/irb/lc/ja/error.rb, lib/irb/lc/error.rb:
	  raise exception when illegal RC_NAME_GENERATOR defined [Bug #6455].

Tue Dec 25 19:22:17 2012  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/workspace.rb: define method to private on top-level irb
	  [Bug #5776]. Patch by davidbalbert.

Tue Dec 25 19:09:51 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* bignum.c, include/ruby/intern.h (rb_big_eql): exported.

	* thread.c (recursive_check): object_id maybe a Bignum, not Fixnum on
	  LLP64.  see also r38493 and r38548.
	  reported by Heesob Park at [ruby-core:51083] [Bug #7607], and patched
	  by shirosaki at [ruby-core:51095]

Tue Dec 25 18:53:35 2012  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h, eval_intern.h (CHECK_STACK_OVERFLOW): move
	  CHECK_STACK_OVERFLOW() to vm_core.h and rename to
	  CHECK_VM_STACK_OVERFLOW().
	  This change is only move and rename.

	* tool/instruction.rb: catch up above changes.

	* vm.c, vm_insnhelper.c: ditto.

	* vm_insnhelper.c (vm_stackoverflow): add a function to unify
	  raising vm stackoverflow exception.

Tue Dec 25 16:16:54 2012  Koichi Sasada  <ko1@atdot.net>

	* vm_core.h (RUBY_VM_THREAD_VM_STACK_SIZE): change default
	  VM stack size (128 KB or  256 KB -> 512 KB or 1024 KB).
	  This re-sizing corrects smaller value introduced at r38478.
	  Newer value is same VM stack size of Ruby 1.9.
	  [ruby-dev:46797] [ruby-trunk - Bug #7603]

Tue Dec 25 13:38:12 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (compile_err_append, compile_warn_print, warn_print): use
	  rb_write_error_str() instead of writing to rb_stderr directly.

	* io.c (rb_write_error_str): a stopgap measure not to unblock GVL.
	  warning from require seems to still have race condition errors.

Tue Dec 25 00:59:29 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* node.h (NODE_OP_CDECL), compile.c (iseq_compile_each),
	  parse.y (stmt, arg): allow scoped constant op-assignment.
	  [ruby-core:40154] [Bug #5449]

Mon Dec 24 04:56:48 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http/generic_request.rb (Net::HTTPGenericRequest):
	  set content-length to zero on empty post requests
	  by Gregory Ostermayr <gregory.ostermayr@gmail.com>
	  https://github.com/ruby/ruby/pull/201 fix GH-201

Sun Dec 23 19:09:16 2012  Koichi Sasada  <ko1@atdot.net>

	* thread.c: rename methods:
	    from Thread.async_interrupt_timing to Thread.handle_interrupt,
	    from Thread.async_interrupted? to Thread.pending_interrupt?.
	  Also rename option from `defer' to `never'.
	  [ruby-core:51074] [ruby-trunk - Feature #6762]

	* vm_core.c, thread.c: rename functions and data structure
	  `async_errinfo' to `pending_interrupt'.

	* thread.c: add global variables sym_immediate, sym_on_blocking and
	  sym_never.

	* cont.c, process.c, vm.c, signal.c: ditto.

	* lib/sync.rb, lib/thread.rb: catch up this renaming.

	* test/ruby/test_thread.rb: ditto.

Sun Dec 23 17:57:30 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/profiler.rb (Profiler__::PROFILE_PROC, print_profile): store
	  profile data per threads for concurrent-execution.
	  [ruby-core:22046] [Bug #1152]

	* lib/profiler.rb (Profiler__::Wrapper): support calling singleton
	  methods of an instance of BasicObject.

	* lib/profiler.rb (Profiler__::PROFILE_PROC): use TracePoint.

Sun Dec 23 16:13:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* lib/erb.rb: typos for ERB::new link

Sun Dec 23 16:06:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* lib/erb.rb: Document ERB::new trim_mode '-' for lines ending in -%>
	  [ruby-core:51084] [Bug #7608]

Sun Dec 23 15:25:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* lib/irb/ruby-lex.rb: Add handling for %i and %I quoting to irb
	  Patch by flori [ruby-core:49550] [Bug #7392] [Github Issue #157]

Sun Dec 23 15:05:48 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (rb_check_funcall_with_hook): rb_check_funcall with hook
	  which is called before calling method_missing or target method.

	* marshal.c (w_object, r_object0): use rb_check_funcall_with_hook
	  instead of respond_to? and call.

Sun Dec 23 14:52:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* re.c (rb_reg_eqq): doc: #=== is not a synonym for #=~, added example
	  [ruby-dev:46746] [Bug #7571]

Sun Dec 23 14:35:13 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (BLOCKING_REGION): if fail_if_interrupted is false ignore
	  the result of blocking_region_begin(), since it always is true in
	  that case.  suppress "uninitialized" warnings.

Sun Dec 23 09:34:07 2012  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/commands/check_command.rb:  Added --doctor and --dry-run
	  options to clean up after failed uninstallation.
	* test/rubygems/test_gem_commands_check_command.rb:  Test for above.

	* lib/rubygems/commands/push_command.rb:  Allow pushes from RubyGems
	  2.0.0.preview3

	* lib/rubygems/commands/update_command.rb:  Use Gem.ruby_version

	* lib/rubygems/dependency.rb:  Update style.

	* lib/rubygems/installer.rb:  Ensure installed gem specifications will
	  be useable.  Refactor.
	* test/rubygems/test_gem_installer.rb:  ditto.

	* lib/rubygems/validator.rb:  Fixed bug with unreadable files.

	* lib/rubygems.rb:  Fixed broken methods.
	* test/rubygems/test_gem.rb:  Test for above.

	* test/rubygems/test_gem_commands_push_command.rb:  Fixed overridden
	  Gem.latest_rubygems_version

Sun Dec 23 01:52:01 2012  Akinori MUSHA  <knu@iDaemons.org>

	* io.c (rb_io_lines, rb_io_bytes, rb_io_chars, rb_io_codepoints):
	  Deprecate IO#{lines,bytes,chars,codepoints} and those of ARGF.
	  [Feature #6670]

	* ext/stringio/stringio.c (strio_lines, strio_bytes, strio_chars)
	  (strio_codepoints): Deprecate
	  StringIO#{lines,bytes,chars,codepoints}. [Feature #6670]

	* ext/zlib/zlib.c (rb_gzreader_lines, rb_gzreader_bytes):
	  Deprecate Zlib::GzipReader#{lines,bytes}. [Feature #6670]

Sat Dec 23 01:35:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* lib/optparse.rb: Documentation for OptionParser to remove 'shadowed
	  outer local variable' from example and make obvious ARGV with
	  non-option arguments.
	  Patch by Marcus Stollsteimer [ruby-core:47460] [Bug #6997]

Sat Dec 23 00:08:00 2012  Kenta Murata  <mrkn@mrkn.jp>

	* include/ruby/intern.h: add the prototype declaration of
	  rb_num_coerce_bit.

	* numeric.c (rb_num_coerce_bit): the new coerce function for bitwise
	  binary operation.

	* bignum.c (rb_big_and): use coerce to convert the argument, which isn't
	  a Fixnum nor a Bignum, to the corresponding Integer object so that
	  bitwise operations can support Integer-mimic objects.
	  [Bug #1792] [ruby-core:39491]

	* bignum.c (rb_big_or): ditto.

	* bignum.c (rb_big_xor): ditto.

	* numeric.c (bit_coerce): ditto.

	* numeric.c (fix_and): ditto.

	* numeric.c (fix_or): ditto.

	* numeric.c (fix_xor): ditto.

	* test/ruby/test_integer.rb: add tests for the above changes.

	* test/ruby/test_bignum.rb: ditto.

Sun Dec 23 00:04:54 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* internal.h (QUOTE, QUOTE_ID): quote unprintable chars in strings and
	  IDs. [Bug #7574] [ruby-dev:46749]

	* string.c (rb_str_quote_unprintable): ditto.

Sat Dec 22 23:59:18 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (rb_compile_error, rb_compile_warn, rb_compile_warning),
	  (rb_warn, rb_warning): support PRIsVALUE.

Sat Dec 22 22:04:58 2012  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* cont.c (rb_fiber_start): unify conditions.

Sat Dec 22 21:47:55 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (rb_io_wait_writable): use rb_thread_check_ints() instead
	  of rb_thread_fd_writable().
	* io.c (rb_io_wait_readable): ditto.

Sat Dec 22 20:31:10 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_mod_const_get): symbol cannot be nested constant name.

Sat Dec 22 19:26:35 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* object.c (rb_mod_const_get): check more strictly.  [ruby-dev:46748]
	  [Bug #7573]

Wed Dec 19 02:34:48 2012  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* cont.c (rb_fiber_start): in case of jump with TAG_FATAL,
	  enqueue error into async_errinfo_queue, because you cannot call
	  TH_TAG_JUMP() in this function. [ruby-dev:45218]  [Bug #5993]

	* thread.c (rb_threadptr_execute_interrupts): now INT2FIX(TAG_FATAL)
	  can be popped from async_errinfo_queue.

	* vm.c (rb_vm_make_jump_tag_but_local_jump): revert r38441.
	  rb_vm_make_jump_tag_but_local_jump() shouldn't return exception
	  in case of state == TAG_FATAL.

	* test/ruby/test_fiber.rb (test_exit_in_fiber): fix a test to illuminate
	  Thread.exit should terminate current Thread.

Sat Dec 22 13:15:08 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* gc.c (obj_id_to_ref): add a macro to treat Bignum object id.
	  This follows the change r38493.

	* gc.c (id2ref): fix for working fine with Bignum object id on x64
	  Windows.
	* gc.c (wmap_finalize): ditto.

Sat Dec 22 11:30:21 2012  Masaki Matsushita  <glass.saga@gmail.com>

	* struct.c (make_struct): remove junk ID check to allow members who
	  have junk name like "foo\000".
	* test/ruby/test_struct.rb: Test for above.
	  [Bug #7575] [ruby-dev:46750]

Sat Dec 22 05:34:54 2012  Eric Hodel  <drbrain@segment7.net>

	* lib/net/http.rb:  Requests may be created with a URI which sets the
	  Host header.  Responses contain the requested URI for easier redirect
	  following.  [ruby-trunk - Feature #6482]
	* lib/net/http/generic_request.rb:  ditto.
	* lib/net/http/response.rb:  ditto.
	* NEWS (net/http):  Updated for above.
	* test/net/http/test_http.rb:  Tests for above.
	* test/net/http/test_http.rb:  ditto.
	* test/net/http/test_httpresponse.rb:  ditto.

Sat Dec 22 02:35:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* lib/irb/slex.rb(#match): Typo, should be D_DETAIL
	  [ruby-core:51071] [Bug#7600]

Sat Dec 22 02:29:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* lib/irb/input-method.rb, lib/irb.rb: Typo in
	  InputMethod#readable_atfer_eof? to #readable_after_eof?
	  [ruby-core:51069] [Bug #7599]

Sat Dec 22 02:19:38 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm_dump.c (rb_vm_bugreport): revert r38533.
	* addr2line.c (fill_lines): add ELF sanity check.
	  [Bug #7597] [ruby-dev:46786]

Sat Dec 22 02:05:00 2012  Zachary Scott  <zachary@zacharyscott.net>

	* lib/irb/inspector.rb, lib/irb/context.rb: Move IRB::INSPECTORS and
	  class methods to IRB::Inspector [ruby-core:51067][Bug #7598]

Sat Dec 22 00:28:46 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* object.c (rb_obj_hash): shouldn't assume object_id can be long.
	  based on a patch by Heesob Park at [ruby-core:51060].
	  cf. [Backport #7454]

Fri Dec 21 23:15:25 2012  Kouhei Sutou  <kou@cozmixng.org>

	* ext/fiddle/lib/fiddle/struct.rb (Fiddle::CStructEntity#set_ctypes):
	  CPtr -> Pointer.
	* test/fiddle/test_c_struct_entry.rb
	  (Fiddle::TestCStructEntity#test_aref_pointer):
	  Added the test for the above.

Fri Dec 21 23:12:05 2012  Kouhei Sutou  <kou@cozmixng.org>

	* ext/fiddle/lib/fiddle/struct.rb (Fiddle::CStructEntity#set_ctypes):
	  CPtr -> Pointer.
	* test/fiddle/test_c_struct_entry.rb
	  (Fiddle::TestCStructEntity#test_aref_pointer_array):
	  Added the test for the above.

Fri Dec 21 22:43:36 2012  Kouhei Sutou  <kou@cozmixng.org>

	* ext/fiddle/lib/fiddle/import.rb (Fiddle::Importer#sizeof):
	  CPtr -> Pointer.
	* test/fiddle/test_import.rb (Fiddle::TestImport#test_sizeof):
	  Added the test for the above.

Fri Dec 21 22:34:17 2012  Koichi Sasada  <ko1@atdot.net>

	* test/ruby/test_iseq.rb: disable a test which checks features
	  removed at r38532.

Fri Dec 21 22:02:00 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/{dir.h,win32.c} (rb_w32_readdir): removed old rb_w32_readdir()
	  and renamed from rb_w32_readdir_with_enc().
	  [ruby-core:24864] [Feature #1927]

	* dir.c (READDIR): follow above change.

Fri Dec 21 21:12:54 2012  Masaya Tarui  <tarui@ruby-lang.org>

	* vm_dump.c (rb_vm_bugreport): commentout addr2line call temporarily
	  in order to avoid segv. anyone can fix addr2line?
	  [Bug #7597] [ruby-dev:46786]

Fri Dec 21 20:38:28 2012  Koichi Sasada  <ko1@atdot.net>

	* iseq.c (Init_ISeq): remove definition of the following methods:
	  ISeq#line_trace_all and ISeq#line_trace_specify because they are
	  half baked.
	  C APIs are remained as experimental. These functions will be
	  renamed, removed their parameters may be changed.
	  You can use these methods by C exts. Please give us your comments.

Fri Dec 21 20:21:04 2012  Koichi Sasada  <ko1@atdot.net>

	* vm_trace.c (tracepoint_new): add code to support specified thread.
	  But not tested and this feature is not supported officially.

Fri Dec 21 19:37:15 2012  Koichi Sasada  <ko1@atdot.net>

